Version 2.2.049
    Combat abilities work with spear in off-hand again (see notes)
    Sweet berry bushes now work with Herbalism (thanks dnocturne)
    (Codebase) Fixed unit tests for Java 25 (thanks Warriorrrr)
    Fixed copper items not giving XP for Repair (thanks Remski01)
    Fixed edge case where mcMMO could drop items with stack size set outside normal bounds

    NOTES:
    As a semi-permanent work around, mcMMO keeps track of when players swing their weapon, if they have swung it recently enough combat skills will work even if you have a spear in your off-hand.
    Prior to this patch, mcMMO disabled combat abilities when spear was in off-hand to prevent the off-hand spear charge from applying combat abilities from other skills, as mcMMO was unable to determine which item (mainhand vs offhand) caused the damage from the event information alone.
Version 2.2.048
    Fixed error when loading Spears skill manager on older Minecraft versions
    Fixed error when using /spears command on an older Minecraft version

Version 2.2.047
    Fix bug where off-hand spears damage could be attributed to various combat skills and trigger their abilities

    NOTE:
    Sorry guys, noticed this right after pushing 2.2.046, for now melee combat skills won't trigger if you have a spear in your off-hand as a temporary work around to mcMMO being unable to differentiate between main hand and off hand damage.
    I'm working on a more robust solution to this issue, so stay tuned.
    What this means in laymen's terms is if you are using a sword main hand, and you have a spear off hand, mcMMO has temporarily disabled your main hand abilities from triggering to avoid issues where off hand spear damage benefits from it and triggers abilities belonging to other weapons.

Version 2.2.046
    Added Spears combat skill
    Added Spears to repair.vanilla.yml and salvage.vanilla.yml (see notes)
    Added various permissions related to Spears
    Added /spears skill command
    Added Nautilus to taming XP in experience.yml
    Added Camel_Husk to taming XP in experience.yml
    Added Camel_Husk to combat XP in experience.yml
    Added Parched to combat XP in experience.yml
    Fixed bug where converting from SQL to FlatFile would not copy data for tridents, crossbows, maces, or spears
    (Codebase) Added docker-based unit tests for SQL databases (see notes)
    (Codebase) Large refactor to both SQLDatabaseManager and FlatFileDatabaseManager
    (Codebase) Database related errors are now more descriptive and have had their logging improved

    NOTES:
    This update had a lot of changes behind the scenes, please report any bugs you find to our GitHub issues page!
    You will need to manually update repair.vanilla.yml and salvage.vanilla.yml to get support for Spears, or...
    If you want to update salvage/repair configs the easy way, you simply can delete these config files to have mcMMO regenerate them with the new entries.
    If you don't want to delete them, you can find the default values for these config files in the defaults folder at plugins\mcMMO\defaults after running this mcMMO update at least once.
    You can use this default file to copy paste if you please.
    Docker is ONLY required for developers compiling mcMMO from source code and ONLY for running SQL-related unit tests.
    mcMMO itself does NOT require Docker to run, and servers using prebuilt releases are completely unaffected.
    New SQL database unit tests use Testcontainers to spin up temporary MySQL/MariaDB instances for testing purposes.
    These containers are created at test time and are never used at runtime.
    If you compile mcMMO locally and do not have Docker installed, SQL-related unit tests may fail.
    In this case, you can safely compile with -DskipTests to skip unit tests entirely.
    Skipping tests has no impact on mcMMO functionality when running on a server.
    Known Issues:
    I ran into an issue where having a spear in the offhand while the main hand is empty causes attacks to be incorrectly classified as unarmed. This allows unarmed abilities to apply to spear damage. As a temporary measure, I’ve disabled unarmed skills from applying to combat when a spear is equipped in the offhand while I investigate a more robust solution.

Version 2.2.045
    Green Thumb now replants some crops it was failing to replant before (see notes)
    Green Thumb now replants harvested plants faster
    Fixed an error that could happen when replanting crops with Green Thumb
    Fixed a bug where salvage.vanilla.yml was readding deleted entries on server restart
    Fixed a bug where repair.vanilla.yml was readding deleted entries on server restart
    Added missing permission node 'mcmmo.ability.repair.copperrepair'
    Added missing permission node 'mcmmo.ability.salvage.coppersalvage'

    NOTES:
    The delay from a plant being replanted from Green Thumb is intentional, and while looking into bugs it seemed maybe a tad slow, so I sped it up a bit.
    Green Thumb still won't replant some stuff such as sugar canes, cacti, those are handled a bit differently, but I could add support for it in an upcoming patch if requested.

Version 2.2.044
    Fixed copper armor and tools not working with Repair or Salvage

Version 2.2.043
    Added support for the new copper tools and armor added in Minecraft 1.21.9
    Added many missing buttons, trapdoors, doors, fence gates, etc to the ability/tool blacklists (see notes)
    Added copper tools and armor to repair.vanilla.yml (see notes)
    Added copper tools and armor to salvage.vanilla.yml (see notes)
    Added copper tools and armor to fishing_treasures.yml (see notes)
    Added Copper_Nugget to treasures.yml (see notes)
    Added Copper_Nugget to experience.yml for Smelting XP
    Added Copper_Golem to experience.yml for Combat XP
    Fixed mcMMO custom potions not having their name set correctly (see notes)
    Fixed ExploitFix.PreventArmorStandInteraction in experience.yml not being respected
    Added ExploitFix.PreventMannequinInteraction to experience.yml to prevent mannequins from granting XP or other effects
    Fixed bug where Armor Stands would get renamed to heart symbols upon breaking them (see notes)
    Tweaked potions loaded msg during mcMMO startup to not include potions requiring newer game versions from being included in the total.

    NOTES:
    You don't need to update your experience.yml, that one updates automatically when you run mcMMO after an update.
    You will need to manually update the following files manually repair.vanilla.yml, salvage.vanilla.yml, treasures.yml, and fishing_treasures.yml files to get support for copper tools and armor.
    You can find the default config files in the defaults folder at plugins\mcMMO\defaults after running this mcMMO update at least once.
    You can use this default file to copy paste if you please
    OR if you haven't customizes these config files, simply delete them to have mcMMO regenerate them with the new entries.
    mcMMO has an internal blacklist of blocks that abilities and tools won't activate or "ready" on, pretty much anything that is interactable should go on this list, and I performed an audit and there were quite a few missing entries, so I've added them in this update, what this means is you won't click on a button and have it ready your tool anymore, as it should have been doing.
    Mannequins are treated the same way armor stands are treated, the default behavior is mcMMO won't process on them unless you turn on the setting under ExploitFix in experience.yml, in addition to this their default XP is set to 0.0
    mcMMO had a setting 'ExploitFix.PreventArmorStandInteraction' to allow mcMMO to process abilities and XP on armor stands, but it was never hooked up! I fixed that mistake in this update.
    The fix for potion names will only apply to newly created potions.
    Armor stands that had already been renamed from the heart symbol bug will keep their names, but the bug shouldn't happen anymore

Version 2.2.042
    mcMMO now listens to BlockDropItemEvent at LOW priority instead of HIGHEST
    Bonus drops from mcMMO now simply modify quantity in BlockDropItemEvent instead of spawning new ItemStacks.
    Added McMMOModifyBlockDropItemEvent event, this event is called when mcMMO modifies the quantity of an ItemStack during a BlockDropItemEvent, it is modifiable and cancellable.
    You can now define custom sounds to be played in sounds.yml (Thank you JeBobs, see notes)
    Added a cap to how much Blast Mining PVP damage can do to other players

    Notes:
    The new sounds.yml config file allows you to override the sounds played by mcMMO.
    Simply define the ID of the sound you want to play for each sound.
    For example, add an entry for Sounds.TOOL_READY.CustomSoundId into sounds.yml to override the sound played when a tool is "readied".
    If you are on older versions (1.18, 1.19, etc), instead of registering an ID, you specify the Sound enum.
    Those who are on newer versions, can define the ID of any sound registered with Paper/Spigot, this allows you to even play custom sounds so long as they are properly loaded on the server.
    Vanilla minecraft sounds tend to have IDs like "minecraft:ui.toast.challenge_complete", you can google what these keys are.

Version 2.2.041
    Fixed Berserk failing to crack blocks
    Added 'Skills.Unarmed.Block_Cracker.Allow_Block_Cracker' to config.yml
    Removed 'SmoothBrick_To_CrackedBrick', it has been replaced by `Allow_Block_Cracker`
    Block Cracker can now crack deepslate bricks, deepslate tiles, polished blackstone bricks, and netherbricks
    Optimizations for Hoppers & Alchemy (thanks Warriorrrr)
    Fixed buckets being consumed by furnaces (thanks RunqRun)
    Fixed Repair stripping unsafe enchantments from items (thanks Techirion)
    Fixed IronGolem causing cast exceptions in rare cases (thanks Techirion)

Version 2.2.040
    Fixed hover component and action bar messages not working for 1.21.6 and 1.21.7
    Fixed bug where entries of mctop could be duplicated when using FlatFile
    Fixed bug where a party leader could leave a party and the party would be left without a party leader
    Fixed a bug where EcoEnchants and similar plugins could cause an infinite loop within mcMMO during TreeFeller and other abilities
    Added 'Happy_Ghast' to experience.yml for combat XP
    Added 'Ghastling' to experience.yml for combat XP
    Updated Japanese (ja_JP) translation (Thanks ryota-abe)
    Updated Simplified Chinese (zh_CN) locale (Thanks GhostDC)

Version 2.2.039
    Added StackOverflow safeguards for abilities dealing damage in mcMMO
    Improved compatibility with MythicMobs/ModelEngine
    Improved compatibility with AdvancedEnchantments

Version 2.2.038
    Fix potion match failing for non-english locales
    FoliaLib Performance improvements (thanks SirSalad)
    Fixed situations where Rupture could never end which affected server performance

Version 2.2.037
    Fixed bug where Alchemy was not matching potions correctly and producing incorrect results (Thanks TheBentoBox)

Version 2.2.036
    Fixed a bug where Chimaera Wing could cause an exception when used
    Fixed bug where Mob Spawners could drop in Blast Mining (thanks TomBock)
    Fixed Spectral Arrows not granting XP for Archery or Crossbows (thanks broccolai)
    Fixed bug where Trickshot arrows would lose their potion or custom effects
    Added locale strings for /mcmmo help command (thanks Griffeng)

Version 2.2.035
    Support for new additions from Minecraft 1.21.5
    Fixed bug where Blast Mining would not drop deep slate
    Swords subskill Stab is now configurable in advanced.yml
    Added 'Skills.Swords.Stab.Base_Damage' to advanced.yml
    Added 'Skills.Swords.Stab.Per_Rank_Multiplier' to advanced.yml
    Added 'Bush' to experience.yml for Herbalism
    Added 'Bush' to config.yml Bonus Drops for Herbalism
    Added 'Cactus_Flower' to experience.yml for Herbalism
    Added 'Cactus_Flower' to config.yml Bonus Drops for Herbalism
    Added 'Firefly_Bush' to experience.yml for Herbalism
    Added 'Firefly_Bush' to config.yml Bonus Drops for Herbalism
    Added 'Leaf_Litter' to experience.yml for Herbalism
    Added 'Leaf_Litter' to config.yml Bonus Drops for Herbalism
    Added 'Short_Dry_Grass' to experience.yml for Herbalism
    Added 'Short_Dry_Grass' to config.yml Bonus Drops for Herbalism
    Added 'Tall_Dry_Grass' to experience.yml for Herbalism
    Added 'Tall_Dry_Grass' to config.yml Bonus Drops for Herbalism
    Added 'Wildflowers' to experience.yml for Herbalism
    Added 'Wildflowers' to config.yml Bonus Drops for Herbalism


    NOTES:
    The mob variants will use the "base" mob definition for values for now, such a a warm chicken using chicken values from experience.yml
    The new config settings will be added automatically to advanced.yml

Version 2.2.034
    Fixed bug where mcMMO would drop items in such a way that they get stuck in an adjacent block and float to the surface
    Fixed a rare edge case where null entities during chunk unload would cause a NullPointerException and potentially lead to server instability
    Fixed bug where arrow would award archery xp after a crossbow trickshot bounce

Version 2.2.033
    Added Breeze_Rod entries to potions.yml for Awkward potion (see notes)
    Added missing TURTLE_HELMET entry to potions.yml for Tier 1 ingredients
    Added missing Wind Charging potion entries to potions.yml (see notes)
    Fixed bug where mcMMO would attempt to load potions that required ingredients or effects from newer versions of Minecraft
    mcMMO is a little more specific during start up of how many potions it loaded, it will now report on incompatible potions from being on an older game version.

    NOTES:
    You will have to update your potions.yml manually to receive these changes, it is highly recommended that if you haven't customized this file that you simply just delete it, mcMMO will generate a new one on the next start up and it will contain all the missing entries.
    If you have customized this file, you can find the "default" version of this file here on the mcMMO github repo: https://github.com/mcMMO-Dev/mcMMO/blob/master/src/main/resources/potions.yml
    You can use this file to compare it to your own and make the manual changes needed to get the new entries.
    After making the changes to potions.yml (either via deleting it or not...) mcMMO should now recognize the Wind Charging potion and the Awkward potion created from Breeze Rods

Version 2.2.032
    Fixed bug where Roll would throw exceptions with certain CMI interactions
    Blast Mining no longer drops infested block variants
    Reduced bonus drops on Blast Mining and randomized results (see notes)
    Added Beetroot to experience.yml for Herbalism
    Added Open_Eyeblossom to experience.yml for Herbalism
    Addeed Open_Eyeblossom to config.yml Bonus Drops for Herbalism
    Added Closed_Eyeblossom to experience.yml for Herbalism
    Addeed Closed_Eyeblossom to config.yml Bonus Drops for Herbalism

    NOTES:
    A balance pass for Blast Mining is coming, but for now, I've reduced the total bonus drops and clamped the yield ceiling as Blast Mining is a bit too good.

Version 2.2.031
    Fixed potential NPE when player or blockstate is null for Inventory events on Furnaces
    Fixed bug where en_us locale was being set system-wide (thanks BlvckBytes)
    Fixed bug where Decimal format would throw exception on non en_us systems (thanks BlvckBytes)
    (API) Added McMMOPlayerTameEntityEvent event (thanks Warriorrr)

Version 2.2.030
    Fixed bug where rupture task could cause an exception (Thanks Wariorrrr)
    Fixed bug where Smelting permission was needed for Alchemy XP gain
    Fixed material based salvage permissions not functioning (Thanks Momshroom)

Version 2.2.029
    Fixed bug where block checks at world height would throw IndexOutOfBounds exceptions
    Added Eyeblossom to experience.yml for Herbalism xp
    Added Bonus_Drops.Herbalism.Eyeblossom to config.yml to enable double/triple drops for Eyeblossom
    Added Pale_Hanging_Moss to experience.yml for Herbalism xp
    Added Pale_Moss_Block to experience.yml for Herbalism xp
    Added Pale_Moss_Carpet to experience.yml for Herbalism xp
    Added Pale_Oak_Log to experience.yml for Woodcutting xp
    Added Pale_Oak_Wood to experience.yml for Woodcutting xp
    Added Stripped_Pale_Oak_Log to experience.yml for Woodcutting xp
    Added Stripped_Pale_Oak_Wood to experience.yml for Woodcutting xp
    Added Bonus_Drops.Woodcutting.Pale_Oak_Wood to config.yml to enable double/triple drops for Pale Oak Wood
    Added Bonus_Drops.Woodcutting.Pale_Oak_Log to config.yml to enable double/triple drops for Pale Oak Log
    Temporarily disabled the party item share functionality until it is fixed or potentially removed (see notes)

    Notes:
    This update adds support for the new stuff added by the "The Garden Awakens" Minecraft Update
    I noticed some issues with the party item share feature, so I've temporarily disabled it until those issues are addressed.
    I'm not even sure people like or dislike this feature, I'm personally not a fan.. I'd like to hear what you guys think.

Version 2.2.028
    Fixed stack overflow during ChunkUnloadEvent
    Fixed a bug where you had to wait to summon another COTW summon if one or more of them had died or otherwise expired before their time limit
    McMMOItemSpawnEvent#setItemStack being ignored (thanks galacticwarrior9)
    (API) Added McMMOPlayerMasterAnglerEvent (thanks bobcat4848)

Version 2.2.027
    Added Tridents / Crossbows to salvage.vanilla.yml config (see notes)
    Fixed an issue where Folia could have all of its threads lock up effectively killing the server
    Fixed concurrency issue with Folia regarding locale strings
    Fixed concurrency issue with Folia regarding COTW summons
    Updated 'Salvage.SubSkill.ScrapCollector.Stat' to no longer mention luck being involved
    The amount of materials from salvage are no longer luck-based, you will get a deterministic amount based on damage to the item.
    Fixed Ricocheted arrows losing some data after a ricochet
    Changed color of locale strings for 'Repair.Listener.Anvil' to be easier to read
    Changed color of locale strings for 'Salvage.Listener.Anvil' to be easier to read

    NOTES:
    Tridents and Crossbows are now in the salvage.vanilla.yml config, you will need to either delete this config file to regenerate it or add the entries manually.
    You can check the default config file after running this mcMMO update at least once in the defaults folder at plugins\mcMMO\defaults to see what you would need to add if you want to take the manual approach

Version 2.2.026
    Fixed NullPointerException on ChunkUnloadEvent

Version 2.2.025
    Fixed NullPointerException spam when processing XP for child skills

Version 2.2.024
    Fixed errors when Fishing or using Shake ability
    Significant optimizations made to reading new chunks for mcMMO
    Significant optimizations to most block interactions in mcMMO code
    Fixed a horrendous edge case where Tree Feller could cause a lot of lag

    Notes:
    Part of this update focused on optimization, there's improvements of around 30% in CPU time for most code involving block interactions in mcMMO, which happens to be most code in mcMMO.
    One of the optimizations made in this update removes an edge case where Tree Feller could cause a lot of lag, but the optimizations really are across the board in regards to any abilities that interact with blocks.

Version 2.2.023
    Compatibility with Minecraft 1.21.3
    (API) add causingPlayer to McMMOReplaceVanillaTreasureEvent and update Fish Event to use it (thanks bobcat4848 and Jacob Cuomo)

    Notes:
    Tested this version of mcMMO against 1.21.3, 1.21.1, and 1.19.4, which should be full coverage for all the changes, but it is possible you will run into things I didn't catch.
    Please report any errors or bugs to GitHub if you find them.

Version 2.2.022
    Fixed a bug where Roll was always reducing damage (thanks Ineusia)
    Fix COTW errors on older versions (thanks Warriorrrr)
    Fixed slimes spawning from slime division not inheriting tags. (thanks Ineusia)

Version 2.2.021
    Fixed issue where Roll wasn't reducing as much damage as it should have been (thanks Ineusia)
    Updated locale_es (thanks Devilcasters)
    Updated locale_lt_LT (thanks tautuxs)

Version 2.2.020
    (Codebase) Reworked Roll implementation (See notes)
    (Codebase) Added unit test coverage for Roll
    Fixed Alchemy error spam in mcMMO potion matching logic (see notes)
    Fixed Alchemy NPE when brewing finishes
    Fixed a bug where Roll was modifying damage unnecessarily
    Fixed blast mining trying to drop non-items (thanks IAISI)

    NOTES:
    I'll need to rework Alchemy config logic a bit further to address some issues I've found, for now mcMMO will ignore harmless matching errors in the potion matching logic.
    The code for Roll was a bit of a mess, I've rewritten a good chunk of it and added some unit test coverage.
    I will likely put out another update for Acrobatics in general, as the code for Acrobatics is whack.
    This would be a good time to suggest changes to Acrobatics on discord.

Version 2.2.019
    Optimized Alchemy code (thanks MrPowerGamerBR)
    Fixed an exception that could occur when shooting entities through worlds (thanks Wariorrrr)
    Fixes to en_US locale (thanks BlockMasters617)
    Maces, Crossbows, and Tridents skill commands don't warn you that they are work in progress anymore.
    Fixed IllegalArgumentException when Rupture would trigger on an entity with illegal state

    NOTES:
    Maces, Crossbows, and Tridents are still in development, the change to remove the message from the skill command was to reduce the visual noise.

Version 2.2.018
    Fixed a probability bug where certain skills would max out in chance to succeed well before they were supposed to (such as Dodge)
    Blast Mining will no longer drop mob spawners (see notes)
    (Codebase) Added more unit tests for Probability and RNG
    The Herbalism XP gained when breaking certain plants that can grow unnaturally tall vertically (bamboo, kelp) is now capped to the most it could give when naturally grown, this can be disabled in experience.yml
    Added 'ExploitFix.LimitTallPlantFarming' to experience.yml

    NOTES:
    This probability bug was a big oopsie and showed a gap in unit test coverage, I've added that coverage and a bug like this in theory shouldn't happen again.
    In a future version I will add configuration for admins to control what blocks are not allowed to be dropped by blast mining.
    A setting has been added to disable player-created super tall plants from giving full XP, this is on by default, you can tun it off in experience.yml via 'ExploitFix.LimitTallPlantFarming'
Version 2.2.017
    Fixed a bug with default Mace permissions (thanks SrBedrock)
    Fixed Blast Mining being almost completely broken
    Reworked Blast Mining to drop non-mining related blocks too
    Reworked Blast Mining to use your pickaxe when determining drops (will apply Silk Touch)
    Fixed shift-clicking ingredients into the brewing stand not working on older versions of Minecraft
    Added a setting in advanced.yml to ignore attack cooldowns (see notes)
    Updated zh_CN locale (thanks libook)
    Updated pt_BR locale (thanks JesusRuescas)
    Updated fr locale (thanks Ted-18)

    NOTES:
    If Mace skills weren't working for your players before and you were scratching your head wondering why, this should fix it (thanks SrBedrock).
    Skills.General.Attack_Cooldown.Adjust_Skills_For_Attack_Cooldown is a new setting in advanced.yml that will allow you to ignore attack cooldowns for the combat skills.
    When a player spams an attack, they have a reduced amount of bonus damage from mcMMO and reduced chance for chance-on-hit subskills to activate.
    You can have mcMMO ignore this value and apply full bonus damage and full chance to proc abilities by setting this to false.

Version 2.2.016
    (SQL) Fixed a bug where skill cooldowns were being loaded for players incorrectly

Version 2.2.015
    Added Maces skill
    Added Mace to repair.vanilla.yml (see notes)
    Fixed a bug where spamming attacks would still apply full bonus dmg and full chance to proc abilities (see notes)
    Fixed some misc missing permissions for crossbows/tridents

    NOTES:
    You shouldn't need to update repair.vanilla.yml, it should update automatically
    Maces is a new skill that is in early development, feedback is appreciated.
    Some ideas I had for the Maces are on hold as they are lacking proper API from Spigot.
    This is mostly pertaining to smash attacks, I had some ideas for enhancing them but without the proper API I will hold off for now.
    While working on Maces, I noticed a bug where spamming attacks would still apply full bonus damage and full chance to proc abilities, this has been fixed.
    When you swing your weapon in Minecraft, you gain an "Attack Strength" value, which is relative to your cooldown, mcMMO was supposed to be making use of this value, but at some point in the past this was broken.
    I have fixed this and now mcMMO will use the attack strength value to determine the bonus damage and chance to proc abilities.
    For servers modifying Minecraft combat to not have this "cooldown", mcMMO should behave as you would expect, with full damage and full chance to proc abilities even when spamming attacks.

Version 2.2.014
    Fixed a bug where Luck Of The Sea was being applied for Super Breaker (and other abilities)

Version 2.2.013
    Added Breeze to experience.yml
    Added Bogged to experience.yml
    (Locale) Updates to zh_TW (thanks chunkiuu)
    (Locale) Updates to zh_CN (thanks haha44444)
    Modified the RNG for dropping non-ore blocks from Blast Mining to yield about 50% of what was destroyed
    (API) Deprecated com.gmail.nossr50.mcMMO.getPlaceStore
    (API) Added com.gmail.nossr50.mcMMO.getUserBlockTracker
    (API) Added com.gmail.nossr50.mcMMO.getChunkManager
    (API) Added new methods to com.gmail.nossr50.util.blockmeta.UserBlockTracker for easier readability
    (API) Deprecated many poorly named methods in UserBlockTracker (see notes)
    (Codebase) Cleaned up and organized unit tests relating to UserBlockTracker
    Added missing entries for Tridents/Xbows/Maces to config.yml (see notes)

    NOTES:
    Some settings such as Hardcore.Death_Stat_Loss.Enabled were missing entries for the new skills, I have added them to the default config.
    Missing entries does not mean these things wouldn't work without them present, as default values will be used when config entries are not present.
    These missing entries should be added to your config upon start up with this update.
    Regarding the API changes, not planning to delete the deprecated methods in UserBlockTracker anytime soon, as nothing has really changed other than the names.
    For anyone consuming mcMMO API, I would still recommend switching off these deprecated methods as soon as you can, just for future-proofing.

Version 2.2.012
    Fixed a bug where Daze would cause an exception in older game versions (1.20.4 and older)

Version 2.2.011
    Fixed bug where some potions on older versions (1.20.4 and older) were not brewable (night vision extended, etc)
    Improved logging for Alchemy potion look up (see notes)

NOTES:
    Added detailed logging when multiple configured potions match an ItemStack.
    This will help identify issues with potion configuration.

Version 2.2.010
    Fixed being unable to load REGEN potion type on new versions of Paper/Spigot 1.20.6
    Fixed some potions not gaining XP when brewed (Level 2 potions, etc)
    BrewingStands will now remember who owns them, this persists across restarts (see notes)
    Fixed rare NPE in mcMMO events when player data was unable to be retrieved
    Fixed a NPE that could happen when damaging armor with Axes
    Fixed a bug where Alchemy brewing would be cancelled if the player died
    (API) Added getMcMMOPlayer() to McMMOPlayerSkillEvent
    (API) Added new ctor McMMOPlayerSkillEvent(@NotNull McMMOPlayer mmoPlayer, @NotNull PrimarySkillType primarySkillType)
    (API) Deprecated ctor McMMOPlayerSkillEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Added ctor McMMOPlayerAbilityEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Deprecated ctor McMMOPlayerAbilityEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Deprecated ctor McMMOPlayerAbilityActivateEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Added ctor McMMOPlayerAbilityActivateEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Deprecated ctor McMMOPlayerCatalysisEvent(org.bukkit.entity.Player, double)
    (API) Added ctor McMMOPlayerCatalysisEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, double)
    (API) Deprecated util method EventUtils.callPlayerAbilityActivateEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Added util method EventUtils.callPlayerAbilityActivateEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Deprecated ctor McMMOPlayerFishingEvent(org.bukkit.entity.Player)
    (API) Added ctor McMMOPlayerFishingEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer)
    (API) Deprecated ctor McMMOPlayerFishingTreasureEvent.McMMOPlayerFishingTreasureEvent(org.bukkit.entity.Player, org.bukkit.inventory.ItemStack, int)
    (API) Added ctor McMMOPlayerFishingTreasureEvent.McMMOPlayerFishingTreasureEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, org.bukkit.inventory.ItemStack, int)
    (API) Deprecated ctor McMMOPlayerMagicHunterEvent(org.bukkit.entity.Player, org.bukkit.inventory.ItemStack, int, java.util.Map<org.bukkit.enchantments.Enchantment,java.lang.Integer>)
    (API) Added ctor McMMOPlayerMagicHunterEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, org.bukkit.inventory.ItemStack, int, java.util.Map<org.bukkit.enchantments.Enchantment,java.lang.Integer>)
    (API) Deprecated ctor McMMOPlayerAbilityDeactivateEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Added ctor McMMOPlayerAbilityDeactivateEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Deprecated util method EventUtils.callAbilityDeactivateEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.SuperAbilityType)
    (API) Added util method EventUtils.callAbilityDeactivateEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.SuperAbilityType)
    (API) Deprecated util EventUtils.callSubSkillEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.SubSkillType)
    (API) Added util EventUtils.callSubSkillEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.SubSkillType)
    (API) Deprecated ctor SubSkillEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.SubSkillType)
    (API) Added ctor SubSkillEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.SubSkillType)
    (API) Deprecated ctor SubSkillEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.SubSkillType, double)
    (API) Added ctor SubSkillEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.SubSkillType, double)
    (API) Deprecated ctor SubSkillEvent(org.bukkit.entity.Player, com.gmail.nossr50.datatypes.skills.subskills.AbstractSubSkill)
    (API) Added ctor SubSkillEvent(com.gmail.nossr50.datatypes.player.McMMOPlayer, com.gmail.nossr50.datatypes.skills.subskills.AbstractSubSkill)
    (API) Deprecated ctor AlchemyBrewCheckTask(org.bukkit.entity.Player, org.bukkit.block.BrewingStand)
    (API) Added ctor AlchemyBrewCheckTask(org.bukkit.block.BrewingStand)

    NOTES:
    You can now use hoppers and brewing stands and not have to worry about having to re-interact with the brewing stand over and over again
    Ownership of a brewing stand is whoever last interacted with it, this persists across restarts
    This is not an exhaustive list of API changes in this update, but most of the important ones should be documented here.

Version 2.2.009
    Fixed a bug that prevented mcMMO from loading on MC versions older than 1.20.6
    Dramatically increased the base XP for Alchemy again (see notes)

    NOTES:
    Alchemy leveling still felt too slow, so I've increased it again. You can either delete experience.yml to get the new values or adjust them manually.
    If you haven't updated mcMMO since 2.2.006 or older you don't need to do anything to get these new values.
    The new default values are...
            Potion_Brewing:
                Stage_1: 666
                Stage_2: 1111
                Stage_3: 1750
                Stage_4: 2250

Version 2.2.008
    Fixed alchemy potions not upgrading correctly (This will only affect new potions made, see notes)
    Fixed a bug where alchemy potions had italicized names
    Fixed a bug where messages were not being sent to the action bar in 1.20.6
    (SQL) Fixed bug that broke /mccooldowns and /archery in some circumstances
    Fixed some exceptions that could happen with parties disabled (thanks IAISI)

    NOTES:
    mcMMO-exclusive Potions (haste, etc) made on version 2.2.007 of mcMMO will not upgrade correctly, you'll just have to make new ones. Sorry for the inconvenience.
    Alchemy potions will now be brewed as type "Mundane" behind the scenes, this used to be Uncraftable/Water. This led to some issues. So I've changed it to be Mundane.

Version 2.2.007
    Compatibility with the 1.20.5 / 1.20.6 MC Update
    Fixed bug where Alchemy was not brewing certain potions (haste, etc)
    Tree Feller no longer restricts how many saplings can drop
    Tree Feller now drops leaves 25% of the time (up from 10%)
    Alchemy XP has been DRAMATICALLY increased, it was extremely grindy by default
    Alchemy experience values in experience.yml are now found under 'Experience_Values.Alchemy.Potion_Brewing'
    Fixed bug where the probability of success of Graceful Roll was not being calculated correctly
    Fixed bug where Green Thumb did not replant if seed was in the off hand
    Added armadillo to combat experience in experience.yml

    NOTES:
    While fixing various Alchemy bugs, I noticed Alchemy leveled SUPER slow, I have increased it dramatically. Feel free to change it back by modifying the new values in experience.yml
    I did my best to keep mcMMO compatible with older versions of Minecraft for this update.
    This update to MC was quite large, with breaking changes to a lot of code relating to Alchemy, and some other things.
    I expect there to be bugs, please report them on GitHub or Discord, but preferably GitHub.
    I will be working on fixing these bugs as they come in, so please be patient.
Version 2.2.006
    Added new config custom_item_support.yml
    Added support for hex color codes in the locale file, uses the format &#RRGGBB (see notes)
    Added setting to disable repair on items with custom models, this is not on by default
    Fixed a bug where sometimes the locale name of a skill would get lowercased
    Fixed a bug where JSON text components did not get colored properly some of the time
    Fixed en_US locale string 'Commands.Skill.Leaderboard' not being colored properly
    Fixed skill commands incorrectly telling you to use their locale name, this isn't currently possible
    Updated outdated wiki URLs in commands to point to the new wiki
    Removed the msg about skills being migrated to a new system when using /mmoinfo command
    Added new locale entry 'Anvil.Repair.Reject.CustomModelData'
    Added new locale entry 'Anvil.Salvage.Reject.CustomModelData'
    Updated en_US locale entry 'JSON.DescriptionHeader'
    (API/Codebase) Added some util methods and basic unit tests for LocaleLoader

    NOTES:
    Hex Color support in locale files is here!
    The hex color code format for the locale files is &#RRGGBB
    An example entry applying yellow as a hex color code would look like this:
    Axes.SkillName=&#FFFF00Axes
    In general, JSON locale entries will either not work with hex color codes or will have the color code stripped out, in the future I will add support for the JSON components to use hex colors from the locale

    Let me know in detail what kind of support you'd like to see in mcMMO regarding custom items, I'm open to suggestions.
    This update adds a new config file to allow server owners to disable repair or salvage on items with custom models,
    This prevention mechanism is not enabled by default, change the settings in custom_item_support.yml if you want to enable it.
    This feature is off by default for now to keep compatibility with existing servers, but it may be enabled by default in the future if feedback suggests it should be.
    As a reminder, anyone can update the wiki by clicking on the "edit on github" link on various pages, this will take you to the wiki's source code on GitHub, submit a PR to make changes

Version 2.2.005
    Fixed a bug where certain skills such as Dodge/Arrow Deflect had no skill cap and would continue improving forever
    Reduced messages on startup for SQL DB
    (API) Constructor for ProbabilityImpl now takes a raw value between 0 and 1 instead of an inflated percentage
    (API) Added some convenience methods to Probability, and ProbabilityUtil classes
    (Codebase) Added more unit tests revolving around Probability/RNG

Version 2.2.004
    Fixed bug where values from Experience_Formula.Skill_Multiplier were not functioning

    NOTES:
    A reminder that these values are multipliers and no longer divisors, if you want 10x lower XP, a value of .1 would do the job.

Version 2.2.003
    (SQLDB) Fixed a bug where lastlogin was using a value that was too large
    (SQLDB) Fixed bug where crossbows was not getting added to SQL schema for some users

Version 2.2.002
    Fixed bug where thrown tridents did not grant XP or benefit from subskills
    Fixed bug where trickshot marked bounced arrows as being shot from a bow instead of being shot from a crossbow

Version 2.2.001
    Fixed Crossbow's Powered shot showing the text for the wrong skill from the locale when using /crossbows command

Version 2.2.000
    General
    Added Crossbows Skill, this skill is an early preview / WIP and feedback on discord is appreciated
    Added Tridents Skill, this skill is an early preview / WIP and feedback on discord is appreciated
    Added an "endgame" triple drop subskill 'Mother Lode' to Mining
    Added an "endgame" triple drop subskill 'Clean Cuts' to Woodcutting
    Added an "endgame" triple drop subskill 'Verdant Bounty' to Herbalism
    Added /mmopower command which simply shows your power level (aliases /mmopowerlevel /powerlevel)
    Quite a few misc bugs were patched relating to random chance, some involving perk permissions

    Config
    Added 'Send_To_Console' settings to chat.yml to toggle sending party or admin chat messages to console
    Replaced 'Experience_Formula.Modifier' in experience.yml with 'Experience_Formula.Skill_Multiplier' which is easier to understand and less prone to divide by zero bugs
    child.yml config is gone now, feel free to delete it
    Added ExploitFix.PreventArmorStandInteraction to experience.yml to prevent players from triggering mcMMO abilities off armor stands

    Tweaks
    Tree Feller now drops 90% less non-wood block rewards (leaves/etc) on average from Knock on Wood.
    Treasure drop rate from Shake, Fishing, Hylian, and Excavation now benefit from the Luck perk
    Updated advanced.yml with entries for the new skills

    Permission nodes
    Added 'mcmmo.commands.mmopower' permission node for the new /mmopower command
    Added 'mcmmo.commands.crossbows' permission node
    Added 'mcmmo.ability.crossbows.crossbowslimitbreak' permission node
    Added 'mcmmo.ability.crossbows.trickshot' permission node
    Added 'mcmmo.ability.crossbows.poweredshot' permission node
    Added 'mcmmo.commands.tridents' permission node
    Added 'mcmmo.ability.tridents.tridentslimitbreak' permission node
    Added 'mcmmo.ability.tridents.impale' permission node
    Added 'mcmmo.ability.herbalism.verdantbounty' permission node
    Added 'mcmmo.ability.mining.motherlode' permission node
    Added 'mcmmo.ability.woodcutting.cleancuts' permission node

    Locale
    Added locale entries for all the new skills/subskills

    Codebase / Misc
    PAPI's '/papi reload' command will no longer unload mcMMO (thanks gecko10000)
    Major rewrite for how random chance was handled in the code
    Many skills with RNG elements now send out a SubSkillEvent (which can be used to modify probability or cancel the results), some skills without RNG still send out this event when activated, this event is cancellable so it can be used to make a skill fail
    A lot of new unit tests were added to help keep mcMMO stable as part of this update, of course, more could always be added.

    NOTES:
    One feature of this update is to provide a endgame benefits to some skills that you can grind for a long time, ideally for a long while. I will likely expand upon this idea in future updates.
    A few skills have these endgame oriented subskills, these new subskills provide a small benefit at first that grows and scales up to level 10,000 (or 1,000 for Standard mode which no one uses) and does not have ranks (other than the initial rank to unlock it).
    These endgame sub skills unlock at level 1000 for users with default mcMMO settings, or 100 for those using the optional Standard scaling.
    You can tweak the benefits of these skills in advanced.yml, the default settings are meant to be a good starting point.

    Crossbows and Tridents are WIP skills, I would like feedback on discord about them.
    Tridents especially is very early, I have some ideas but I want to hear what you think about it.

    More info on the new Triple Drop skills (Mother Lode, Clean Cuts, Verdant Bounty):
    Currently these start at about 5%  chance and can reach a maximum 50% chance if a player acquired 10,000 skill, you can adjust this in advanced.yml
    These skills respect double drop settings from config.yml just like the corresponding Double Drop skills do, if a double drop is disabled for an item, then its disabled for triple drops too.
    I added a new Power Level Command, for now this just shows you your current power level. If I ever add features based on power level, this command will likely display output related to those features.

    Regarding Maces, I will likely add that as a WIP skill when the next Minecraft update drops.

Version 2.1.231
    Fixed a bug preventing parties from being made without passwords (Thanks Momshroom)
    Updated korean locale (thanks mangchi57)
    Added some unit tests for party creation

Version 2.1.230
    Fixed an error that could happen when mcMMO was saving when parties were disabled by party.yml (thanks IAISI & L4BORG)
    Fixed several exceptions when checking PVP damage when parties were disabled by party.yml (thanks IAISI & L4BORG)

Version 2.1.229
    Added new party.yml config, which lets admins disable the party system entirely without having to use permissions
    Fixed error caused by missing API in McMMOEntityDamageByRuptureEvent
    (API) Major API changes to PartyManager
    (API) PartyManager is no longer a static singleton class, use mcMMO.getPartyManager() to get the PartyManager
    (API) Added com.gmail.nossr50.mcMMO.isPartySystemEnabled to check if the party system is enabled
    (API) Added com.gmail.nossr50.api.PartyAPI.isPartySystemEnabled as an alternative, to check if the party system is enabled
    (API) Added missing com.gmail.nossr50.events.skills.rupture.McMMOEntityDamageByRuptureEvent.getHandlerList

    NOTES:
    Admins can now enable/disable the whole party system with a setting in the new party.yml config
    You'll have to start your server one time to generate the config, then change the setting and reboot your server.

Version 2.1.228
    Fixed a stack trace due to Spigot API break on EntityDamageEvent and EntityDamageByEntity event
    (API) - Removed FakeEntityDamageEvent and FakeEntityDamageByEntityEvent
    (API) - Reworked McMMOEntityDamageByRuptureEvent, this no longer extends EntityDamageByEntityEvent, instead it extends EntityEvent

    Notes:
    Some care went into keeping mcMMO compatible with older versions despite a big API break from Spigot, this may introduce some new bugs, so please report them if you run into any.

Version 2.1.227
    Fixed bug where some text would not be displayed to players (Adventure dependency update)
    Repair sound effect from mcMMO can now be adjusted in Minecraft sound options (Thanks MithicSpirit)
    Korean locale updated (Thanks Pindang2)
    Simplified Chinese locale updated (Thanks YuanYuanOwO)

    NOTES:
    For those curious, mcMMO uses Adventure to do a lot of the message sending to players.
    It typically needs updating when new versions of MC come out, sorry for the delay on my part.

Version 2.1.226
    Added Short_Grass to experience.yml for Herbalism
    Updated Hylian Treasures "Bushes" alias to use short_grass when playing on new Minecraft versions
    Fixed dirt_path and grass_block not being correctly whitelisted for herbalism abilities
Version 2.1.225
    Fixed text from mcMMO not being sent or displayed to the player
    Updated Adventure dependencies
    Added new API McMMOPlayerNotificationEvent.getPlayer

Version 2.1.224
    Updated to a new build of ACF to fix NoSuchFieldException locale
    Improved Folia Support (Thanks HSGamer)
    Fishing Shake has 8 ranks again

    NOTES:
    At some point Shake got reduced to 1 rank, this didn't really make sense as it was meant to be a skill that ranked up and got better over time.
    It now has 8 ranks again, you may need to update advanced.yml and skillranks.yml to get the new ranks.
Version 2.1.223
    Folia Support added (Thanks to HSGamer, TechnicallyCoded, Rockyers, and Yomamaeatstoes)

    NOTES: This update brings mcMMO to Folia, not all features are guaranteed to work but from limited testing it appears to be working well.
Version 2.1.222
    Fixed dupe exploit
    Glow Lichen default XP changed from 200 to 5
    A lot of mcMMO logging was moved from INFO to DEBUG, this should reduce the amount of noise in your logs and console

    NOTES: If you want to see all logging messages, modify config.yml and set General.Verbose_Logging to true
    You will have to adjust experience.yml to get the balance changes, or delete it to generate a new one
Version 2.1.221
    PAPI Support is now built into mcMMO and loads when mcMMO loads (as long as you have PAPI running)
    Fixed blast mining bonus drops not working (Thanks warriiorrrr)
    Added fail safes to prevent bonus drops metadata from lingering on blocks

    NOTES: Placeholders were brought in from electroniccat's original work on a PAPI expansion for mcMMO, the placeholders are the same as a result
    I will be adding a leaderboard placeholder in the next patch (most likely). Feel free to share details of what functionality you'd want from additional placeholders on discord.
Version 2.1.220
    (API) Added TreeFellerBlockBreakEvent class which extends FakeBlockBreakEvent (see notes), this is sent out during Tree Feller processing to allow other plugins to differentiate between Tree Feller and other fake block break events
    Config files update automatically again
    Default configs are now copied to plugins/mcMMO/defaults for easy reference
    Fixed child skills counting towards power level in /inspect (Thanks Wariorrrr)

    NOTES: For a while configs were not updating automatically as a rewrite of how config files were loaded was partially done, this is now complete and configs will update automatically again.
    Fake block break events have been sent out historically by mcMMO to check other plugins for a players permission to break or place a block, Tree Feller will now specify via inheritance its own event type for this so mcMMO plugins can handle Tree Feller fake block break events differently if they so choose.
    You can now view the default configs more easily as they are now copied to plugins/mcMMO/defaults, these configs will be overwritten on start up to match the default values of the config in the JAR
Version 2.1.219
    Fixed Fishing exploit protection being triggered inappropriately by other plugins (Thanks smudgge)
    Fixed wiki url being incorrect in commands
    Party loading is more resilient (Thanks Wariorrrr)
    Fixed periods not being replaced whe nrenaming party (Thanks Wariorrrr)
    Fixed Party Teleport NPE (Thanks Wariorrrr)
    Added support for various new things from Minecraft 1.20
    Fixed double drop issue with Beetroots
    Added 'Camel' to taming experience in experience.yml
    Added 'Sniffer' to taming experience in experience.yml
    Added 'Snifflet' to taming experience in experience.yml
    Added 'Pitcher_Plant' to bonus drops in config.yml
    Added 'Torchflower' to bonus drops in config.yml
    Added 'Pink_Petals' to bonus drops in config.yml
    Added 'Cherry_Log' to bonus drops in config.yml
    Added 'Cherry_Wood' to bonus drops in config.yml
    Added 'Camel' to combat experience in experience.yml
    Added 'Sniffer' to combat experience in experience.yml
    Added 'Snifflet' to combat experience in experience.yml
    Added 'Torchflower' to herbalism experience in experience.yml
    Added 'Pitcher_Plant' to herbalism experience in experience.yml
    Added 'Pink_Petals' to herbalism experience in experience.yml
    Added 'Cherry_Log' to woodcutting experience in experience.yml
    Added 'Cherry_Wood' to woodcutting experience in experience.yml
    Added 'Stripped_Cherry_Log' to woodcutting experience in experience.yml
    Added 'Stripped_Cherry_Wood' to woodcutting experience in experience.yml
    Added 'Skills.Mining.BlastMining.Bonus_Drops.Enabled' to advanced.yml to enable/disable bonus drops from Blast Mining
    NOTE: There are plans to add experience and potentially subskills for discovering items via the new brushing mechanic, but this will have to wait for new Spigot API to become available

Version 2.1.218
    Fixed locale pt_BR type (thanks MrPowerGamerBR)
    Updated Russian Locale (thanks imDaniX)
    Harvest Lumber checks main hand enchantments when delivering bonuses (thanks destro174)
    Fixed bug where players could use inspect to determine if vanished players were online (thanks DarkKnights22)

Version 2.1.217
    Tree Feller will now break blocks within the limit instead of refusing to fell the entire tree (partial big tree destruction)
    Mangrove trees resulting from growth are now marked as natural (existing trees marked unnatural before this update will not be retroactively fixed)
    Fixed a bug removing comments from configs (see notes)
    Fixed mouse-hover tooltip windows (thanks Greymagic27)

    NOTES:
    Regarding the secure chat feature Minecraft rolled out, once APIs have updated I will look into rolling support for that into admin/party chat.
    Comments should no longer get removed from config but I haven't added any code to add missing comments back in, for now if you want comments you can delete the config file to regenerate it (sorry for the inconvenience)

Version 2.1.216
    Reverted Unarmed changes from 2.1.215 (fixes block breaker/beserk active at all time for all players)
    Added Sculk_* blocks to Mining XP
    You can use Hoe(s) to gain mining XP, Hoe(s) won't benefit from Super Breaker nor will they activate it (see notes)

    NOTES:
    Hoe's being able to gain Mining XP is primarily for Sculk blocks which have Hoe as the fastest tool yet to me feel like Mining blocks, let me know what you think
    The Sculk blocks don't quite fit perfectly as mining-related, especially since hoes are the fastest tool to use for them. Let me know what you think.
Version 2.1.215
    Fixed Coal Blocks and potentially other fuel sources not showing burning animation to players (see notes)
    Level up broadcasts from level milestones will now be visible to the player who achieved them
    Fixed a bug where hovering over skill descriptions did not display anything (thanks Greymagic27)
    Added Dripstone to experience.yml (thanks Greymagic27)
    Added Mangrove_Log to experience.yml (should fix behavior for tree-feller etc)
    Item in main hand is now used for Tree Feller drops (thanks destro174)

    NOTES:
    The burning animation bug is actually in Spigot, it takes an int for setBurnTime when it really should only take a short as the game is expecting a short value, I implemented a hacky workaround via Math.min
    There is a bug where you may lose your config comments, this will be complex to solve, for now you can check our GitHub for the configs with comments.

Version 2.1.214
    Temporarily removed FakePlayerAnimationEvent (see notes)
    Players can now see their own level up broadcasts

    NOTES:
    Spigot updated PlayerAnimationEvent with an API break between versions 1.18 and 1.19, as a temporary fix for mcMMO to be able to support both of these
    Minecraft versions I have temporarily removed FakePlayerAnimationEvent. I am working on a fix to dynamically use the correct API depending on the version of MC
    as many people will likely be stuck on 1.18 for a while.
    FakePlayerAnimationEvent existed to circumvent false positives on anti-cheat plugins such as NoCheat, however
    I am unsure if it is still needed and removing it may have no ill effects.. however I cannot be certain.
    Anti-cheat plugin authors should be informed to update if you run into false positives with mcMMO after this update so they can make the appropriate changes.
Version 2.1.213
    Updated various mechanics to recognize and understand the new blocks
    Added 'Packed_Mud' to mining xp
    Added 'Mud_Bricks' to mining xp
    Added 'Reinforced_Deepslate' to mining xp
    Added 'Mud' to excavation xp
    Added 'Muddy Mangrove Roots' to excavation xp
    Added 'Mangrove_Roots' to woodcutting xp
    Added 'Stripped_Mangrove_Log' to woodcutting xp
    Added 'Stripped_Crimson_Stem' to woodcutting xp
    Added 'Stripped_Warped_Stem' to woodcutting xp
    Added 'Allay' to combat experience
    Added 'Frog' to combat experience and taming experience
    Added 'Tadpole' to combat experience
    Added 'Warden' to combat experience

    Changes to excavation treasures (requires manual editing or regenerating the config)
        Added Mud as a block which can drop various treasures (see notes)
        Added Muddy_Mangrove_Roots as a block which can drop various treasures (see notes)
        Added Stick as a new excavation drop, which drops from mud and muddy mangrove roots (see notes)
        Added Potato as a new excavation drop, which drops from mud and dirt (see notes)
        Added Feather as a new excavation drop, which drops from mud (see notes)
        Added Spyglass as a new excavation drop, which drops rarely from mud and dirt (see notes)
        Added Trident as a new excavation drop, which drops somewhat rarely from mud, muddy mangrove roots, and clay (see notes)
        Added Heart of the Sea as a new excavation drop, which drops very rarely from mud and requires a very high excavation level to appear

    NOTES:
    To get the new excavation drop list, the easiest way is to delete treasures.yml and mcMMO will regenerate it with the newest version
    I'll likely be tweaking the treasures list in the near future, leave feedback on discord if you have suggestions

Version 2.1.212
    An herbalism exploit has been patched (thanks WhatsTheBadNews)
    Added 'ExploitFix.Combat.XPCeiling.Enabled' to experience.yml
    Added 'ExploitFix.Combat.XPCeiling.Damage_Limit' to experience.yml
    Single instances of combat damage above 100 give are capped to give the same reward as 100 by default (100 is a lot, but you can change this in settings)

    NOTES: The damage ceiling won't affect server that don't have mobs running around with abnormally high health, if your server does you'll want to adjust this limit or disable it.
Version 2.1.211
    Added /mmodebug info for players hitting other players
    Fixed Immortal Player bug
    Removed all of Spigot's buggy and deprecated DamageModifier API, this fixes the bug where players would become immortal when using certain other plugins
    Rupture is back to doing "pure" damage (due to the above change)

    NOTES:
    Rupture damage will be tweaked based on feedback as it is dealing "pure" damage
Version 2.1.210
    Fixed a memory leak involving mob metadata
    Fixed a potential null pointer exception in InventoryListener

    NOTES:
    If you're having issues with "immortal players" this is a known plugin incompatibility between mcMMO and another plugin, I need more info on what plugins need to be present to cause it. Please post info to GitHub issues or tag me on discord.
    There was a big rewrite in this update relating to how various types of metadata were being tracked/stored/retrieved
    If you run into issues with this version of mcMMO, please post about it on GitHub

Version 2.1.209
    Fixed a bug where some config files did not get trimmed completely

    NOTES:
    This should fix the issue for everyone, let me know if you still run into trouble!
    Don't be afraid to ping me on discord

Version 2.1.208
    Significantly rewrote to how mcMMO loads/updates config files
    Fixed a bug where huge config files caused the server to take forever to start/shutdown
    Fixed config files duplicating comments and updated their code to use Spigot API (thanks the456gamer)
    mcMMO now repairs config files (removing duplicate comments, see notes)
    Updated lithuanian locale (thanks dexasz)

    NOTES:
    Due to a change in Spigot mcMMO started growing config files at an alarming rate until they became so big they wouldn't load, and well before they got to that stage they slowed down loading the server
    mcMMO now uses the Spigot API in a smarter way for config files

Version 2.1.207
    Fixed an IndexOutOfBounds exception with our BlockTracker
    Fixed a bug where leveling up a party at level cap would spam the chat with messages
    mcMMO will no longer use enchanted repair materials (thanks JeBobs)
    Added an option to allow enchanted repair materials 'Skills.Repair.Use_Enchanted_Materials' in config.yml
    Temporarily rolling required Java version back to 16
    Added unicode (UTF-8) support to locale files (no more UTF-16 codes needed)
    Added locale key 'Scoreboard.Disabled' to en_US
    Added locale key 'Scoreboard.NotSetupYet' to en_US
    Fixed a bug where Salvage sent messages even though the event was cancelled (Thanks TheBusyBiscuit)

Version 2.1.206
    Fixed a memory leak involving Herbalism under specific circumstances
    Fixed a memory leak involving Rupture under specific circumstances
    Fixed a memory leak involving Dodge
    Fixed a memory leak involving Endermen and block pickups
    Fixed a memory leak from plugin conflicts when double drops get activated
    Fixed a memory leak that required a specific config.yml setup with mob health bars
    You can no longer set mob health bars to -1 in config.yml to set it to display permanently (this was problematic behavior)
    Fixed a bug preventing Action Bar messages from showing
    Fixed a bug where Alchemy XP wasn't being granted
    Lowered the default volume of level up from .75 to .3 in sounds.yml (delete sounds.yml to get this change automagically)
    Updated adventure platform dependency
    Updated to use Java 17

    NOTES:
    mcMMO will target the newest version of MC moving forward, any backwards compatibility with prior versions of Minecraft should be considered a side effect rather than intended.

Version 2.1.205
    Fixed yet another exception preventing Alchemy from working (thanks NemuruYama)
    Added some code to cleanup potential memory leaks

    NOTES:
    Sorry for the delay in this patch, I have had a terrible cold all weekend, feeling better now

Version 2.1.204
    Fixed IndexOutOfBounds exception (thanks gecko10000) (related to Alchemy)
    Added double smelt to copper ingot and netherite scrap (thanks Lyther)

Version 2.1.203
    mcMMO now requires Java 16
    mcMMO now requires the newest version of Minecraft (currently 1.17.1)
    Fixed several API breaks (mostly affected Alchemy)
    Fixed a bug relating to Shake percentages (thanks Lyther)
    Fixed hexcolors not displaying correctly in level up milestone broadcasts (thanks gecko10000)
    (API) Added deprecated constructors for PlayerProfile (thanks PikaMug)
    mcMMO has had many of its dependencies updated to newer builds

    NOTES:
    If you want to play mcMMO on older versions, simply use 2.1.202 instead
    Keeping mcMMO backwards compatible with older versions is getting messy, and I'd rather be able to focus my attention at newer features than having to make an elaborate build process (or alternatively hacky code) to support older versions of the game
    Furthermore, it seems most people are playing 1.17.1 by a wide margin
    You may have trouble compiling the source code if your maven is not setup to run JDK16, if you get any errors when compiling this is likely the reason

    The data from bstats went into making this decision (shoutout to Qixils for typing this up too)
     71.9% of servers are running 1.17.X
     97.9% of servers are running ≥1.16
     99.3% of servers are running ≥1.15

Version 2.1.202
    Fixed a bug where mcMMO didn't reward XP for Kelp
    Fixed a bug where mcMMO marked bonemealed Azalea trees as unnatural (and thus did not give XP or get affected by Tree Feller)
    Added Amethyst_Block to experience.yml for Mining
    Added Flowering Azalea Leaves to Tree Feller's white list
    Fixed a bug where mcMMO didn't appropriately flag blocks as natural in some tree growing events
    (SQL) Added more MySQL/MariaDB settings (allowPublicKeyRetrieval - thanks rosaage)
    (API) Added CREATED_PARTY and DISBANDED_PARTY to EventReason (used in some party events - thanks PikaMug )
    Party member name matching is no longer case sensitive (thanks Wariorrrr)
    Updated zh_CN locale (thanks GhostDC)
    Added some settings for over fishing (Settings are in experience.yml under Fishing_ExploitFix_Options - thanks tunagohan)

    NOTES:
    This means tree feller will correctly traverse flowering azalea leaves during its ability

Version 2.1.201
    Tweaked the visual/audio effect for Rupture
    (API) TNT is set as the source in Blast Mining (1.16.1 and up)
    Fixed an exploit related to Ability Buffs remaining on tools
    Blast Mining no longer drops Budding Amethyst since its not legal to obtain this item through normal gameplay
    Added mcinspect and mmoinspect aliases to inspect command
    Portuguese translation of Woodcutting changed back to Lenhador
    Updated zh_CN (Chinese) locale, thanks GhostDC!
    Major changes to zh_TW locale, thanks gregman98
    Added '/skill keep' shortcut (for example /mining keep) thanks GriffinCodes
    Impact is now more balanced as the formula has been changed (see notes) thanks emanondev

    NOTES:
    Impact will deal less durability damage to armors without unbreaking, and more to armors with unbreaking

Version 2.1.200
    Fixed a major 1.17 exploit
    Dodge will no longer trigger while blocking
    Action Bar messages can now be disabled (thanks TheBusyBiscuit)
    mcMMO is better at MC version parsing now (thanks stepech & TheBusyBiscuit)

Version 2.1.199
    Fixed IndexOutOfBounds error for servers running 1.17 or higher
    Fixed a bug that caused MySQL/MariaDB to malfunction for 1.17 (see notes)
    Renamed Deepslate Lapis Lazuli Ore to Deepslate Lapis Ore in experience.yml and config.yml
    Added some code to prevent mcMMO from breaking if it doesn't recognize the version of the game
    Optimized CompatibilitySupportLayer - this handles some of the logic for supporting multiple versions of the game
    Added Unit Tests for MinecraftGameVersion

    NOTES:
    I have temporarily disabled SSL for MySQL/MariaDB for 1.17 ( proper fix coming soon )

Version 2.1.198
    Fixed a bug where Smelting didn't work with the new 1.17 materials
    Updated dependency Adventure to 4.8.0 (thanks TheBusyBiscuit)

Version 2.1.197
    This update adds compatibility for new mobs and blocks from 1.17
    This build of mcMMO should be more compatible with certain versions of ViaVersion
    Players are no longer launched from Minecarts when using a Fishing Rod (they are still dismounted) thanks lexikiq
    Updated Japanese locale (thanks ViaSnake)
    Updated Brazil Portuguese (pt_BR) locale (thanks Paulo Guilherme)
    Added Goat to experience.yml for combat and taming
    Added Axolotl to experience.yml for combat and taming
    Added Glow_Squid to experience.yml for combat and taming
    Added Glow Berries to Farmer's Diet
    Updated Super Breaker to recognize the new pick-axe appropriate blocks
    Updated Tree Feller to recognize Azalea Leaves

    Added Rooted Dirt to experience.yml for Excavation
    Added Small Dripleaf to experience.yml for Herbalism
    Added Big Dripleaf to experience.yml for Herbalism
    Added Moss Block to experience.yml for Herbalism
    Added Cave Vines to experience.yml for Herbalism
    Added Cave Vines Plant to experience.yml for Herbalism
    Added Glow Lichen to experience.yml for Herbalism
    Added Tuff to experience.yml for Mining
    Added Calcite to experience.yml for Mining
    Added Smooth Basalt to experience.yml for Mining
    Added Block_Of_Amethyst to experience.yml for Mining
    Added Budding Amethyst to experience.yml for Mining
    Added Small_Amethyst_Bud to experience.yml for Mining
    Added Medium Amethyst Bud to experience.yml for Mining
    Added Large Amethyst Bud to experience.yml for Mining
    Added Amethyst Cluster to experience.yml for Mining
    Added Deepslate to experience.yml for Mining
    Added Cobbled Deepslate to experience.yml for Mining
    Added Copper Ore to experience.yml for Mining
    Added Deepslate Redstone Ore to experience.yml for Mining
    Added Deepslate Copper Ore to experience.yml for Mining
    Added Deepslate Coal Ore to experience.yml for Mining
    Added Deepslate Diamond Ore to experience.yml for Mining
    Added Deepslate Emerald Ore to experience.yml for Mining
    Added Deepslate Iron Ore to experience.yml for Mining
    Added Deepslate Gold Ore to experience.yml for Mining
    Added Deepslate Lapis Lazuli Ore to experience.yml for Mining
    Added Lapis Lazuli Ore to experience.yml for Mining (was missing)

    Added Moss Block to Bonus Drops for Herbalism in config.yml
    Added Glow Berries to Bonus Drops for Herbalism in config.yml
    Added Cave Vines to Bonus Drops for Herbalism in config.yml
    Added Cave Vines Plant to Bonus Drops for Herbalism in config.yml
    Added Tuff to Bonus Drops for Mining in config.yml
    Added Amethyst Shard to Bonus Drops for Mining in config.yml
    Added Calcite to Bonus Drops for Mining in config.yml
    Added Smooth Basalt to Bonus Drops for Mining in config.yml
    Added Block_Of_Amethyst to Bonus Drops for Mining in config.yml
    Added Budding Amethyst to Bonus Drops for Mining in config.yml
    Added Small_Amethyst_Bud to Bonus Drops for Mining in config.yml
    Added Medium Amethyst Bud to Bonus Drops for Mining in config.yml
    Added Large Amethyst Bud to Bonus Drops for Mining in config.yml
    Added Amethyst Cluster to Bonus Drops for Mining in config.yml
    Added Deepslate to Bonus Drops for Mining in config.yml
    Added Cobbled Deepslate to Bonus Drops for Mining in config.yml
    Added Raw Iron to Bonus Drops for Mining in config.yml
    Added Raw Gold to Bonus Drops for Mining in config.yml
    Added Raw Copper to Bonus Drops for Mining in config.yml
    Added Copper Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Redstone Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Copper Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Coal Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Diamond Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Emerald Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Iron Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Gold Ore to Bonus Drops for Mining in config.yml
    Added Deepslate Lapis Lazuli Ore to Bonus Drops for Mining in config.yml
    Added Lapis Lazuli Ore to Bonus Drops for Mining in config.yml (was missing)

    Added Cobbled Deepslate to experience.yml for Smelting
    Added Raw Copper to experience.yml for Smelting
    Added Raw Iron to experience.yml for Smelting
    Added Raw Gold to experience.yml for Smelting
    Added Copper Ore to experience.yml for Smelting
    Added Deepslate Redstone Ore to experience.yml for Smelting
    Added Deepslate Copper Ore to experience.yml for Smelting
    Added Deepslate Coal Ore to experience.yml for Smelting
    Added Deepslate Diamond Ore to experience.yml for Smelting
    Added Deepslate Emerald Ore to experience.yml for Smelting
    Added Deepslate Iron Ore to experience.yml for Smelting
    Added Deepslate Gold Ore to experience.yml for Smelting
    Added Deepslate Lapis Lazuli Ore to experience.yml for Smelting
    Added Lapis Lazuli Ore to experience.yml for Smelting (was missing)

    NOTES:
    Another patch will follow this one shortly to add more 1.17 support, I am waiting on the Spigot API to test some stuff which isn't out yet.
    You shouldn't need to edit your configs for this update, your configs should update automatically.
    Expect some patches following this update for Axolotl and other new entities, waiting on the Spigot API to become available
    If you run into any issues with ViaVersion or ViaBackwards, use the latest dev builds for each.

Version 2.1.196
    Removed the explosion from Rupture
    Adjusted Rupture to play its particle effect less often
    Fixed a bug where Rupture never applied to additional targets during Serrated Strikes
    Fixed a bug where players without Rupture permission could use Rupture during Serrated Strikes
    Fixed a possible null error for our SelfListener
    Added locale string 'Swords.Combat.Rupture.Note.Update.One'
    Updated locale string 'Guides.Swords.Section.1'
    Crossbows can now be fished up with enchantments
    (API) Added McMMOEntityDamageByRuptureEvent (thanks qixils)

    NOTES:
    For now Rupture is non-lethal, I may add back a lethal component at the end of its damage
    Rupture will be in a state of change for a while as I receive feedback (give me feedback in Discord!)
    Crossbows is not in the default fishing loot list, you'd have to add it yourself.
    For Devs: McMMOEntityDamageByRuptureEvent extends EntityDamageByEntityEvent and uses CUSTOM type damage

Version 2.1.195
    Fixed a null connection error which affected some SQL users

Version 2.1.194
    Fixed an XP exploit
    Updated SQL to not throw errors if upgrades.yml was reset for any reason
    Updated SQL to use the newest driver path (and fall back to the old one if the new one doesn't exist on the server)
    Locale override files are now named locale_override.properties (converted automatically/generated automatically)
    Existing in use locale override files will be renamed to locale_override.properties and have some useful text put in them
    mcMMO will now generate a locale override file with some detailed instructions if one doesn't exist (will be found in /plugins/mcMMO/locales/locale_override.properties)

    NOTES:
    If you were overriding locale before this update mcMMO will just rename the existing override file to locale_override.properties add some useful text and then load it
    Remember you can use /mcreloadlocale to swap the edits in without restarting the server

Version 2.1.193
    Fixed another bug where mcrank/mctop/leaderboards weren't loading
    Fixed a bug where override locales weren't being loaded (but worked after a reloadlocale command)
    (Unit Tests) Added a test to make sure leaderboards for FlatFile were working
    Fixed blocks being dropped from blast mining even if yield was set to 0 (thanks Warriorrrr)
    Fixed Tree feller not working entirely if one fake block break event is cancelled. (thanks Warriorrrr)
    Fixes no woodcutting xp being rewarded if a tree is too big while using tree feller. (thanks Warriorrrr)
    Updated pl locale (thanks Mich3l3k)

Version 2.1.192
    Removed some debug messages from FlatFileDatabaseManager
    Fixed another bug where player names could be saved as null for FlatFileDB (they will update on the players next login at the next save interval)
    (API) Removed deprecation from com.gmail.nossr50.api.ExperienceAPI.getOfflineProfile(java.lang.String)
    (API) Added com.gmail.nossr50.api.DatabaseAPI.doesPlayerExistInDB(org.bukkit.OfflinePlayer)
    (API) Added com.gmail.nossr50.api.ExperienceAPI.getOfflineProfile(org.bukkit.OfflinePlayer)
    (API) Added com.gmail.nossr50.api.ExperienceAPI.getOfflineXP(org.bukkit.OfflinePlayer, java.lang.String)
    (API) Added com.gmail.nossr50.api.ExperienceAPI.getOfflineXPRaw(org.bukkit.OfflinePlayer, com.gmail.nossr50.datatypes.skills.PrimarySkillType)
    (API) Added com.gmail.nossr50.api.ExperienceAPI.getOfflineXPRaw(org.bukkit.OfflinePlayer, java.lang.String)
    (API) Added com.gmail.nossr50.api.ExperienceAPI.getOfflineXPToNextLevel(org.bukkit.OfflinePlayer, java.lang.String)
    (API) Added com.gmail.nossr50.api.DatabaseAPI.doesPlayerExistInDB(java.lang.String)
    (Unit Tests) Added some more unit tests to FlatFileDB

Version 2.1.191
    Fixed a bug related to our blocktracker
    Fixed a bug that prevented the leaderboards from working on FlatFile in some circumstances
    Some minor optimizations to our Block events
    (Unit Tests) Added a test for initializing the leaderboard on FlatFile
Version 2.1.190
    Fixed a null error in BitSetChunkStore
Version 2.1.189
    Fixed a bug that would remove components from death messages when players were killed by mobs (thanks lexikiq)
    Rewrote how FlatFileDatabase verifies data integrity
    FlatFileDatabase has much better data validation and will repair broken/invalid data much better
    Fixed a bug where FlatFileDatabase users could have their names saved as "null" (names will be fixed the next time the player logs in)
    Added 20~ unit tests for FlatFileDatabaseManager (see notes)
    FlatFileDB now stores the last login of users again (was completely non functional for a while)
    Newly created flat file databases (mcmmo.users file) will have a comment line at the top noting the date the database was created
    Minor performance optimizations to FlatFile database
    mcMMO will once again purge old users if the config option is on (see notes)
    Fixed a bug where FlatFileDatabaseManager didn't properly upgrade older database entries to the newest schema
    The setting to disable the mcMMO user block tracker has been moved from our "hidden config" to persistent_data.yml
    Added 'mcMMO_Region_System.Enabled' to persistent_data.yml (don't touch this setting unless you know what you are doing)
    Removed MHD command (it didn't do anything for a while now)
    Removed UltraPermissions warning
    Updated pl locale (Thanks Mich3l3k)
    Fixed an IllegalPluginAccessException error that could happen during server shutdown
    Minor performance optimizations to misc parts of the codebase
    (API) Added com.gmail.nossr50.database.DatabaseManager.loadPlayerProfile(org.bukkit.OfflinePlayer)
    (API) Deprecated com.gmail.nossr50.database.DatabaseManager.loadPlayerProfile(java.util.UUID, java.lang.String)
    (API) Removed com.gmail.nossr50.database.DatabaseManager.newUser(java.lang.String, java.util.UUID)
    (API) PrimarySkillType will soon be just an enum with nothing special going on
    (API) Deprecated the members of PrimarySkillType use mcMMO::getSkillTools instead, deprecated members will be removed in Tridents & Crossbows (due soon)
    (API) Some members of PrimarySkillType were removed and not deprecated (such as the field constants)

    NOTES:
    I spent over 26 hours refactoring FlatFileDB and writing unit tests for it, this will ensure that any changes in the code that could break the database are caught at compile time (so long as we have enough tests, could probably use more)
    Regarding purging old users on the FlatFileDB, since this wasn't functioning for a while, the last login of users has been reset and if mcMMO hasn't seen that user since this update, it won't purge them as it has no way to know if they are truly an old user
    I'm likely going to add SQLite DB as an option in the future, I spent time to fix up the FlatFileDB as some Unit Testing practice.
    Ultra Permissions is SAFE to use with mcMMO, disregard previous messages stating otherwise
    After getting in contact with the UltraPermissions devs and exhaustive testing, I have concluded that using UltraPermissions is completely safe with mcMMO. The users who had an issue with performance currently have an unknown cause, potentially it is from a plugin using the UltraPermissions API I really can't say without more data. My apologies to the UltraPermissions team for reporting an issue between our two plugins directly, as that is not the case. I would have tested it myself sooner but UltraPermissions was closed source and premium so I wasn't particularly motivated to do so, however I have been given access to the binaries so now I can do all the testing I want if future issues ever arise which I have zero expectations that they will.

Version 2.1.188
    Updated default entries in treasures.yml to use "Level_Requirement" instead of "Drop_Level"
    Fixed a bug where excavation treasures only required level 0 instead of loading the value from the config
    Fixed a bug where /fishing was showing the wrong shake chance
    Default Shake chance increased from 15% to 30% (update advanced.yml manually or delete the file to regenerate it and receive these changes)
    Removed entries for ranks 2-8 of Shake from advanced.yml (Shake only has one rank, the extra entries were a mistake)
    Modified the warning about UltraPermissions
    Removed the debug message about potentially unused keys (only shown if you had debug mode enabled in config.yml)

    NOTES:
    This update makes changes to treasures.yml automatically to apply the fix, you don't need to do anything
    UltraPermissions devs are working on a fix for the performance issue bug

Version 2.1.187
    Fixed a ClassCastException error involving Rupture

Version 2.1.186
    Rupture has been reworked to solve a few outstanding issues (see notes)
    Fixed an exploit involving enchantments (thanks TheBusyBiscuit)
    Fixed a very small memory leak that would only happen in very rare situations
    Fixed a bug where XP wasn't granted while sneaking and interacting with a berry bush
    Gore no longer applies Rupture
    Gore no longer sends a message to the Wolf owner when it triggers
    Gore no longer sends a message to players that are hit by it
    Rupture no longer sends a message telling you that your target is bleeding
    Updated locale string 'Swords.SubSkill.Rupture.Description'
    Updated locale string 'Swords.SubSkill.Rupture.Stat.Extra'
    Updated locale string 'Swords.Combat.Rupture.Note'
    Added locale string 'Swords.SubSkill.Rupture.Stat.TickDamage'
    Added locale string 'Swords.SubSkill.Rupture.Stat.ExplosionDamage'
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Chance_To_Apply_On_Hit' to advanced.yml
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Duration_In_Seconds.Against_Players' to advanced.yml
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Duration_In_Seconds.Against_Mobs' to advanced.yml
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Tick_Interval_Damage.Against_Players' to advanced.yml
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Tick_Interval_Damage.Against_Mobs' to advanced.yml
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Explosion_Damage.Against_Players' to advanced.yml
    Added 'Skills.Swords.Rupture.Rupture_Mechanics.Explosion_Damage.Against_Mobs' to advanced.yml
    Removed 'Skills.Swords.Rupture.ChanceMax' from advanced.yml
    Removed 'Skills.Swords.Rupture.MaxBonusLevel.Standard' from advanced.yml
    Removed 'Skills.Swords.Rupture.MaxBonusLevel.RetroMode' from advanced.yml
    Removed 'Skills.Swords.Rupture.MaxTicks' from advanced.yml
    Removed 'Skills.Swords.Rupture.BaseTicks' from advanced.yml
    Removed 'Skills.Swords.Rupture.DamagePlayer' from advanced.yml
    Removed 'Skills.Swords.Rupture.DamageMobs' from advanced.yml

    NOTES:
    The old Rupture would constantly interfere with your ability to do a Sweep Attack/Swipe with swords, the new one solves this problem
    Targets will bleed and take "pure" damage while bleeding, this never kills the target. It will reduce them to 0.01 HP.
    After 5 seconds of not applying Rupture on the target Rupture explodes dealing a large amount of damage, this damage is not pure and is affected by armor etc.
    Rupture no longer tells you that you that you applied it to the target, it should be obvious from the sounds/particle effects
    The new Rupture no longer constantly interferes with the vanilla Swipe (the AOE attack built into Minecraft)
    The new Rupture has not had a fine tuned balance pass, I will be balancing it frequently after this patch, it may be too weak or too strong in its current form
    Rupture does not stack between players, whoever applied Rupture first determines its strength, this will change in the future (Stronger Ruptures will overwrite weaker ones)
    When you reapply rupture it immediately triggers a damage tick



Version 2.1.185
    Fixed an exploit for Herbalism

Version 2.1.184
    Removed April Fools event
    Fixed a bug where the default treasures.yml file had incorrect keys (see notes)

    NOTES:
    mcMMO will fix bad config files automatically, you don't need to do anything

Version 2.1.183
    Players now gain Acrobatics XP from falling even if they don't have the Roll permission node (checks for Acrobatics skill permission)
    treasures.yml now has separate settings for Drop_Level for Standard/Retro mode (see notes / this change is automatic)
    Updated Russian locale (thanks ImDaniX)
    Added Donkeys to beat lore (thanks QuantumToasted)
    Alchemy guide now correctly labels Rabbit's foot for potion of leaping (thanks mldriscoll)
    Fixed a bug where sweet berry bushes would give XP in situations where they shouldn't
    The /mmoinfo for Roll is removed for the time being, it will return in a future update (see notes)

    NOTES:
    Previously treasures.yml would take drop_level and multiply it by 10 if you were on Retro Mode, this is confusing so it has been changed
    treasures.yml will update old entries to follow the new format automatically, please review them to make sure they match expected values, and if not edit them and save then reboot your server
    Roll is actually the only skill that had an /mmoinfo, its one big mess, I'll fix it in the future

Version 2.1.182
    Players now receive XP from harvesting Sweet Berry bushes (double XP for harvesting fully grown berries)
    Fixed an error when using mcMMO with Featherboard that broke mcMMO skill boards when using certain commands
    Fixed a NPE with Scoreboards enabled when trying to update scoreboards
    Added 'Scoreboard.Recovery' locale key
    Sweet Berry Bush will no longer ready tools for Super Abilities
    You can now use '.all' (for example: mcmmo.perks.xp.customboost.all) to give an XP perk to all skills
    Removed hardcore and vampirism commands, these commands are dangerous, just modify the config file if you want to use hardcore / vampirism
    Fixed several errors in de locale (Thanks TheBusyBiscuit & w1tcherrr)
    Fixed a bug where double smelt never succeeded if the furnace was empty (but worked normally afterwards)
    Added some safety so that mcMMO automatic save interval is never more frequent than 1 minute
    Removed a few silent exceptions for scoreboards & mcMMO
    Added warning about UltraPermissions to mcMMO
    Fixed a potential NPE in McMMOPlayerExperienceEvent
    Added Sweet Berry Bush to config.yml bonus drops for Herbalism

    NOTES:
    Sweet Berry Bushes won't give double drops for now, looking into an elegant solution
    mcMMO will do a better job reporting if something went wrong with scoreboards, which may lead to improved plugin compatibility between mcMMO and other plugins touching scoreboards.

Version 2.1.181
    mcMMO no longer pointlessly tries to check for missing UUIDs for FlatFile database
    Removed the "name change detected" message as some plugins (such as Plan) invoke API calls which spams the console with this message
    Refactored code related to loading player data from the database
    (API) Added DatabaseManager::loadPlayerProfile(String)
    (API) Removed DatabaseManager::loadPlayerProfile(String, UUID, boolean)
    (API) Removed DatabaseManager::loadPlayerProfile(String, boolean)

Version 2.1.180
    mcMMO will now automatically remove corrupted data from mcmmo.users instead of catastrophic failure
    When using FlatFile database (the default) mcMMO will try its best to inform you which players had corrupted data when it does repairs
    Various minor optimizations and tweaks to the FlatFile database
    mcMMO is now much more verbose when things go wrong with the FlatFile database (removed some silent errors, added more error messages/warnings)
    mcMMO now uses UTF-8 compliant encoding for SQL databases (utf8mb4)
    Fixed a bug where mcMMO could in some circumstances fail to update SQL schema and mark it as successful
    Renamed updates.yml to updates_overhaul.yml to avoid some potential issues when upgrading from classic

    NOTES:
    This update was tested pretty thoroughly so it should be pretty safe, let me know if you have issues in the mcMMO discord or GitHub issues page for mcMMO!

Version 2.1.179
    Fixed a bug for FlatFile databases where some players with changed nicknames would have their levels not loaded upon login (possibly wiping their data)

    NOTES:
    Players affected by this bug (introduced in 2.1.177) may have their data lost, but this patch reverts the change which caused this bug.
    I suspect their data isn't lost and may be restored after this patch is loaded up, however if it is lost mcMMO makes regular backups so you can load one of those (check <Server Directory>/plugins/mcMMO/) or manually edit their levels via MMOEDIT as a solution of sorts.

Version 2.1.178
    Item replacement in vanilla fishing override back to SALMON from AIR (see notes)

    NOTES:
    Apparently can't set items to AIR, my bad. I'll look into another solution for fishing plugin compatibility soon.

Version 2.1.177
    Environmentally aware will now protect Wolves from Magma blocks
    Fixed a bug where mcMMO would fail to update a players name when it detected a name change
    mcMMO will treat vanished players as if they are offline when using the inspect command on them now (see notes)
    mcMMO now listens to PlayerFishEvent at HIGH event priority instead of HIGHEST
    Changed how vanilla fishing treasures are overridden (AIR instead of SALMON)
    (API) Added McMMOReplaceVanillaTreasureEvent -- see notes

    NOTES:
    A few changes were made to the inspect command, it used to reject you when used on vanished players, now it will be processed as if they are offline.
    Additionally if you do inspect a vanished player, it will not use their display name (consistent with offline players) as that would give them away for being online
    McMMOReplaceVanillaTreasureEvent is an event which is fired when mcMMO replaces a vanilla treasure with AIR if the server config file is set to override vanilla treasures, this causes some issues for other fishing plugins so this event helps those plugins be more compatible

Version 2.1.176
    Another fix for Double Smelt bringing item stack size to illegal values

Version 2.1.175
    Fixed a bug where mcMMO would occasionally give a 65 item stack from a double smelt on a furnace
    Fixed a bug where arrows could be duped when fired from a crossbow with piercing enchantment
    Added setting to enable or disable Green Thumb automatically replanting crops per crop to config.yml under 'Green_Thumb_Replanting_Crops' section
    Updated Adventure (our text dependency) fixes some errors when using color codes in party/admin chat (thanks TheBusyBiscuit)
    Added some support for negative Y values in anticipation of 1.17 world height changes (thanks t00thpick1)

Version 2.1.174
    Some legacy color codes in our locale file were swapped to &-code equivalents (thanks ViaSnake)
    Updated hu_HU locale (thanks andris155)
    Updated ru locale (thanks imDaniX)
    Updated fr locale (thanks Elikill58)
    (API) Added SubSkillBlockEvent for some SubSkill events that have a block (eg: Green Thumb Block events)
    (API) Green Thumb (Block) now fires a SubSkillBlockEvent which is cancellable
    (API) Green Thumb (Plant) now fires SubSkillBlockEvent which is cancellable
    (API) Shroom Thumb now fires a SubSkillBlockEvent which is cancellable

    NOTE: A lot of sub-skills without random chance elements are missing events, this will be cleaned up in the near future. If you need something specific added sooner than that, post a GitHub issue for it and I'll patch it in.
    I'm likely to separate Green Thumb into two distinct skills in an upcoming patch
    Only Green Thumb/Shroom Thumb trigger the new SubSkillBlockEvent for now

Version 2.1.173
    The experience orbs dropped by Knock on Wood rank 2 during Tree Feller are now much less frequent but provide more XP
    mcMMO no longer damages fishing rods or drains a player's hunger when fishing
    Fixed a visual bug where players who had lucky perk were shown incorrect odds when using skill commands (such as /axes)
    Updated ja_JP locale (thanks ViaSnake)
    Fixed a bug where scoreboards were torn down inappropriately when moving to or from blacklisted worlds (thanks steve4744)
    Updated Kyori's adventure library to 4.4.0 (used by mcMMO to handle text components)

Version 2.1.172
    Updated german locale (thanks TheBusyBiscuit)
    Added 'mcmmo.broadcast.levelup' permission node, if a player lacks this node they will not have their level up milestones broadcast to chat, this is a default permission node
    Power Levels are now included in level up broadcasts and they have their own settings (mirroring the existing settings for skill broadcasts)
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Enabled' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Milestone_Interval' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Broadcast_Targets.Send_To_Console' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Broadcast_Targets.Only_Party_Members' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Broadcast_Targets.Only_Same_World' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Broadcast_Targets.Distance_Restrictions.Restrict_Distance' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Powerlevels.Broadcast_Targets.Distance_Restrictions.Restricted_Radius' to config.yml
    Added 'Broadcasts.PowerLevelUpMilestone' to locale
    You can now disable the XP orbs from being dropped when Knock On Wood triggers during Tree Feller
    Added 'Skills.Woodcutting.TreeFeller.Knock_On_Wood.Add_XP_Orbs_To_Drops' to advanced.yml
    Changed Fists to not be capitalized (en_US) when lowering/readying berserk
    SkillActivationPerkEvent can now be called in async threads (thanks electronicboy)
    Removed a few never implemented settings from Skills.Woodcutting.TreeFeller in advanced.yml
    Updated bStats (thanks TheBusyBiscuit)
    Fixed some incorrect reporting to bStats (I'm so dyslexic...)

    NOTES:
    The new 'mcmmo.broadcast.levelup' node is a default node included under the 'mcmmo.defaults' node umbrella, you shouldn't have to give this to your players unless they don't have access to 'mcmmo.defaults'
    If you don't have a permission plugin you don't need to worry, players will have this node by default in that case
    There are situations where level up broadcasts will be skipped, for example if you go from level 0 -> 101 via addlevels or mmmoedit, and your broadcast interval is 100, it will be skipped as 101 falls out of this interval, this kind of skip only applies to command based leveling. Players gaining levels naturally should never have their broadcasts skipped. I'll fix this particular interaction in the future so that command based leveling never skips over milestone broadcasts, but for now it does.

Version 2.1.171
    Fixed a bug where arrows shot by infinite bow enchant would duplicate
    Fixed a bug where Archery XP would calculate incorrectly
    Axes can now replant cocoa plants (thanks Lyther)
    Players who level up at certain milestones have their level ups broadcast to the server (very configurable and optional, see notes)
    New locale string 'Broadcasts.LevelUpMilestone'
    Added 'General.Level_Up_Chat_Broadcasts.Enabled' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Milestone_Interval' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Targets.Send_To_Console' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Targets.Only_Party_Members' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Targets.Only_Same_World' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Targets.Distance_Restrictions.Restrict_Distance' to config.yml
    Added 'General.Level_Up_Chat_Broadcasts.Broadcast_Targets.Distance_Restrictions.Restricted_Radius' to config.yml

    NOTES:
    The new broadcast system is very configurable, you could set the milestone interval to 1 if you want players to always be informed when someone levels up
    With default settings, messages are broadcast to all players on all worlds and to the server console when a player hits a level up that is a 100 interval, for example level 100, 300, 600, 2200 would all qualify
    You can change the settings to specify who receives these messages or turn the whole system off
    The message is customizable via locale: https://mcmmo.org/wiki/Locale
    There are comments in config.yml above each setting (as long as YAML doesn't move comments around chaotically...) that explain each setting
    In case your comments are missing, here's what they look like by default: https://gist.github.com/nossr50/baf656477c75663e9e2f9284acee8d67


Version 2.1.170
    Reverted a change that broke compatibility with the mcMMO papi ecloud thingy

Version 2.1.169
    Fixed a few memory leaks involving arrows
    Fixed mcMMO inappropriately assigning metadata to projectiles not fired from players
    Fix mctop not working if locale was set to something other than en_US
    mcMMO will now always emulate lure in order to stack it correctly and avoid vanilla bugs

Version 2.1.168
    Fixed an IndexOutOfBoundsException error when trying to access UserBlockTracker from an invalid range (thanks t00thpick1)
    (API) UserBlockTracker is now the interface by which our block-tracker will be known (thanks t00thpick1)
    Optimized memory access for Acrobatics fall anti-exploit mechanics (thanks t00thpick1)

Version 2.1.167
    Fixed a serious dupe bug
    Add McMMOPlayerPreXpGainEvent event for plugins to modify given exp (thanks electronicboy)
    Add SkillActivationPerkEvent (thanks electronicboy)

    NOTE:
    This bug was introduced in 2.1.165, update immediately if you are on 2.1.165 or 2.1.166

Version 2.1.166
    Fixed a small memory leak in the new COTW tracker
    Potentially fixed a ConcurrentModificationException involving the TransientEntityTracker (report this error if you encounter it)
    Music discs removed from the default fishing_treasures.yml
    Optimized how mcMMO saves player data (should improve timings on servers with bad disk speeds and or bad connectivity to their SQL server instance)

    NOTES:
    No one likes fishing up music discs, if you want this change it is recommended you delete fishing_treasures.yml and let it regenerate
    (You won't have this file if you haven't updated in a while, if so you don't need to do anything)
    If any of you encounter a ConcurrentModificationException error that mentions TransientEntityTracker in its stack trace after this update let me know, I have another fix in mind for this if this update didn't fix it.

Version 2.1.165
    Fixed a bug where Enchanted Books dropped by mcMMO (in Fishing) did not function correctly
    The mcMMO system which tracks player placed blocks has had some major rewrites (thanks t00thpick1)
    Optimized our ChunkUnloadEvent, this should improve timings in this area
    How mcMMO tracks COTW entities has been rewritten
    When COTW summons are killed players are now informed (from anything other than the time expiring).
    mcMMO will now be compatible with changes to world height (1.17 compatibility)
    mcMMO will ignore EntityPickupItemEvents from "Fake-Player" NPCs if it recognizes them as such, this will prevent some compatibility issues with some plugins
    SuperBreaker will now always activate if the target blocks fastest tool is a Pickaxe (used to require the block giving XP or being considered an ore)
    Master Angler mentions that it works better with a boat in its hover tip
    Added missing cooldown locale message 'Commands.Database.Cooldown'
    Added new locale message 'Taming.Summon.COTW.Removed'
    Updated locale entry 'Fishing.SubSkill.MasterAngler.Description'

    NOTES:
    Books dropped before this fix will not be usable and should just be chucked in lava, the broken books have blue names, the working books have yellow names.
    t00thpick1 has taken time to rewrite our block meta tracking system to be more efficient, easier to maintain, and support upcoming features such as world height changes
    This new system is compatible with the old one, it will convert old files to the new format as needed. You won't even know it is doing anything.
    This update shouldn't break anything as the API is the same.

    Alright back to work on T&C unless some major bugs come out of this...

Version 2.1.164
    mcMMO will now let players use vanilla blocks that have interactions (such as the vanilla Anvil) which are assigned as either Repair or Salvage blocks if a player is sneaking (see notes)
    The Rarity known as Records has been renamed to Mythic
    Fishing treasures have been moved from treasures.yml -> fishing_treasures.yml, copy over any custom entries you had from treasures.yml carefully as the config file has changed and you can't just copy paste your old entries without making a few edits
    Added Enchanted Books to fishing_treasures.yml as Legendary rarity (can drop with any legal enchantment - see notes)
    Added all Netherite gear to the Mythic rarity in fishing_treasures.yml
    Added Name Tag to fishing_treasures.yml as Rare rarity
    Added Netherite Scrap to fishing_treasures.yml as Legendary rarity
    Added Nautilus Shell to fishing_treasures.yml as Legendary rarity
    Music Disc rarity in fishing_tresures.yml has been broken up across tiers, they will be more common now.
    Mythic rarity (formerly known as Records) now allows for Enchantments to be applied to drops (See Notes)
    New exploit fix setting 'PreventPluginNPCInteraction' which defaults to true, when disabled it will allow combat interactions with "NPC" entities from plugins like Citizens
    ExploitFix.PreventPluginNPCInteraction Added to experience.yml
    Modified locale string 'Fishing.SubSkill.TreasureHunter.Stat.Extra' in existing locale files
    You can now define a whitelist of enchants or a blacklist of enchants for an Enchanted_Book entries in fishing_treasures.yml, see notes for an example

    NOTES:
    Before reading, Fishing/Excavation are getting a complete loot table rewrite in the future, everything changed in this patch is meant as a temporary quality of life fix until the bigger better change in the future.
    There's no real reason to allow for vanilla treasures anymore, so if you were using the vanilla treasure override I suggest turning it off.
    You can't add Enchanted_Book to any treasures outside of Fishing's treasure drops right now, I'll fix it in an upcoming patch. Well you can add it, but it won't work.
    The rarity formerly known as 'Records' was odd to me, if you got the best possible drop it was always going to be a Music Record drop (using the default mcMMO treasure list), and by default the Records tier had only music records. It was treated differently in the code as well, for example Records drops never had enchantments applied to them. So you could add say NETHERITE_ARMOR to them in your user config and it would never put enchantments on it, that seemed very odd to me.
    As a response to this, I've renamed Records as Mythic, I've moved the records into varying tiers, you'll start getting them much earlier now. I've also added Netherite and Enchanted Books to the Mythic tier.
    Enchanted Books have been added to Fishing loot, this is a basic hacky work around until the config update comes. Enchanted books can have any legal enchant and you can specify which Enchants a book can spawn with.
    Also the Enchantment chance to be applied to the book is completely equal across all enchantments, it does not follow the same logic as applying enchantments to fished up gear.

    Here is an example of using the whitelist or blacklist for an Enchanted_Book entry in fishing_treasures.yml
    https://gist.github.com/nossr50/4e15b8ba6915b5a5f516eccfba2d7169
    If you can't load this image, at the address of your treasure for example, at Fishing.Enchanted_Book.Enchantments_Blacklist: you define a list (which must follow yaml spec, google yaml linter) of enchants to disallow, likewise at Fishing.Enchanted_Book.Enchantments_Whitelist you can setup a whitelist, if neither is defined then the book can spawn with all possible enchants, if both are defined the whitelist is used instead of the blacklist
    Take care when moving any fishing entries you may have defined in treasures.yml over to fishing_treasures.yml, the config file has had a few things changed (as noted in these notes).

    When talking about NPCs in the below notes, I am referring to "Fake" Players used in plugins such as Citizens, not Villagers from Vanilla Minecraft or anything labeled NPC in another plugin which does not constitute a "Fake Player"
    Historically mcMMO has checked an entity for being a Fake-Player-NPC and backed out of any interaction, this was originally done because of Fake-Player-NPCs that were meant to be invincible/etc and not give XP
    However nowadays what a Fake-Player-NPC is used for is pretty loose, mcMMO only has definitions for some NPCs (such as from Citizens) it doesn't know about most Fake-Player-NPCs in most plugins unless they identify themselves in a similar way to the predefined parameters
    Leave this new exploit fix setting on true unless you understand the implications

    If you only ran mcMMO on your server you'd have no way to use Enchanted Books if you set the repair anvil to the vanilla anvil, so now you can sneak to open up its menu. By the way, mcMMO has the vanilla anvil as repair's default anvil (instead of iron block which it had been historically).
Version 2.1.163
    Fixed the translate URL pointing to the wrong place (thanks chew)
    Fixed a bug where FlatFile databases would always attempt a UUID conversion task every save operation (every 10 minutes) causing console spam
    mcMMO will no longer throw errors when incoming XP is below 0 (it will just silently cancel the operation)
    COTW Summoned entities are now removed when the chunk they are in is unloaded (prevents some exploits)

    NOTES:
    Seems I skipped releasing 2.1.162, not a big deal though as you should be using this version instead!
    I often test in SQL environments so I missed this bug, reminder to come bother me on discord if you find any annoying bugs!
    Also work on T&C is going great lately, I feel great. Perhaps my depression is getting better!

Version 2.1.162
    Fixed a bug where Alchemy brew events were processed after setting brew results (thanks Wolf2323)

Version 2.1.161
    Fixed a bug where a bunch of text from mcMMO was never being sent and or being sent as blank messages

    NOTES:
    Adventure (the chat library we use) had an update that required shading in another new module, but there were no errors thrown without running a jvm debug flag and testing it, which is why I missed it. I also missed it because I don't read update notes very closely
Version 2.1.160
    Fixed another 9+ year old exploit
    Silenced a harmless "error" related to Rupture/Bleed often produced when using mcMMO and crazy enchantments together

Version 2.1.159
    Fixed a memory leak involving renamed mobs
    Updated Adventure library (used in our chat code)

Version 2.1.158
    Fixed a bug where Lure level 4 and above would break fishing with the new Master Angler
    URLs in party/admin chat work again (use https:// in front to make links clickable)
    Updated nl locale (thanks xl3ehindTim)
    * Added Crossbow to string repairables (Thanks Momshroom)
    * Added Shield to wood repairables, with oak planks as material (Thanks Momshroom)
    * Added Elytra and Trident to Other repairables, using phantom membrane and prismarine crystals respectively. (Thanks Momshroom)

    NOTES:
    * You'll need to update repair.vanilla.yml yourself or delete the file and regenerate it (lazy easy way).
    Links in party/admin chat might not be clickable without https:// added in front of the url
    Added some stuff to Repair, a rework to Repair is coming in the future, this stuff will work for now as a placeholder.
    Master Angler will emulate the effects of Lure if the level is higher than 3 instead of attempting to stack with it to avoid a vanilla Minecraft bug where fish are never caught

Version 2.1.157
    Fixed a NPE that prevented mctop (Leaderboards) from working

Version 2.1.156
    Added Woodcutting skill 'Knock on Wood' - This ability gives you goodies (saplings, xp orbs, apples, etc) when using Tree Feller
    Tree Feller no longer gives non-wood items by default, it now requires Knock on Wood for additional loot
    When you raise your axe you will now see information about any super abilities on CD
    Fixed a bug where Green Thumb would replant blocks floating in the air
    Fixed a bug where the admin and party chat toggles in chat.yml didn't function as intended
    * Fixed a bug where Master Angler rank 1 level requirement was set too high (default configs)
    Added some errors that trigger if a plugin hooking into mcMMO is grabbing leaderboards for child skills through our SQL/FlatFile class (which don't exist)
    mcMMO will automatically fix some errors in logic for user settings in skillranks.yml
    Corrected some logic errors when checking for oddities in skillranks.yml
    Removed incorrect translations of Master Angler from various locales
    Modified Master Angler stat lines in /fishing
    Updated Green Thumb description to mention that it needs a hoe
    'Abilities.Limits.Tree_Feller_Threshold' in config.yml now defaults to 1000 instead of 500 (edit your config)
    Added new permission node 'mcmmo.ability.woodcutting.knockonwood'
    Added new locale line 'Woodcutting.SubSkill.KnockOnWood.Name'
    Added new locale line 'Woodcutting.SubSkill.KnockOnWood.Stat'
    Added new locale line 'Woodcutting.SubSkill.KnockOnWood.Description'
    Added new locale line 'Woodcutting.SubSkill.KnockOnWood.Loot.Normal'
    Added new locale line 'Woodcutting.SubSkill.KnockOnWood.Loot.Rank2'

    NOTES:
    You don't need to touch your config files unless you want to get the new tree feller threshold (1000 instead of 500), you could also delete config.yml and regenerate it, for all the other config changes in this update, they are handled automagically.
    * - If you haven't manually edited your Master Angler entries in skillranks.yml then the previous mcMMO update has rank 1 for Master Angler too high, this update automatically fixes it.
    You may have noticed sometimes config file entries are in a strange jumbled order, yeah that's "normal". We'll be moving to HOCON for the config update and wont' have to deal with this crap for much longer.
    I'll probably be doing a bunch of tweaks to mcMMO UI in the near future, I don't know, or I'll work on T&C

Version 2.1.155
    Master Angler now has 8 ranks
    Master Angler is now supported by the latest builds of Spigot on 1.16.4
    Wolves will now earn a lot more XP from combat than before (Wolves are going to be tweaked a lot in the near future)
    Fixed a bug where Spectral Arrow awarded too much XP
    Fixed a bug where party members other than the party leader had names that weren't properly hex colored
    Added 'Skills.Fishing.MasterAngler.Tick_Reduction_Per_Rank.Min_Wait' to advanced.yml
    Added 'Skills.Fishing.MasterAngler.Tick_Reduction_Per_Rank.Max_Wait' to advanced.yml
    Added 'Skills.Fishing.MasterAngler.Boat_Tick_Reduction.Max_Wait' to advanced.yml
    Added 'Skills.Fishing.MasterAngler.Boat_Tick_Reduction.Min_Wait' to advanced.yml
    Added 'Skills.Fishing.MasterAngler.Tick_Reduction_Caps.Min_Wait' to advanced.yml
    Added 'Skills.Fishing.MasterAngler.Tick_Reduction_Caps.Max_Wait' to advanced.yml
    Removed Skills.Fishing.MasterAngler.BoatModifier from advanced.yml
    Removed Skills.Fishing.MasterAngler.BoatModifier from advanced.yml
    Optimized party/admin chat a bit
    Added some misc safeguards against possible NPEs
    Added some debug output when fishing if mmodebug is on
    (API) Removed AbstractPlayerAuthor#getComponentDisplayName
    (API) Removed AbstractPlayerAuthor#getComponentUserName
    (API) Removed Author#getAuthoredComponentName

    NOTES:
    Master Angler won't work if you aren't on 1.16.4, the truth is it hasn't worked for a very long time (Since before 1.13.2)
    The Spigot API related to it has been broken since years and years ago, and they finally updated the API but it is only in the newest builds of Spigot.
    If you are on something that doesn't support the new Master Angler that skill will be missing when you type /fishing
    The boat bonus for master angler is static and doesn't improve when leveling master angler.
    All the new master angler stuff is configurable and can be found in advanced.yml
    The configurable reduction tick stuff for master angler is multiplied by the rank level when determining the final bonus (use /mmodebug when fishing to see some details)
    Master Angler stacks with the Lure enchant
    Removed some unnecessary API, we aren't a chat plugin so these things shouldn't be here.
    Slowly adding Nullability annotations to the codebase

Version 2.1.154
    Hex colors are now supported in Party & Admin chat
    Added support for &#RRGGBB color codes (hex colors) in chat and nicknames for party and admin chat
    Added hex colored nickname support to admin/party chat
    Fixed a bug where Tree Feller was not dropping some items like saplings
    Fixed a bug where using admin chat would in some circumstances throw a NPE
    (API) Author class has been reworked
    (API) McMMOChatEvent::getSender removed (use getDisplayName() instead)
    (API) McMMMOChatEvent::setDisplayName() removed
    (API) Removed Author::setName use Player::SetDisplayName instead
    (API) Modified Author::getAuthoredName signature to -> Author::getAuthoredName(ChatChannel)
    (API) Added Author::getAuthoredComponentName(ChatChannel)
    (API) PartyAuthor and AdminAuthor removed, replaced by PlayerAuthor
    (API) Probably some more undocumented changes that I'm forgetting...

Notes:
    For example '/p &#ccFF33hi guys' will send a message colored in hex colors
    You'll see ~§x in console when hex color codes are used, this is a quirk of how the 'adventure' library we are using is handling some bungee component related things, so it's outside of my hands for now

Version 2.1.153
    Fixed a bug where most sub-skills were not being displayed when using a skills command (for example /taming)
    Fixed a bug where some URL links were not being colored
    Updated fr locale (thanks Vlammar)

Version 2.1.152
    Fixed a bug where Tree Feller would sometimes double drop blocks inappropriately
    Fixed a bug with bleed damage calculations and player armor
    Added some code to prevent a possible NPE when spawning items in a world that got unloaded
    Added the missing 'pc' alias for party chat
    Added the missing 'ac' alias for admin chat
    (API) New ENUM ItemSpawnReason which gives context for why mcMMO is dropping an item
    (API) McMMOItemSpawnEvent::getItemSpawnReason() was added
    (API) Many instances of spawning items that didn't used to create and call an McMMOItemSpawnEvent now do
    Updated hu_HU locale (thanks andris)

    NOTES:
    I really should stop letting my OCD compel me to rewrite code all the time.
    Bleed was meant to do reduced damage to players wearing 4 pieces of armor or more, it was incorrectly counting everyone as wearing 4 pieces even when they weren't.
    This means Bleed was doing a bit less damage than was intended against players without a full set of armor equipped.

Version 2.1.151
    Added new config for chat options named 'chat.yml'
    Added 'Chat.Channels.Party.Spies.Automatically_Enable_Spying' to chat.yml which when enabled will start users who have the chat spy permission in chat spying mode
    All chat settings that used to be in 'config.yml' are now in 'chat.yml'
    The list of party members shown when using the party command has been simplified, this will change again in the T&C update
    Fixed a bug where players could use the party chat command without the party chat permission
    Party Leaders now use a different style when chatting than normal party members (can be customized)
    Added 'Chat.Style.Party.Leader' to the locale, party leaders use this as their chat style

    NOTES:
    I greatly disliked the old party member list but was avoiding rewriting it until later, someone pointed out how ugly it was and my OCD triggered and now it is rewritten. I will rewrite it again in Tridents & Crossbows.
    The new config file lets you disable the chat system (you can disable all of it, or just party chat, and or just admin chat) without permission nodes.
    If you disable the party/admin chat, then the party/admin chat command never gets registered and attempting to use the command will result in a whole lot of nothing, so if you want users to have a permission denied message then just stick to negating permission nodes.
    I'll probably be tweaking mcMMO visually a lot in the near future, probably after Tridents & Crossbows goes out.
    I hate adding more config files using the old .yml system, but the config update is a ways out and this works for now.
    Reminder that the look/feel of party/admin chat is now determined by locale entries
    https://mcmmo.org/wiki/Locale can help you understand how to change the locale

Version 2.1.150
    Fixed an ArrayIndexOutOfBounds exception when using /skillreset
    You can now add "-s" at the end of mmoedit, addlevels, or addxp to silence the command. Which will prevent the target of the command from being informed that the command was executed.
    mcMMO should now be compatible with 1.16.4's new social features (affects Party/Admin chat)
    mcMMO Party & Admin Chat have had a complete rewrite
    Players & Console can now use color codes (including stuff like &a or [[GREEN]]) in party or admin chat
    Added new permission node 'mcmmo.chat.colors' which allows players to use color codes, negate to disallow this
    The style and look of admin/party chat is now determined by locale file instead of options in config.yml
    The default style of admin/party chat has been updated, and it may be updated again in the future
    Improved messages players receive when they toggle on or off admin or party chat
    All locale files have had 99.9% of their [[]] color codes replaced by & color codes, you can still use [[GOLD]] and stuff if you want
    Added new locale entry 'Commands.Usage.3.XP'
    Added new locale entry 'Chat.Identity.Console'
    Added new locale entry 'Chat.Style.Admin'
    Added new locale entry 'Chat.Style.Party'
    Added new locale entry 'Chat.Spy.Party'
    Added new locale entry 'Chat.Channel.On'
    Added new locale entry 'Chat.Channel.Off'
    (API) ChatAPI::getPartyChatManager() has been removed
    (API) ChatAPI::sendPartyChat has been removed (similar functionality can be found in the new ChatManager class)
    (API) ChatAPI::sendAdminChat has been removed (similar functionality can be found in the new ChatManager class)
    (API) Fake events in mcMMO now implement 'FakeEvent' (thanks TheBusyBiscuit)
    (API) Updated Adventure Library to 4.1.1
    (API) McMMOChatEvent has been reworked, plugins dependent on this event should review this class and make appropriate changes

    NOTES:
    The yet to be released Tridents & Crossbows update will also feature some new features related to party chat, so expect more tweaks to those features in the future.
    I actually spent a little over a week on this, the old code for party/admin chat was absolutely horrid and when porting in the new 1.16.4 features I couldn't stand the sight of it so I burned everything to the ground and rewrote all of it.
    The mcMMO chat events now make use of adventure library by Kyori, you can override the message payload with a TextComponent, which allows for some fancy stuff potentially.
    I'll put in some of my own fancy stuff for party and admin chat in a future update.

Version 2.1.149
    Added a new config file 'persistent_data.yml'
    Almost all persistent mob data is now off by default and needs to be turned on in persistent_data.yml (new config file) for performance concerns

NOTES:
There are some performance issues with how Spigot/MC saves NBT when you start adding NBT to mobs, because of this I have decided that the new persistent data from 2.1.148 is now opt-in.

Not every server will suffer a TPS hit when using the persistent data options, but there is a significant IO cost which can affect TPS if you have them on

I am therefore making many persistent options (the problematic ones involving mobs) opt-in so only those aware of the performance risk will be using the feature.

Persistent data on mobs was a new feature that was introduced in 2.1.148, it was not in mcMMO for the last 10 years and most of you probably didn't even know that it was missing

An example of persistent data would be, normally mcMMO would give 0 XP for a mob from a mob spawner, in the last 10 years if the server rebooted then those existing mobs would give XP again. But with the persistent data option turned on in persistentdata.yml they will be saved to disk, and mcMMO will not forget about them upon reboot.

For now it is not recommended to use persistent data without monitoring performance of ticks afterwards to make sure it was something your server could handle.

I have a solution in mind to make persistent data not so expensive, but writing the code for that will take some time. This will serve as an interim fix.

I am going to focus on Tridents & Crossbows instead of that alternative solution, so don't expect it anytime soon. Use persistent data only if you understand the potential performance cost risk.
@
Version 2.1.148
    Fixed a memory leak involving entity metadata
    Alchemy progression is now more reasonable (delete skillranks.yml or edit it yourself to receive the change, see notes)
    Made some optimizations to combat processing
    New experience multiplier labeled 'Eggs' in experience.yml with a default value of 0 (previously mobs from eggs were using the Mobspawner experience multiplier)
    New experience multiplier labeled 'Nether_Portal' in experience.yml with a default value of 0
    New experience multiplier labeled 'Player_Tamed' in experience.yml with a default value of 0
    New advanced.yml config setting 'Skills.Mining.SuperBreaker.AllowTripleDrops' defaults to true

    Fixed a bug where mobs from eggs were only tracked if it was dispensed (egg tracking now tracks from egg items as well)
    Fixed a bug where egg spawned mobs were sometimes not marked as being from an egg (used in experience multipliers)
    Fixed a bug where entities transformed by a single event (such as lightning) weren't tracked properly if there was more than one entity involved
    mmodebug now prints out some information about final damage when attacking an entity in certain circumstances

    (1.14+ required)
        Mobs spawned from mob spawners are tracked persistently and are no longer forgotten about after a restart
        Tamed mobs are tracked persistently and are no longer forgotten about after a restart
        Egg spawned mobs are tracked persistently and are no longer forgotten about after a restart
        Nether Portal spawned mobs are tracked persistently and are no longer forgotten about after a restart
        Endermen who target endermite are tracked persistently and are no longer forgotten about after a restart
        COTW spawned mobs are tracked persistently and are no longer forgotten about after a restart
        Player bred mobs are tracked persistently and are no longer forgotten about after a restart
        Player tamed mobs are tracked persistently and are no longer forgotten about after a restart

    NOTES:
    Egg mobs & Nether portal pigs being assigned to the mobspawner xp multiplier didn't make sense to me, so it has been changed. They have their own XP multipliers now.
    While working on making data persistent I stumbled upon some alarming memory leak candidates, one of them was 7 years old. Sigh.
    Alchemy now progresses much smoother, with rank 2 no longer unlocking right away. Thanks to Momshroom for pointing out this oddity. Delete skillranks.yml or edit it yourself to recieve this change.
    https://gist.github.com/nossr50/4c8efc980314781a960a3bdd7bb34f0d This link shows the new Alchemy progression in skillranks.yml feel free to copy paste (or just delete the file and regenerate it)
    There's no persistent API for entities in Spigot for 1.13.2, but in the future I'll wire up NMS and write it to NBT myself.
    This means the new persistence stuff requires 1.14.0 or higher, if you're still on 1.13.2 for now that stuff will behave like it always did

Version 2.1.147
    Fixed a bug where players below the level threshold on a hardcore mode enabled server would gain levels on death in certain circumstances

Version 2.1.146
    A bug where players would disconnect from mcMMO messages has been fixed (thanks kashike / read notes)
        It should be noted this was NOT an mcMMO bug, but a bug within Spigot since Spigot 1.16
    A dupe exploit has been fixed
    Improvements were made to tracking player placed blocks in mcMMO
    Players no longer lose levels below the level threshold in hardcore mode
    Hardcore now only applies penalties to levels above threshold

    NOTES:
    Shout out to Kashike
    Kashike is a developer on the mcMMO team, however after I recruited him had a lot of life stuff come at him and has./tn't had a chance to contribute until now!

    JSON is used by Minecraft for a lot of stuff, in this case the JSON mcMMO made use of was related to displaying text in chat or displaying text on the clients screen in other places such as the action bar, there's been a bad bug in Spigot since 1.16 that would disconnect players some of the time when sending JSON components.
    mcMMO makes heavy use of these components, so since spigot has yet to fix the bug I decided we needed a work around for the time being.
    The library named 'adventure' is developed by the Kyori organization, which is Kashike's baby.
    Kashike is a very talented and skilled developer and he did the work on this patch to solve this issue.

    This is a link to an bug report I did on this bug on Spigot's issue tracker, it is my understanding they have yet to find a way to reliably reproduce this bug.
    If you have any information please post about it in this thread.

    https://hub.spigotmc.org/jira/browse/SPIGOT-6056
    Although mcMMO solved this issue by switching to Kyori's Adventure library for sending JSON Components, most Spigot plugins have not implemented a work around like this and will continue to make players disconnect until it is solved within Spigot.

    Hardcore changes
    If you set a level threshold of 100 and player with 150 levels dies, they should never lose more than 50 levels as the first 100 are considered part of the threshold.
    Prior to this change in this exact same scenario a player could be penalized and be put below the threshold.

    Shout out to HexedHero for reporting the dupe exploit and providing a demonstration of how to replicate it

    Tridents & Crossbows update
    It is still being worked on but it won't make a September release.
    October is the new target release but I am terrible with estimates so take it with a grain of salt!


Version 2.1.145
    Reverted 'Changed one of the PlayerInteractEvent listeners to ignore cancelled events' from 2.1.144


Version 2.1.144
    Steel Arm Style damage is now customizable in advanced.yml (make sure to set override to true)
    Fixed a bug where Deflect worked against non-arrow projectiles
    Fixed a bug where Deflect was checked twice, resulting in two chances to deflect effectively
    Fixed a bug where Roll wouldn't award XP when fall height was over a certain amount
    Lowered the XP ceiling of Roll
    Fixed a NPE that would happen involving taming in combat processing
    Updated hu_HU locale (thanks andris155)
    Fixed a bug where mcMMO could erase item data on Wheat Seeds when using Green Thumb on a block
    Changed one of the PlayerInteractEvent listeners to ignore cancelled events (should improve plugin compatibility)
    mmodebug mode now prints some information when fuel efficiency is applied to a furnace

    NOTES:
    I seem to consistently find old bugs in mcMMO, this deflect bug where it was checked twice, who knows how many years its been in mcMMO, I didn't check but its probably between 5-7.
    I was waiting to make Steel Arm Customizable for the config update (due in the future), but enough people ask for it that I decided to do the extra work to put it into 2.1.XX
    Tridents & Crossbows is likely going to be in development continuing into September, I am taking my time to make it feature packed and I hope you guys will appreciate it.

Version 2.1.143
    mcMMO now tracks super ability boosted items through persistent metadata
    mcMMO no longer relies on lore to tell if an item has been modified by a super ability
    Slight buff to Rupture (1 more tick duration across all ranks)
    Lore no longer gets added to items being buffed by mcMMO./

    NOTES:
        The item tracking is persistent for MC versions 1.13-1.16.2 (and beyond). However the code handling the persistence for 1.13.2 differs from the other versions. It shouldn't result in any problems.
        Any items that currently have the old "mcMMO Ability Tool" lore on them will have that lore stripped off them and will have any dig speed enchants removed. This should only affect glitched items that never properly got their buffs removed.

Version 2.1.142
    Iron Arm Style renamed to Steel Arm Style
    Steel Arm Style now scales over 20 ranks instead of 5
    Added 'mcmmo.ability.unarmed.steelarmstyle' permission node
    Removed 'mcmmo.ability.unarmed.ironarmstyle' permission node
    Added locale entry 'Unarmed.SubSkill.SteelArmStyle.Name'
    Added locale entry 'Unarmed.SubSkill.SteelArmStyle.Description'
    Updated locale entry 'Unarmed.Ability.Bonus.0'

Version 2.1.141
    Added some missing values for 1.16.2 compatibility modes

Version 2.1.140
    Fixed a few potential issues with scoreboards
    Updated polish locale

    NOTES:
    Scoreboards code in mcMMO is pretty messy and poorly designed, I am going to rewrite it in a future update. The fixes applied in this patch should solve some problems some users were having for now.

Version 2.1.139
    Code used to fetch UUIDs was reworked to avoid a scenario where it failed (thanks t00thpick1)
    Added 'Netherite_Gold_Ore' to Smelting XP tables (thanks Quavelen)
    Added 'Gilded_Blackstone' and 'Nether_Gold_Ore' to code used to determine what can activate Super Breaker in certain situations (thanks Quavelen)
    MMOinfo for Roll was corrected (thanks emanondev)

Version 2.1.138
    Fixed a bug where Netherite weapons/tools/armor weren't applying correct values in some skill calculations

Version 2.1.137
    Added some code to avoid NPE errors when checking armor on entities

Version 2.1.136
    Furnace ownership is no longer lost when the furnace stops doing a job
    Furnaces remember owners between restarts (requires MC 1.14 or higher)

    NOTES:
        I'm making use of a Spigot API for persistent data for versions of MC 1.14 and above, for versions below the data will be temporary as it has been up until this point.
        In the future I'll wire up NMS to make use of NBT and all versions will have persistent data support.

Version 2.1.135
    Furnaces no longer simulate block break checks when assigning ownership as it caused some unwanted plugin conflicts
    Fixed an issue where Fishing would break if exploit protection was turned off for Fishing (Thanks Ineusia)
    Fixed Super abilities not being translated on scoreboards (Thanks Ineusia)
    Added option in advanced.yml to squelch ability activation messages being sent to other players via action bar (Thanks Ineusia)

Version 2.1.134
    Furnaces now change ownership to the last player who clicks in their inventory and is legally allowed to break the furnace
    Smelting now has a Bonus Drops section in config.yml
    Smelting now only doubles smelting results for items which have bonus drop entries in config.yml
    Smelting XP can now be gained offline, but all other benefits from Smelting don't happen unless you're online
    Fix brewing stand not consuming items (thanks Durburz)
    Changed the UUID updater task to not catastrophically fail when requests failed
    Fixed a bug where players could set each other on fire when partied or when PVP was disabled
    Fixed a NPE that could happen with thrown potions
    Fixed a potential NPE when damaging player armor with Axes
    Fixed a potential NPE when damaging a player with Blast Mining
    Fixed a potential NPE when checking tools related to Super Abilities
    Fixed a potential NPE when checking the Chimaera Wing
    Fixed a potential NPE when creating party member lists
    Fixed a potential NPE when fishing
    Fixed a potential NPE when players right click blocks
    Fixed a locale mistake in locale hu_HU
    Fixed a locale mistake in locale ru
    Minor code cleanup

    NOTES:
    It used to be that Furnaces would assign an owner and that would be their owner until the server shutdown, now owners will change based on who last had their hands on the furnace.
    You won't become the owner if you are not allowed to view the inventory of a furnace, or break the furnace, or interact with the contents of the furnace

Version 2.1.133
    A fix for an 'array out of bounds' error related to players clicking outside the inventory windows has been fixed
    French locale has been updated (thanks Elikill58)
    Another fix has been deployed to prevent mobs from having hearts in player death messages (thanks FrankHeijden)
    Players no longer ready their tool if they don't have access to the skill (thanks Draycia)
    Unused NMS compatibility layers have been disabled for now (expect them to be used in the future for 1.12/1.8 support stuff)

Version 2.1.132
    A fix is in place to prevent an exploit from working that is due to a yet to be patched Spigot server software bug
    Fixed a NPE that could happen when players swapped items from their hotbar

    NOTE: The exploit was not described on purpose, please update.
    I reported the bug to Spigot, so hopefully it will be patched in the near future.

Version 2.1.131

    New permission node 'mcmmo.ability.repair.netheriterepair' which is included in the mcmmo.defaults permission package
    New permission node 'mcmmo.ability.salvage.netheritesalvage' which is included in the mcmmo.defaults permission package
    Changed Salvage maximum quantity values to 4 for all Netherite armor
    mcMMO will set the default salvage quantities for netherite armor to 4 once and then never again (see notes)

    Added Basalt to Bonus Drops for Mining in config.yml (see notes)
    Added Polished Basalt to Bonus Drops for Mining in config.yml (see notes)
    Added Blackstone to Bonus Drops for Mining in config.yml (see notes)
    Added Chain to Bonus Drops for Mining in config.yml (see notes)
    Added Nether Bricks to Bonus Drops for Mining in config.yml (see notes)
    Added Red Nether Bricks to Bonus Drops for Mining in config.yml (see notes)
    Added Cracked Nether Bricks to Bonus Drops for Mining in config.yml (see notes)
    Added Chiseled Nether Bricks to Bonus Drops for Mining in config.yml (see notes)
    Added Crying Obsidian to Bonus Drops for Mining in config.yml (see notes)
    Added Gilded Blackstone to Bonus Drops for Mining in config.yml (see notes)
    Added Warped Roots to Bonus Drops for Herbalism in config.yml (see notes)
    Added Warped Stem to Bonus Drops for Herbalism in config.yml (see notes)
    Added Crimson Roots to Bonus Drops for Herbalism in config.yml (see notes)
    Added Crimson Stem to Bonus Drops for Herbalism in config.yml (see notes)
    Added Shroomlight to Bonus Drops for Herbalism in config.yml (see notes)
    Added Twisting Vines to Bonus Drops for Herbalism in config.yml (see notes)
    Added Nether Wart Block to Bonus Drops for Herbalism in config.yml (see notes)
    Added Warped Wart Block to Bonus Drops for Herbalism in config.yml (see notes)
    Added Weeping Vines to Bonus Drops for Herbalism in config.yml (see notes)
    Added Crimson Hyphae to Bonus Drops for Woodcutting in config.yml (see notes)
    Added Stripped Crimson Hyphae to Bonus Drops for Woodcutting in config.yml (see notes)
    Added Warped Hyphae to Bonus Drops for Woodcutting in config.yml (see notes)
    Added Stripped Warped Hyphae to Bonus Drops for Woodcutting in config.yml (see notes)

    Added Red Nether Bricks to Experience tables for Mining in experience.yml (see notes)
    Added Netherite to Experience tables for Repair in experience.yml (see notes)
    Added Piglin Brute to Experience tables for all combat skills in experience.yml

    Netherite now requires 100 Salvage skill (by default configs) in order to salvage
    Added the missing NMS wiring (it should be noted NMS isn't currently being used in mcMMO, but the framework is there. Working on a sideproject involving this...)

    NOTES:

    You should not need to edit your configs to receive any changes in this patch, simply starting your server is enough.
    Default salvage quantities for netherite armor were above 4 in some cases which was not intended, mcMMO will run some code to correct this once and then it will not edit the file again.
    Repair and Salvage are going to get some tweaks regarding Netherite gear really soon.
    This update adds quite a few missing entries for bonus drops, without these entries double drops on these items/blocks will not happen.


Version 2.1.130
    Fixed a bug that prevented Repair from working on the new Netherite weapons/armors
    Fixed a bug where Netherite gear used Gold Ingots to repair instead of Netherite Scraps (by default)
    mcMMO will now run a script to fix a misspelling of netherite in repair/salvage configs (script only runs once and then never again)
    mcMMO will produce a fake PlayerItemDamageEvent before damaging axes in Tree Feller execution


    NOTES:
    Early versions of 1.16 support had Netherite misspelled, the script I added executes before loading those config files to fix the spelling mistakes if it finds any
    If you are still having issues with Repair/Salvage, delete the repair and salvage .yml files in /plugins/mcMMO and restart the server

Version 2.1.129
    Added new subcommand /mmoxpbar disable - Hides all mcMMO XP bars
    New locale string 'Commands.XPBar.DisableAll'
    Added Blackstone to Mining experience tables
    Added Chain to Mining experience tables
    Added Bone Block to Mining experience tables
    Added Cracked Nether Bricks to Mining experience tables
    Added Chiseled Nether Bricks to Mining experience tables
    Added Crying Obsidian to Mining experience tables
    Added Gilded Blackstone to Mining experience tables
    Added Crimson Hyphae to Woodcutting experience tables
    Added Stripped Crimson Hyphae to Woodcutting experience tables
    Added Warped Hyphae to Woodcutting experience tables
    Added Stripped Warped Hyphae to Woodcutting experience tables
    Added Shroomlight to Herbalism experience tables
    Added Zoglin to combat experience tables
    Added Redstone Dust to bonus drops for Mining ( edit config.yml )
    Lodestone will now be ignored for activating abilities
    Respawn Anchor will now be ignored for activating abilities
    Soul Campfire will now be ignored for activating abilities

    Edit your experience.yml or delete it to generate a new one
    Edit config.yml and add Redstone_Dust under bonus drops for Mining, you could delete it to generate a new one but MySQL data is stored here

    Default experience.yml looks like this now: https://raw.githubusercontent.com/mcMMO-Dev/mcMMO/master/src/main/resources/experience.yml

Version 2.1.128
    The first rank of Iron Arm for Unarmed now only gives 1.5 bonus damage instead of 4 (other ranks are the same as before)
    Blast Mining nerf reverted
    Fixed a bug where debris were not reduced from Blast Mining skills
    Fixed a bug where certain types of ore did not receive bonuses from Blast Mining
    Fixed a few locale errors with commands
    (API) Added ExperienceAPI::addCombatXP for adding combat XP to players, signature may change so its deprecated for now
    mcMMO now logs whether its using FlatFile or SQL database on load
    (1.16) Strider added to combat experience with a value of 1.2

    NOTES: A more thorough look at Unarmed balance will happen in the future, the intention of this nerf is to make Unarmed less rewarding until it is leveled quite a bit.
    I do plan to add saving XP bar settings to an upcoming version of mcMMO, but I'm working on another thing for mcMMO atm.

Version 2.1.127
    Child Skills now have XP bars, they are hidden by default
    Updated hu_HU locale (thanks andris155)
    Updated korean locale (thanks GownHeeJun)
    Fixed a potential resource leak (thanks f1xme)
    Fixed some potential chunk bugs (thanks f1xme)


    NOTES:
    You can enable the child skill bars with the command /mmoxpbar <skill> show

Version 2.1.126
    mcMMO now relies on NMS for some of its features, if NMS cannot properly be wired up when initializing mcMMO behaviours relying on NMS will either be partially supported or disabled
    mcMMO now has a compatibility mode, any features that require specific versions of Minecraft for full functionality will be disabled if your server is not running a compatible version, mcMMO will still function in compatibility mode, but either the feature will be modified or disabled depending on the version of the server software
    New command /mmocompat - Shows information about whether mcMMO is fully functional or if some features are disabled due to the server software not being fully supported. Can be used by players or console.
    New command /mmoxpbar (alias /xpbarsettings) - Players can choose to always show XP bars or to never show XP bars on a per skill basis
    XPBars now last for 3 seconds before hiding instead of 2 seconds
    Fixed an exploit involving fishing rods
    mcMMO is now less verbose about unsupported materials found in configs

    New locale strings
        Commands.Description.mmoxpbar
        Commands.Description.mmocompat
        Commands.XPBar.Reset
        Commands.XPBar.SettingChanged
        Compatibility.Layer.Unsupported
        Compatibility.Layer.PartialSupport


    Notes:
        There are no features that rely on NMS in this version, it took a lot of work to write the NMS framework and I'm going to delay implementation for future versions.
        /mmoxpbar (or /xpbarsettings) example usages
            /mmoxpbar show archery - Always show archery XP bar
            /mmoxpbar hide acrobatics - Never show acrobatics XP bar
            /mmoxpbar reset - Reset all settings related to XP bars (hide/show)

Version 2.1.125
    *Fixed a bug where you could not place blocks on top of certain repair/salvage anvils

    Notes: You won't be able to place blocks on top of stuff that has an interactable component if its setup as an anvil for either Repair or Salvage, for example if you set the vanilla minecraft anvil to Repair, you won't be able to place blocks on top of that. If the repair anvil is still set to iron block then you can now place blocks on it again.

Version 2.1.124
    Repair/Salvage can now be set to use vanilla blocks that already do something and that vanilla functionality will be disabled by mcMMO (you could use vanilla-anvils instead of iron_blocks for repair now)
    Added Gold_Nugget to Mining's Bonus_Drops in config.yml (edit your config)
    Added Piglin to experience.yml combat XP tables with a value of 2.0 (edit your config)
    Added Hoglin to experience.yml combat XP tables with a value of 4.0 (edit your config)
    Added Zombified_Piglin & Zombie_Pigman to experience.yml combat XP tables with a value of 3.0 (edit your config)

    For this update either edit experience.yml and config.yml manually or delete them to regenerate, keep in mind config.yml has MySQL settings so don't delete it carelessly.


Version 2.1.123
    Added 'Nether_Gold_Ore' to Mining XP tables in experience.yml with a value of 1300
    Adept Salvage message will now show the correct minimum level
    'Weeping_Vines' renamed to 'Weeping_Vines_Plant' in experience.yml (no edits necessary)
    'Twisted_Vines_Plant' added to Herbalism XP tables in experience.yml with a value of 10
    Weeping_Vines_Plant and Twisted_Vines_Plant are now flagged as multi-block plants in Herbalism

Version 2.1.122
    Changed the xp values for Nether_Wart_Block and Warped_Wart_Block from 20 to 1 for Woodcutting
    Changed the xp values for Nether_Wart_Block and Warped_Wart_Block from 20 to 3 for Herbalism
    mcMMO now treats Nether_Wart_Block and Warped_Wart_Block as leaves
    Removed Crimson_Roots and Warped_Roots from Woodcutting XP tables in experience.yml
    Added Crimson_Roots and Warped_Roots to Herbalism XP tables in experience.yml with a value of 6 XP
    Fixed some start up bugs for salvage/repair

    You can either edit experience.yml yourself or delete it to regenerate a new one to get the new changes

Version 2.1.121
    Fixed a netherite related bug that prevented mcMMO from functioning correctly

Version 2.1.120
    Fixed a bug involving the new netherite equipment

Version 2.1.119
    1.16 Support
    Fixed another dupe bug
    Fixed a bug that can cause blast mining to give out more rewards than intended
    Blast Mining rewards are now randomized but still influenced by your blast mining rank
    mcMMO is now aware of turtle shell and treats it appropriately
    mcMMO is now aware of chainmail armor and treats it appropriately
    Calculations which change depend on the quality of your tool or armor has had netherrack support coded in
    All excavation drops that can drop from soul_sand now also drop from soul_soil (edited treasures.yml)

    Added netherite armor/weapons/tools to repair.vanilla.yml
    Added netherite armor/weapons/tools to salvage.vanilla.yml

    Added 'Bamboo_Sapling' to bonus drops for Herbalism in experience.yml
    Added 'Ancient_Debris' with a value of 7777 to Mining experience tables in experience.yml
    Added 'Basalt' with a value of 40 to Mining experience tables in experience.yml
    Added 'Crimson_Fungus' with a value of 50 to Herbalism experience tables in experience.yml
    Added 'Warped_Fungus' with a value of 50 to Herbalism experience tables in experience.yml
    Added 'Warped_Nylium' with a value of 5 to Mining experience tables in experience.yml
    Added 'Crimson_Nylium' with a value of 5 to Mining experience tables in experience.yml
    Added 'Crimson_Stem' with a value of 35 to Woodcutting experience tables in experience.yml
    Added 'Crimson_Roots' with a value of 35 to Woodcutting experience tables in experience.yml
    Added 'Warped_Stem' with a value of 35 to Woodcutting experience tables in experience.yml
    Added 'Warped_Roots' with a value of 35 to Woodcutting experience tables in experience.yml
    Added 'Ancient_Debris' with a value of 200 to Smelting experience tables in experience.yml
    Added 'Nether_Sprouts' with a value of 10 to Herbalism experience tables in experience.yml
    Added 'Shroomlight' with a value of 100 to Woodcutting experience tables in experience.yml
    Added 'Soul_Soil' with a value of 50 to Excavation experience tables in experience.yml
    Added 'Nether_Wart_Block' with a value of 20 to Woodcutting experience tables in experience.yml
    Added 'Nether_Wart_Block' with a value of 20 to Herbalism experience tables in experience.yml
    Added 'Warped_Wart_Block' with a value of 20 to Woodcutting experience tables in experience.yml
    Added 'Warped_Wart_Block' with a value of 20 to Herbalism experience tables in experience.yml
    Added 'Weeping_Vines' with a value of 10 to Herbalism experience tables in experience.yml

    Added 'Ancient_Debris' to bonus drops for Mining in config.yml
    Added 'Netherite_Scrap' to bonus drops for Mining in config.yml
    Added 'Crimson_Fungus' to bonus drops for Herbalism in config.yml
    Added 'Warped_Fungus' to bonus drops for Herbalism in config.yml
    Added 'Warped_Nylium' to bonus drops for Mining in config.yml
    Added 'Crimson_Nylium' to bonus drops for Mining in config.yml
    Added 'Crimson_Stem' to bonus drops for Woodcutting in config.yml
    Added 'Warped_Stem' to bonus drops for Woodcutting in config.yml
    Added 'Shroomlight' to bonus drops for Woodcutting in config.yml

    NOTES: You will likely need to update repair.vanilla.yml, salvage.vanilla.yml and treasures.yml
    You can just delete those config files to regenerate them fresh which is much faster if you don't have any custom settings in those files
    Here are the default configuration files if you wish to compare them to your own servers settings while updating your configs.
    https://paste.gg/p/anonymous/bf8ba1a24c8c4f188da5f8b8ebfc2b35 (Keep scrolling)

    Netherrack is repaired using netherrack scraps for now, wait for 2.2 for a better version of repair.
    Netherrack salvages into netherrack scraps for now, wait for 2.2 for a better version of salvage.

    Repairing chainmail/etc will be tackled in 2.2 so don't expect that in this version


Version 2.1.118
    Fixed another dupe bug
    Blast Mining no longer reduces debris from explosions due to some issues with the Bukkit API
    Modified locale string 'Mining.Blast.Effect' to remove debris reduction mention
    Rupture now fires a FakeEntityDamageByEntityEvent before damaging its victims (cancelling it will be ignored)

Version 2.1.117
    Fixed a rare http error when polling Mojang for UUIDs
    Fixed a bug that allowed duping

Version 2.1.116
    Fixed directional plants not maintaining their direction when replanted

Version 2.1.115
    Green Thumb now requires a hoe to activate
    Hoes no longer give free replants
    You can sneak to break plants with a hoe in your hand (or just put the hoe away)
    Using a hoe on non-fully grown crops will replant them as a convenience feature
    New sound option in sounds.yml called 'ITEM_CONSUMED', plays when eating seeds for Green Thumb
    Cocoa plants now require GT of at least 2 to start at the second stage of growth
    Green Terra now boosts growth on Green Thumb by 1 stage (doesn't go above the maximum value though)
    There is now a feature in place to prevent breaking a newly automatically replanted (via green thumb) crop from being breakable for a few seconds after it appears
    Fixed a bug where Salvage always gave the best results
    Fixed an issue with arrows causing exceptions with players not yet having data loaded
    Spectral arrows are now tracked by mcMMO
    Use minimum level of salvageable properly
    Fix Axes Critical Strikes default permissions ( new fixed permission: mcmmo.ability.axes.criticalstrikes )
    Fix potential null pointer exception for salvage
    Updated locale entry 'Herbalism.SubSkill.GreenTerra.Description'

Version 2.1.114
    Fix some more locale usages, should aim to further prevent issues with oddball locales
    Fixed a bug where newer versions of MySQL did not like our rank command
    Added a new setting to turn off the Snow Golem Exploit prevention to experience.yml next to the other exploit fixes
    Fixed a bug which stopped the optional Endermite XP exploit fix from working

Version 2.1.113
    Activating Berserk on a soft block (glass, snow, dirts) will break that material right away instead of only breaking subsequent blocks hit by the player
    Berserk will now break glass and glass pane blocks
    Hitting glass with berserk readied will activate it
    Added GLASS settings to sounds.yml for Berserk
    Fixed bug where BlockCracker didn't work on infested_stone_bricks
    Fixed a bug where beacons could be duplicated
    Check player's PTP world permissions before executing a party teleport
    Improved how mcMMO handles randomness

Version 2.1.112
    Correct locale usage for enum access, now enforces using the english locale to prevent issues with oddball locales for configs/commands
    Fixed a NPE that can occur if a player engages in combat with specific skills before their profile is loaded
    mcMMO is now more compatible with certain mob stacking plugins
    Improved behaviour for mob health bars
    Archery's Skill Shot bonus damage is now multiplicative instead of additive (nerfing early game skill shot ranks)
    Sweet Berry Bush's default Herbalism XP is now 50 instead of 300 (Update your experience.yml or delete it to generate a new one)

Version 2.1.111
    mcMMO is compatible with the following versions of MC: 1.15 / 1.14.4 / 1.14.3 / 1.14.2 / 1.14.1 / 1.14 / 1.13.2
    Further prevent nesting of bleed damage calls
    Warn about reparable/salvage configs with missing sections
    Added Bee combat experience modifier to experience.yml (Update your experience.yml file, see notes)
    Breaking a Bee Nest will result in Herbalism XP (Update your experience.yml file, see notes)
    Breeding bees will now result in Taming XP (Update your experience.yml file, see notes)

    NOTES:
        You will need to update your experience.yml by hand or delete it to get XP from new things in 1.15
        The default version of mcMMO's experience.yml looks like this: https://paste.gg/p/anonymous/15c34df6e60d45d9a3508b379a5e6514
        You'll want to add Bee to combat XP section, and Bee_Nest to Herbalism XP, and Bee to Taming XP section.

Version 2.1.110
    Fixed a dupe bug
    Actually fixed Block Cracker
    You can now crack Infested Stone Bricks with Block Cracker
    Added Lithuanian locale (thanks Vyciokazz)

Version 2.1.109
    Block Cracker will now correctly crack stone_bricks during Berserk again
    Added Lily_Of_The_Valley to the Bonus Drops list in config.yml (you'll probably want to add this manually) which enables it to double drop
    Added missing 1.14 blocks to ability/tool activation blacklists
    Fixed spamming of incompatible worldguard version message
    Updated Italian locale (thanks Fabrimat)

Version 2.1.108
    Fixed an amusing exploit for easy leveling in Acrobatics
    mcMMO should no longer break if FAWE is being used in conjunction with WG on the server
    Improved WG compatibility, mcMMO will now check if WG has loaded properly before hooking into it, which will prevent mcMMO from breaking if WG could not load properly.
    mcMMO now loads after worlds do during start up (which is what it should be doing)

    NOTES:
    Mobs will now only reward Dodge XP a certain amount of times
    You can turn off this exploit prevention by disabling ExploitFix.Acrobatics in experience.yml

Version 2.1.107
    Fixed an exploit that allowed automated XP gain for Excavation
    Fixed encoding of russian translation
    New API event McMMOPlayerProfileLoadEvent (thanks Shrek5InTheatres2019)

Version 2.1.106
    Added a few missing blocks to the ability blacklist tables (prevents readying/using abilities on certain blocks that have right click functionality)
    Updated Japanese locale (thanks ethernetcat)
    Updated Simplified Chinese locale (thanks Fu_Meng)

Version 2.1.105
    mcMMO will reset players scoreboard to the main scoreboard if they move into a blacklisted world
    Beast lore now shows max jump height and other tweaks (Thanks QuantumToasted)
    If the server has enabled level caps (which are not on by default) players will be shown that they are at max level instead of seeing how much XP needed to reach an impossible level (thanks Shrek5InTheatres2019)
    Large update to Italian locale (thanks Leomixer17)

    NOTES:
    The scoreboard change should result in mcMMO removing scoreboards from players properly when they enter a black listed world. This is a hacky band aid fix as our scoreboard code is archaic and needs to be rewritten in 2.2 and not 2.1. Expect a scoreboard overhaul sometime in the future.

Version 2.1.104
    Fixed a bug resulting in many errors when using Rupture
    Large update to the Japanese locale (thanks ethernetcat)
    Updated Hungarian locale (thanks andris)

Version 2.1.103
    Treasure item amount will default to 1 if not specified instead of breaking mcMMO
    Fishing treasures will now return the amount defined in treasures config file, an option to randomize amounts will be coming in the future. See notes.
    Fixed a bug where Tree Feller was only rewarding 1 XP per log broken no matter the circumstances
    Fixed an issue with salvage checking the incorrect level requirement
    Updated Italian locale (thanks Leomixer17)
    Fixed grammar in one of the Salvage strings (thanks QuantumToasted)

    NOTES:
    Sometime in 2014 a decision was made that any fishing treasure over the amount of 1 will be randomized in its yield, while this is not necessarily a bad thing it means control over the drop is a bit random. I've removed this randomness temporarily, in the future you will be able to chose if the amount is randomized or static.

Version 2.1.102
    Scoreboards will now be removed from players who teleport to a blacklisted world
    Fixed a bug where Rupture could trigger itself

Version 2.1.101
    Fixed an exploit where chorus plants could be used to gain automatic XP
    Added blast furnace, cartography table, grindstone, lectern, loom, scaffolding, smoker, stonecutter, and sweet berry bush to the list of internal blocks that don't trigger tool readying

Version 2.1.100
    Fixed a bug where plants could double drop when the skill was not yet unlocked
    Fixed a bug where plants ALWAYS double dropped
    mcnotify command now checks that it's being executed by a player
    Fixed some concurrency concerns around BleedTasks
    Fixed an NPE that may occur with random chances on a player without loaded data
    Updated Russian locale (thanks myfbone!)

Version 2.1.99
    MASSIVE update to the Russian locale (ru) credit to myfbone
    Debug mode (/mmodebug) will now print info about XP perks and how they are modifying your incoming XP

Version 2.1.98
    Fixed a bug that prevented Taming XP from combat

Version 2.1.97
    mcMMO is compatible with 1.14.4 (Didn't require any changes)
    Fixed a NPE that could occur if a pet participated in combat and its master's mcMMO data was not available
    mcMMO now properly closes its region files as it creates them (thanks Yukiiro-Nite)
    Updated Hungarian locale (thanks andris)

Version 2.1.96
    Added the setting 'Skills.General.LimitBreak.AllowPVE' to advanced.yml to allow Limit Break damage bonus to apply in PVE again, defaults to false
    Updated Limit Break locale strings
    Fixed a few more places where 'Archaeology' was misspelled in the locale
    Added the setting 'ExploitFix.PistonCheating' to experience.yml at the request of a user
    Added a missing 's' to Nether_Bricks (thanks Sikatsu) in experience.yml

    NOTES:
    The Skill Tooltips are a bit limited right now, in the future they will be more flexible. In order to reflect that Limit Break doesn't always work in PVE (now up to server settings) I added a crappy note to its hover window tip. I'll be fixing this in the future.
    You shouldn't need to update you config entry for Nether_Bricks, I believe that file updates automatically (the old config system is a bit janky, some stuff updates, some other stuff doesn't.)
    PistonCheating prevents blocks from being marked "natural" once they've been moved, we've never had an option for this before.
    A discord user requested it, its a strange request but I added it anyways.
    Of course, it defaults to "true" which prevents cheating with pistons.

Version 2.1.95
    Added missing Chorus_Fruit & Chorus_Plant entries to Herbalism's Bonus Drops in config.yml (See notes)
    Limit Break now does dramatically less damage to players with lower grades of armor
    Limit Break damage bonuses now only apply to Players
    Updated in game text to reflect changes to Limit Break
    Fixed a bug where opponents used your stats instead of their own to activate Iron Grip
    Fixed a bug preventing Wandering Traders from granting XP
    Fixed a bug that prevented Chorus Tree's from giving full XP if you broke anything other than the bottom block
    Fixed a bug which could cause Large Fern's to reward less XP
    Fixed a bug where certain herbalism crops could have fewer than intended bonus drops
    Fixed a bug involving Ender Pearl and Acrobatics
    Added some protection to Acrobatics to prevent gaining too much XP in one Roll.
    Added 'Carrots, Cocoa, Potatoes, Wheat, Beetroots, Nether_Wart' to Herbalism in experience.yml (See notes)
    Removed the _Ripe entries from experience.yml (no longer used)
    Updated locale string 'Swords.SubSkill.SwordsLimitBreak.Description' & 'Swords.SubSkill.SwordsLimitBreak.Stat'
    Added missing 'Chorus_Flower' entry to herbalism in experience.yml
    Added some debug messages about XP gains if you are in debug mode
    Added some debug messages for Acrobatics if you are in debug mode
    Added some debug messages for Herbalism if you are in debug mode

    NOTES:
    Add 'Chorus_Fruit' and 'Chorus_Plant' under Bonus_Drops.Herbalism in config.yml or you will not be getting double drops for Chorus Fruit.
    You shouldn't need to add "Chorus_Flower, Carrots, Cocoa, Potatoes, Wheat, Beetroots, Nether_Wart" to your experience file, it seems that config file updates automatically for missing entries.

Version 2.1.94
    2 new devs have joined the mcMMO team (electronicboy, kashike), bringing the active dev team to 3 including myself! Strings relating to authors of mcMMO have been updated to reflect this
    Fixed a bug where 2 people using Tree Feller could result in the tree being rejected for being too big
    New command /mmodebug (or /mcmmodebugmode) - Prints useful information when players punch blocks while they are in debug mode
    mcMMO no longer prints debug information when you attack stuff with the debug stick, use the new command (/mmodebug) instead
    Added locale string 'mcMMO.Description.FormerDevs'
    Added locale string 'mcMMO.Template.Prefix'
    Added locale string 'Commands.Mmodebug.Toggle'
    Added locale string 'Commands.Description.mmodebug'
    Tweaked locale string 'mcMMO.Description'
    Updated Japanese locale (thanks snake)
    Updated hu_HU locale (thanks andris155)

Version 2.1.93
    Fixed a bug where players would be told they could not breed summoned animals when the animals weren't summoned (bug didn't actually do anything besides send you a message)

Version 2.1.92
    Call Of The Wild (COTW) no longer cares if entities of the same type are nearby when attempting to summon a new entity
    Fixed a bug where COTW summon limit was global instead of per player
    If you are playing in 1.14 mcMMO will now summon cats instead of ocelots
    The default summon limit for COTW is now per player instead of global which is how it should be, for wolves this defaults to 2, for other entities it defaults to 1
    The COTW setting named Summon_Max_Amount in config.yml has been renamed to Per_Player_Limit
    By default players are no longer allowed to breed COTW summoned animals with other animals, you can turn this off (see the notes)
    If a player tries to breed animals with a COTW animal and the server settings prevent this, they are informed via a message that it is not allowed
    If the COTW summon has a lifespan, players are now informed about this lifespan when the entity is first summoned
    COTW entities now send the player a message when they die, time out, or get removed through other means
    COTW summons now have their name prefixed with some colored text to to make it easier to identify them.
    COTW summons now despawn if their owner logs out
    There is now a small 150ms window in which you cannot summon an entity via COTW to prevent accidentally summoning extra entities
    COTW Horses, Cats, and Wolves now always spawn in as adults
    Changed the sound effect for COTW (Fireworks -> Pop)
    Most COTW messages have been tweaked and new COTW messages have been added
    Added new setting to experience.yml 'ExploitFix.COTWBreeding' - Prevents breeding with COTW summoned entities when set to true, defaults to true
    Removed the 'mcmmo.ability.taming.callofthewild.renamepets' permission node as it is seen as unnecessary

    Removed locale strings
        Taming.Summon.Fail.Ocelot
        Taming.Summon.Fail.Wolf
        Taming.Summon.Fail.Horse
        Taming.Summon.Fail.TooMany
        Taming.Summon.Lifespan
    Added new locale strings
        Taming.Summon.COTW.NeedMoreItems
        Taming.Summon.COTW.BreedingDisallowed
        Taming.Summon.COTW.Success.WithLifespan
        Taming.Summon.COTW.Success.WithoutLifespan
        Taming.Summon.COTW.Limit
        Taming.Summon.COTW.TimeExpired
    Tweaked locale string
        Taming.Summon.Name.Format

    NOTES:
    I plan to rework Call of The Wild (COTW) significantly in the upcoming content patch, until then I have made several tweaks to it.

    COTW Summoning Requirement Changes
    It is intentional that you are not supposed to be able to COTW summon something that you already have tamed, but mcMMO was not checking this properly.
    So previous to this patch, if you tried to summon a wolf and wolves were nearby, it would fail. This is not intentional behaviour and was a bug.
    The correct behaviour is that if you try to summon a wolf and you already have wolves, it should fail.
    I was fixing this bug when it occurred to me, why do we even care if nearby tamed wolves owned by you exist if you are trying to summon a temporary one?
    As a result of this train of thought, I have removed this restriction on COTW and several other tweaks have been made as a result of this line of thinking.
    There was also an issue involving how many COTW entities could be out at once, for some reason the limit was applied globally and defaulted to 10, so if 10 players had COTW entities out no one else would be able to summon anything. I have fixed this.
    You can set the lifespan to 0 in the config to make it so that COTW entities last until a server restart or the player logs out.

    COTW Breeding Change
    It was never intentional for COTW summoned entities to be breedable, by default they will not be. You can change this by setting 'ExploitFix.COTWBreeding' to false in experience.yml

Version 2.1.91
    mcMMO is now more compatible with plugins that spawn arrows in unexpected ways, this fixes some NPE in mcMMO when using certain plugins
    Fixed a bug where Unarmed was using the same CD timer for every player in the server (thanks slop_me)

Version 2.1.90
    Salvaged items now travel much slower towards the player
    Books from salvage will now travel towards the player
    Salvaged items travelling towards you will now have their speed adjusted based on distance

    Common Materials found when mining have had their XP gains reduced and rare materials have had their XP gains increased
    Diamond Ore has had its XP increased from 750 to 2400
    Gold Ore has had its XP increased from 350 to 1300
    Iron Ore has had its XP increased from 250 to 900
    Lapis Ore has had its XP increased from 400 to 800
    Nether Quartz Ore has had its XP increased from 100 to 300
    Redstone Ore has had its XP increased from 150 to 600
    Blue_Ice has had its default XP value reduced to 15
    Packed_Ice has had its default XP value reduced to 15
    Netherrack has had its default XP value reduced to 15
    Coal Ore has had its XP increased from 100 to 400
    Stone has had its XP decreased from 30 to 15
    Granite has had its XP decreased from 30 to 15
    Andesite has had its XP decreased from 30 to 15
    Diorite has had its XP decreased from 30 to 15
    End Stone has had its XP decreased from 30 to 15
    Glow Stone has had its XP decreased from 30 to 15
    End Bricks has had its XP decreased from 200 to 50


    NOTES:
    You can either apply the default XP changes manually to experience.yml or delete it to generate a new file

    Sorry about salvaged items traveling too quickly, in testing on my LAN server with ideal conditions they always entered my inventory and never shot past me so the high speed of the items was not an apparent issue.
    I've tested the new changes to how they travel towards you pretty thoroughly, they never go fast enough to go past you and they adjust their speed based on distance to you with some speed limitations.
    In testing the new tweaks work well whether the salvage anvil is above, below, or at the same height as you.

    I'll be tweaking XP values across all skills more carefully in the upcoming content patch due after 2.2. Some tweaks to XP gains will be applied for 2.2.

Version 2.1.89
    Many changes were made to this version that affect default values in the config, read the notes carefully if you wish to apply these changes. They are optional.
    mcMMO is compatible with the new 1.14.3, in addition to this it is still compatible with 1.14.2, 1.14.1, 1.14, and 1.13.2. This did not require any changes to be made to mcMMO, but I thought I'd add this to the notes for those wondering.

    RetroMode is the default level scaling mode again
    The default level for players has been changed back to 0 from 1 (you can change it back to 1 by editing 'Skills.General.StartingLevel' in advanced.yml) if you wish to apply this change read the notes
    Super Abilities now scale in length up to level 100/1000 instead of 50/500 by default (you can edit this in advanced.yml under 'Skills.General.Ability.Length.xxx')
    Early Game Boost now only applies when leveling from level 0 to level 1
    Removed the config setting 'MaxLevelMultiplier' from experience.yml as it is no longer used.
    When finding a treasure via Excavation players have a 1-8% chance to have a small amount vanilla experience orbs to be found alongside the treasure, the chance and number of orbs are based on the players Archaeology rank
    Tweaked the locale string 'Excavation.SubSkill.Archaeology.Description'
    Added locale string 'Excavation.SubSkill.Archaeology.Stat'
    Added locale string 'Excavation.SubSkill.Archaeology.Stat.Extra'
    Tweaked the locale string 'Fishing.SubSkill.MasterAngler.Stat'
    The interval at which you can gain Acrobatics XP from fall damage has been reduced to 3 seconds from 10 seconds, this will be configurable in 2.2.

    When using WorldGuard (WG) with mcMMO, mcMMO now examines WG more carefully to determine if it is a compatible version or not, see the notes. Keep in mind WG is optional and not needed to run mcMMO.
    Fixed a bug that could result in Tree Feller failing to remove parts of a tree in snowy biomes. (This fix won't apply retroactively to old trees, see the notes)
    Updated Japanese locale (thanks snake)
    Tree Feller and other Super Abilities will damage tools with the Enchantment named 'Durability/Unbreaking' again, this does not apply to the NBT tag named Ubreakable (Unbreakable NBT tag is safe from damage however, try not to confuse them as they share similar names)
    Added new setting 'ExploitFix.TreeFellerReducedXP' to experience.yml
    Tree Feller will no longer give full XP for each block destroyed and instead give diminishing returns on XP for each block removed. You can turn this off by setting 'ExploitFix.TreeFellerReducedXP' in experience.yml to false
    Many skills which used to unlock at level 5/50 now unlock at level 1 instead
    Arrow Retrieval now unlocks at level 1 in both Standard and RetroMode
    Skill Shot now unlocks at level 1 in both Standard and RetroMode
    Dodge now unlocks at level 1 in both Standard and RetroMode
    Critical Strikes now unlocks at level 1 in both Standard and RetroMode
    Armor Impact now unlocks at level 1 in both Standard and RetroMode
    Beast Lore now unlocks at level 1 in both Standard and RetroMode
    Call Of The Wild now unlocks at level 1 in both Standard and RetroMode
    Scrap Collector now unlocks at level 1 in both Standard and RetroMode
    Treasure Hunter now unlocks at level 1 in both Standard and RetroMode
    Rupture now unlocks at level 1 in both Standard and RetroMode
    Iron Arm Style now unlocks at level 1 in both Standard and RetroMode
    Harvest Lumber now unlocks at level 1 in both Standard and RetroMode
    Archaeology now unlocks at level 1 in both Standard and RetroMode
    Repair Mastery now unlocks at level 1 in both Standard and RetroMode
    Double Drops (Herbalism and Mining) now have ranks and unlock at level 1 in both Standard and RetroMode
    Concoctions rank 2 now unlocks at Level 1 for both Standard and RetroMode
    Serrated Strikes now unlocks at levels 5/50 instead of 10/100
    Berserk now unlocks at levels 5/50 instead of 10/100

    NOTES:
    I'm looking into adding 1.12.2 support sooner than expected.

    Editing your config files is not required for this patch (and never will be), however I would highly recommend it. Read the notes below this line carefully.
    If you want to update to this patch easily and you don't mind default config values, delete skillranks.yml, advanced.yml, and experience.yml before starting your server with 2.1.89 of mcMMO applied.
    Many skills now unlock at level 1 and the default starting level is back to 0. It is recommended you change this number from 1 to 0 manually by editing 'Skills.General.StartingLevel' in advanced.yml or deleting advanced.yml and generating a new file when 2.1.89 starts.
    It is recommended you make the manual edits to skillranks.yml to apply this change or delete skillranks.yml and a new one will be generated once you start 2.1.89.

    Early Game Boost was used to help players get to level 5 quickly by boosting their XP until they got there, this caused some confusion as they appeared to be 'learning a skill' for multiple levels, on RetroMode this lasted until level 50.
    I have changed Early Game Boost to only last from level 0-1 on both RetroMode and Standard, and now important skills are unlocked at level 1.
    I was going to wait until 2.2 was done to deploy this change, but 2.2 is some time away and the previous system was causing some confusion.
    Early Game Boost gives players extra XP for skills that are level 0, you can turn this system off by setting 'EarlyGameBoost.Enabled' in experience.yml to false
    Early Game Boost will show 'Learning a new skill...' if XP bars are enabled

    https://mcmmo.org/wiki/World_guard - A list of WG flags supported by mcMMO.
    It is not necessary to have WG installed, but if you do have WG installed mcMMO hooks into it to provide some additional features.
    Previously mcMMO used to determine if WG was compatible just by checking to see if it was version 7 of WG, however version 7 of WG is not guaranteed to be compatible as necessary classes that mcMMO hooks into were added during its development and some users are still running early dev versions of WG7.
    In order to decrease the chance of error, mcMMO now uses reflection when checking to see if WG is compatible in addition to checking its version number, if its not compatible mcMMO will print a message and refrain from hooking into WG.
    WG is an optional dependency for mcMMO, and unfortunately before this change if mcMMO thought you were running a compatible version of WG and it turned out you weren't then mcMMO would not function correctly.

    Archaeology does something now, it will be tweaked again in the future. Previously rank 1 of Archaeology was required to find treasures but that was all it did, now each rank of Archaeology also adds a small chance to find experience orbs when a player finds treasure.

    In a prior patch I removed damage on tools if they had Unbreakable NBT or Unbreaking Enchantment, at the time I made this change I did not realize they were different things and just shared the same name, this patch fixes this mistake. My intention was to prevent damage on tools with the NBT unbreakable tag which makes an item never suffer from durability loss.
    mcMMO reduces damage to tools from super abilities if they have the "Durability/Unbreaking" enchantment already, this behaviour has been in mcMMO for a long time.

    Tree Feller will now give reduced XP per block destroyed by Tree Feller and will never go below 1 XP per block, you can turn this off with 'ExploitFix.TreeFellerReducedXP' in experience.yml
    There was a bug fixed in this patch that prevents an issue where Tree Feller was not removing all blocks left behind, unfortunately this will only affect new trees made in the world. The only trees that suffered from this bug were ones in snowy areas that had snow form on them.

    RetroMode and Standard mode will be getting renamed in 2.2, probably to something like 1000-scale and 100-scale respectively.
    Retro Mode was accidental genius is the short reason for the change to make it the default level scaling for mcMMO again.
    Standard Mode is not going anywhere, it is just opt-in now instead of the default.
    If you delete config.yml you will need to turn RetroMode off to use Standard mode as mcMMO doesn't keep track of what level scaling you are using outside of that.

Version 2.1.88
    mcMMO is now more compatible with a plugin named Project Korra
    mcMMO will no longer process combat triggers for damage at or below 0

Version 2.1.87
    (Level caps are not on by default in mcMMO, this is something you can turn on)

    Players who reach either the power level cap or skill level cap will now be informed that they have done so
    XP Bars will no longer be sent to players who have reached the power level or skill level cap respectively
    Level up messages will no longer be sent to players who have reached the power level or skill level cap respectively
    Fixed a bug where mcMMO would send level up notifications to a player if the custom level up event from mcMMO was cancelled
    New locale strings 'LevelCap.PowerLevel' & 'LevelCap.Skill'

Version 2.1.86
    Players will no longer be told they got a perfect result when salvaging if they are below max skill level
    Salvage results will now travel towards the player instead of moving in a random direction
    (FIX) You cannot view stats of players who are offline if your server limits the range on inspect for you via permissions or settings
    (FIX) Players will no longer be told they lack skill in salvage if they already qualify for the best possible result for the item
    (FIX) Fixed a bug where arcane salvage was being used to calculate salvage results instead of scrap collector
    (FIX) Added the missing locale color for 'Commands.Party.Commands'
    Modified colors used in locale strings 'Salvage.Skills.Lottery.Normal', 'Salvage.Skills.Lottery.Perfect', and 'Profile.Loading.FailurePlayer'
    When failing to load a profile mcMMO will increase the amount of time it waits before reattempting to load the profile for each failure

    NOTES:
    You can (and always have been able) to turn off the inspect range check by setting it to 0 in the config
    2.2 is around the corner, most things are functional, still a lot of work left to do.

Version 2.1.85
    Fixed a nearly 6 year old bug where Super Repair was not included as a child permission under Repair ability permission nodes (which meant some players would not have access to this skill)
    Fixed a bug that could prevent salvage from working for certain players
    Renamed the advanced salvage permission node to 'mcmmo.ability.salvage.scrapcollector'
    Fixed a bug that would send players skill unlock notifications if they did not have the permission node for that skill
    Dramatically increased the chance of receiving full materials when salvaging

Version 2.1.84
    Added some code to make mcMMO more compatible with EpicSpawners

Version 2.1.83
    You can no longer set party members on fire with your bow
    (FIX) Arrow Retrieval will no longer work with piercing enchant on crossbows
    WG Flags should now correctly recognize when a projectile belongs to a player and respect flag settings
    Updated hu_HU locale (thanks andris155)

Version 2.1.82
    Added new WG flag 'mcmmo-hardcore' if set to negative players will not be penalized by hardcore mode (if hardcore mode is enabled) it defaults to true
    Added proper error handling when loading parties file
    Fixed an error that could occur when using mcrank on an offline player
    You can now use mcrank on offline players by default
    You can now use inspect on offline players by default
    Removed the offline inspect/mcrank permissions
    Updated Chinese locale (thanks to the user named 89009332 from github)
    Added some redundancy checks when loading profiles (NPC checks to be specific)

    NOTES:
    There were reasons to prevent inspecting offline players in the past, I don't see any reason for them anymore so I've removed the restriction.

Version 2.1.81
    Fixed a bug where Arrow Deflect would never trigger outside of PVP
    Fixed a bug where failing to salvage enchantments incorrectly colored the text
    mcMMO no longer allows players to keep enchantments exceeding normal limitations by default when salvaging or repairing (you can turn this off in the config, see below)
    Added new setting 'ExploitFix.UnsafeEnchantments' to experience.yml, turn this on to allow players to salvage/repair enchantments higher than normal game restrictions

    NOTES:
    If a player tries to salvage/repair an item with an illegal enchant (for example Sharpness X) it will downgrade that item to the highest legal version when calculating rewards
    If you don't like this change you can turn it off in experience.yml under 'ExploitFix.UnsafeEnchantments'


Version 2.1.80
    (Fix) mcMMO now respects the NBT "Unbreakable" tag and does not deal durability damage to items with that tag

Version 2.1.79
    Updated Japanese locale (Thanks snake0053)
    Fixed a NPE that could happen when using Tree Feller with an unenchanted Axe

Version 2.1.78
    Shovels no longer take more than 1 diamond to repair
    Tools with the unbreaking enchantment no longer take extra damage from ability usage, they are still subject to the normal durability damage from breaking blocks though.

Version 2.1.77
    Added minimum quantity back to Repair config

    NOTES: I removed this last patch because I did not consider that server admins might be allowing users to repair items without crafting recipes (as of last patch mcMMO determines minimum quantity via counting ingredients in a recipe)
    If you do not define minimum quantity in the repair config, mcMMO will grab the minimum quantity automatically as I programmed it to do as of last patch, otherwise if it is defined, mcMMO will respect that and use that for calculations.
    The minimum quanitty should be set to the number of ingredients used to craft the recipe, for example 8 for diamond chestplate etc, you do not need to define this unless you are allowing players to repair custom items.

Version 2.1.76
    Advanced Salvage has been renamed to Scrap Collector
    Scrap Collector has 8 ranks, the first rank is unlocked at level 2 (Level 20 in RetroMode)
    You can not salvage without at least 1 rank in Scrap Collector now (formerly Advanced Salvage)
    Fixed a bug where Repair was repairing too much
    Fixed a bug where Arcane Salvage was used to determine how many materials a player could salvage from an item instead of Scrap Collector (formerly Advanced Salvage)
    Fixed a bug where messages about an item being too damage to salvage were being sent twice
    Removed the minimum quantity field from the repair config
    Removed the item data (metadata) field from repair config as its not used anymore
    Salvage will no longer return the max amount of materials possible, instead you are guaranteed one item and then some luck is involved on how many items are returned.
    Updated Chinese locale (thanks to the user named 89009332 from github)

    New locale strings
        Salvage.Skills.Lottery.Normal
        Salvage.Skills.Lottery.Perfect
        Salvage.Skills.Lottery.Untrained
        Salvage.SubSkill.ScrapCollector.Name
        Salvage.SubSkill.ScrapCollector.Description
        Salvage.SubSkill.ScrapCollector.Stat

    (API) SALVAGE_ARCANE_SALVAGE in SubSkillType has been renamed to SALVAGE_SCRAP_COLLECTOR

    NOTES:
    You do not need to update your configs for this update.

    How Salvage works
    As an example, say you had enough skill to gain up to 5 items from salvaging something, and that item has enough durability to yield up to 5 materials, salvage will play out like this...
    First off, you will be guaranteed 1 material, after this you have 80% chance to get the next material, if successful, another dice roll is conducted but lowers your odds by 20%, you chance to succeed will never fall below 33%
    If you fail a dice roll, it will still conduct dice rolls for the remaining maximum amount of materials returned but your odds of success are only lowered upon a successful dice roll, the sum of the successful dice rolls is used to calculate how many items you are given back, the first item is guaranteed and has no dice rolls, which means for example the Diamond Shovel will always succeed.

Version 2.1.75
    Fixed a bug that prevented Fortune from working correctly if a Double Drop was triggered

Version 2.1.74
    Fixed a NPE that could occur during certain events if a skill was disabled in coreskills.yml (Sorry!)

Version 2.1.73
    Fixed a NPE that could occur if an entire skill was disabled in coreskills.yml

Version 2.1.72
    Fixed a NPE if a server shutdown with no player data needing to be saved (the error is harmless but spammy)
    Fixed a NPE that could occur if Roll was disabled in coreskills.yml

Version 2.1.71
    Salvage will now always ask for confirmation before breaking your items (instead of only asking for enchanted items)
    Repair will now always ask for confirmation before repairing items (instead of only asking for enchanted items)
    Gold & Iron Blocks will no longer trigger tool ready messages
    Salvage & Repair anvils will no longer work on multi-item stacks

    NOTES: You can still turn the confirmation off in config.yml

Version 2.1.70
    Added new DatabaseAPI to the API package, has features relating to database operations
    Fixed a bug where shulker boxes (without colors) would activate tool ready messages

Version 2.1.69
    Fixed a few places where mcMMO would not save player data immediately which may cause players to lose a few minutes of progress

    A big thanks to Sleepyflea for helping test this patch and report this bug.

Version 2.1.68
    Updated Japanese locale (thanks Snake)
    Fixed a bug where consuming food in the off hand did not trigger the Diet abilities

Version 2.1.67
    The XP bar now reflects whether the player is receiving the early game boost
    Players who are receiving an early game boost will be shown "Learning a skill..." as the title of the XP bar while gaining XP
    New locale string 'XPBar.Template.EarlyGameBoost'

    NOTES:
    You can turn off this system in experience.yml 'EarlyGameBoost.Enabled'
    The Early Game Boost is a system in which players receive drastically increased XP gains for the first few levels (until the first set of skills are unlocked)
    With default settings, this means players will be receiving boosted XP for the first 5 levels (50 for Retro)
    The Early Game Boost ends when players get the first skill in each ability under default settings
    The main purpose of this system is to alleviate progression issues with a few skills where the first set of unlocked abilities drastically increase how fun it is to level the skill
    The secondary purpose of this system is to alleviate any psychological issues when grinding towards the first set of unlocks by making the first set of unlocks happen quickly
    This system has been in place for a few versions now, but without an in game indicator of what was going on.
    If you have XP bars off there is still no indicator that this system is in place, I'll address that at some point.

Version 2.1.66
    Fixed a bug that could happen if a player was removed from the DB when using MySQL/MariaDB when the user was offline
    Fixed a minor memory leak for MySQL

Version 2.1.65
    Corrected a bug that would cause RetroMode to use Linear formula regardless of setting

Version 2.1.64
    Corrected how Standard mode (1-100 scaling) XP to next level was calculated, it is now a true 1:10 ratio with Retro (1-1000) scale, which is how it was intended to be to begin with
    Fixed a bug that caused skill messages to spam nearby players
    (API) method to get XP in FormulaManager has been renamed to getXPtoNextLevel(...), this shouldn't break anything as plugins should be using our Experience API methods instead of this
    (API) Added method getLevel(Player player, PrimarySkillType primarySkillType) to ExperienceAPI.java


    NOTE: The net result of this change is it will take a bit longer to level with Standard, but it should not be a drastic change. You might not even notice it.
    Standard is meant to take the same amount of time to level from levels 1-100 as it takes Retro to do 1-1000, this change corrects from errors in the code that made Standard actually take less XP than Retro despite intending for it to be a cosmetic difference in progression.
    I made a google sheet visualizing the difference between Standard and Retro Mode using default settings and Linear formula - https://docs.google.com/spreadsheets/d/1VlJtvNHlypACHyz_zulEdhgLwFjL01xMPkqlnu0XBSs/edit?usp=sharing

Version 2.1.63
    Fixed Armor Impact not scaling by skill rank
    Significantly Buffed the amount of durability damage incurred by a successful Armor Impact
    Added new setting to advanced.yml 'Skills.Axes.ArmorImpact.DamagePerRank' which is multiplied against Armor Impact's skill level to determine damage done to armor
    Fixed a bug that caused creative mode players to gain XP when qualifying for early game XP boosts
    Removed the damage cap setting for Armor Impact, it is inherently capped now based on its max rank and damage setting
    Updated hu_HU locale (thanks andris155)
    Updated ja_JP locale (thanks snake)

    NOTES:
    Armor Impact only has a 25% chance to go off, and for it to only incur 20 durability damage seemed incredibly underwhelming, I've buffed it quite a bit.
    You can change it back to its underwhelming self by setting DamagePerRank to 1.0
    Based on feedback I may tweak the number again or other properties of this skill

Version 2.1.62
    Added a new admin notification system, sensitive commands will print chat messages to "admins" (players with either Operator status or admin chat permission)
    Added a setting to disable the new admin notifications to config.yml 'General.AdminNotifications' (this will be more configurable in 2.2)
    OPs and players with the admin chat permission will now see details about XP rate event commands regardless of whether the XP rate event messages are enabled
    Updated hu_HU locale (thanks andris155)
    Added XP for mining Magma_Block (default 30 XP - Update your config, see notes)
    Diamond tools & armor in the repair config now have a minimum level of 0 (Update your config, temporary hotfix, 2.2 addresses this issue, see notes)
    Guardian default combat XP multiplier reduced from 3.0 to 1.0 (update config if you want this change)
    New locale string - 'Server.ConsoleName' the name of the server console, this will be used in place of player names when sending admin notifications out if the command was used from console
    New locale string - 'Notifications.Admin.Format.Others' style formatting + prefix for admin notifications used in the other new strings below
    New locale string - 'Notifications.Admin.Format.Self' style formatting + prefix for admin command confirmations sent to the user who executed the command
    New locale string - 'Notifications.Admin.XPRate.Start.Self' sent to the user who modifies the XP rate regardless of whether messages for the event are enabled
    New locale string - 'Notifications.Admin.XPRate.Start.Others' details of who started an XP rate event are sent to players who have Operator status or admin chat permission when the command to start or modify XP of an event has been issued
    New locale string - 'Notifications.Admin.XPRate.End.Self' sent to the user who ended the XP rate event regardless of whether messages for the event are enabled
    New locale string - 'Notifications.Admin.XPRate.End.Others' details of who ended an XP rate event are sent to players who have Operator status or admin chat permission when the command to end the event has been issued

    NOTES:
    Admin notifications currently only reports use of the XP rate command, it will be expanded to support other commands in upcoming patches
    Add an entry of 'Magma_Block: 30' under Mining in experience.yml section titled "Experience_Values" (or you can delete the file to generate a new one with default values, 2.2 is coming soon which will have brand new configs so you could just wait for that
    2.2 is the config rewrite, in this rewrite Repair and Salvage configs have been partially rewritten, it is not intended for Diamond Repair to take until level 50 in Standard level scaling to be available, since it'd be redundant to fix this in 2.1.X when 2.2 fixes it and its about to come out, the minimum level has temporarily been changed to 0. You can either update your repair.vanilla.yml config manually or delete it to generate a new one.

    Admin notifications are a step in the right direction for finding naughty admins in mcMMO, I will be changing which permission node is used for players to be considered an admin in the future as not everyone wants or uses admin chat.
    I expect to add logging of admin commands which will be viewable in game via command, so you won't have to have access to the servers log files to view who has been executing what.

Version 2.1.61
    Fixed the locale string formatting of 'Mining.SubSkill.DoubleDrops.Stat'
    Updated the Japanese locale (thanks snake0053)
    Added toggle to turn off event message broadcasts (XP rate) to config.yml - 'General.EventBroadcasts'
    Added toggle to not inform players of events when they join (XP rate, etc) to config.yml 'General.EventInfoOnPlayerJoin'
    Added anti-exploit protection for cobble/stone farms which can be automated, to turn this off you can toggle the new config options 'ExploitFix.LavaStoneAndCobbleFarming' in experience.yml

    NOTE: The toggle for event message broadcasts is separate from the titles being shown, that's another config option (titles are the BIG TEXT in the middle of the screen)
    NOTE: The new anti-stone/cobble automation will not prevent XP gains from obsidian, since Obsidian requires some effort to farm

Version 2.1.60
    Fixed a NPE error if a LivingEntity's target was set to null
    Fixed a bug where tamed mobs could kill themselves if their owner shot them once
    Corrected a typo when naming entities summoned by COTW (Locale string - Taming.Summon.Name.Format)
    Fixed a bug where tamed mobs could have hearts instead of their name in their own death messages
    Fixed a bug where multi-block crops would fail to double/triple drop (Sugar Cane, Cactus, etc)
    Optimized the bonus drop code to reduce overhead

Version 2.1.59
    Raised the overfishing limit from 3 to 10
    Improved the overfishing messages to be more clear about its mechanics
    Overfishing locale keys renamed "Fishing.ScarcityTip" and "Fishing.LowResourcesTip"

    NOTES: This and other exploit prevention measures are much more customizable in 2.2, which shouldn't be too far off.

Version 2.1.58
    Fixed the wrong locale string being used for Mining Double Drops

Version 2.1.57
    Fixed an incredibly rare dupe bug that only happened with VERY specific config options that was extremely difficult to pull off

Version 2.1.56
    Very large update to the zh_CN Chinese language file (thanks Dream_m)

Version 2.1.55
    Fixed a bug that could occur when adding UUIDs to old outdated DBs

Version 2.1.54
    Fixed a bug where the Skill 'Understanding the Art' was preventing vanilla experience orbs from furnaces
    Fixed 'Understanding the Art' not correctly boosting vanilla XP from furnaces

Version 2.1.53
    Fixed a critical bug where players earned too much XP

Version 2.1.52
    Updated Japanese locale (thanks snake0053)
    Added a toggle for the early game XP boost to experience.yml 'EarlyGameBoost.Enabled'
    Added a max level multiplier for determining early game boosts cutoff to experience.yml 'EarlyGameBoost.MaxLevelMultiplier'

Version 2.1.51
    You can now customize a locale outside of the JAR! (Thanks mikroskeem)
    Added a new locale reload command 'mmolocalereload' (Thanks mikroskeem)
    Locales can now be overriden by placing a file with an appropriate name inside /plugins/mcMMO/locales/ (Thanks mikroskeem)

    NOTES
    You can find the up to date current en_US locale entries here: https://github.com/mcMMO-Dev/mcMMO/blob/master/src/main/resources/locale/locale_en_US.properties
    You do NOT have to replace the whole locale, you can replace only the strings you want to!
    Locales only support ASCII and UTF16 characters at the moment, so you'll need to run special characters through a UTF16 converter (google it) to get them to work, I'll be fixing this in the future!
    The locale name must match the internal file you are overriding (ie: locale_en_US.properties)
    Locale will first check for a users locale file, if it doesn't exist it will use internal resources (files inside the JAR)
    If a locale is found, it will use locale entries from that file, if any entries are missing, it will use entries from en_US inside the JAR
    The locale file names are structured like this 'locale_XX_XX.properties', replace XX with your country codes, if you are not overriding en_US you will have to change the targetted locale inside config.yml

Version 2.1.50
    Fixed a bug where early game XP boost (level 1-5) didn't function in certain circumstances
    Updated German locale (thanks OverCrave)
    Added missing Herbalism XP values for: Bamboo, Cornflower, Lily of the valley, Wither rose (thanks Zed-I)
    Added missing Mining XP values for: Stone Bricks, Cracked Stone Bricks, Mossy Stone Bricks, Chiseled Stone Bricks, Prismarine Bricks, Dark Prismarine, Sea Lantern (thanks Zed-I)
    Added missing Combat XP multiplier for: Wandering Trader (thanks Zed-I)

    Notes:
    If you haven't upgraded mcMMO since version 2.1.47 or before you will not need to do these steps as the experience file will update once automatically.
    You can either delete experience.yml to generate a new one or edit it manually
    This is what the default experience.yml looks like
    https://paste.gg/p/anonymous/946f62ce7dff4ab7a87cae70c0266313


Version 2.1.49
    Added sweet berry bush to Herbalism XP (Update your experience.yml config or delete it to gen a new one)
    Fixed a bug where falling blocks were not marked as unnatural in water
    Fixed a bug where tool lower notifications were being called async when they are sync only
    Fixed NPE when checking inventory location
    Improved herbalism compatibility with anti-cheat (thanks LogGits)

    NOTE: This is what the default herbalism XP table looks like
    https://paste.gg/p/anonymous/1022088f20cf44298870930e9bc58e8a

Version 2.1.48
    1.14 Support
    Added Cats, Foxes, and Pandas to Taming XP rewards
    Added Cats, Foxes, Pandas, Trader Llamas, Pillagers, and Ravagers to Combat XP rewards
    "Experience" section of experience.yml has been renamed to "Experience_Values"
    Dodge now gives 800 XP
    Roll now gives 600 XP
    Fall now gives 600 XP

    The first 5/50 levels of skills now give large amounts of XP so players get key early skills much faster
        Note: First 5 in Standard, first 50 in Retro

    Dev Notes:
    I will be making a write up soon explaining near future plans for mcMMO and what is going on with the config update, abstraction update, etc...
    Currently this version of mcMMO will work on both 1.13 and 1.14, in the abstraction update I will expand compatible versions of mcMMO to include: 1.14 / 1.13.2 / 1.12.2 / 1.8.8 / Sponge 1.14
    It is not necessary to update your configs if you are upgrading from 1.13 -> 1.14, however if you had custom XP values in your experience.yml you will want to update your config.
    Acrobatics XP was buffed since many AFK counter-measures were put into place to prevent repetitive grinding.
    Experience node in experience.yml was renamed to "automatically" update configs for the new stuff 1.14
    There are 4 updates planned for mcMMO, including a patreon rewards update, a large content update, a config update, and backwards compatibility for 1.13/1.12/1.8.8 and support for Sponge

Version 2.1.47
    Fix NPE when party leader is offline and players grab a party list

Version 2.1.46
    Party member lists now show the whole party, including offline players again.
    Party lists now have special markers for players who are in shared XP range
    Party lists now have special markers for players who are offline
    Party lists now have special markers for the party leader
    Fixed an error where bleed was setting health outside minimum values
    [See NOTE] Fixed a bug where Creepers and Zombies were not dropping the correct heads from Shake (thanks Zed-I)
    [See NOTE] Fixed a bug where salvage was not returning the correct amount of materials for AXE items (thanks Zed-I)
    [See NOTE] Added missing STRIPPED_WOOD entries to experience.yml for Woodcutting
    [See NOTE] Added about 15-20 missing entries to experience.yml for coral to Herbalism
    Fixed a bug where admin chat from console would fail to send (thanks OverCrave)
    Reduced default XP values for DEAD_* coral plants from 30 -> 10
    Updated hu_HU locale (thanks andris155)

    NOTE: These bugfixes were related to default config values, to receive these changes you can either delete experience.yml, treasures.yml and salvage.vanilla.yml to generate new ones or make the necessary edits.
    This is what the files should look like after being edited.
    Experience Correct Default Config - https://paste.gg/p/anonymous/ff695df1417e4232957a3d176fd14ed4
    Salvage Correct Default Config - https://paste.gg/p/anonymous/c4eb2f4e66ed444e872021051760f3be
    Treasures Correct Default Config - https://paste.gg/p/anonymous/b0120210f8c149958ca0303c68c19ebd

Version 2.1.45
    mcMMO will now check to see if the server version is incompatible and inform server admins on how to fix the problem.

Version 2.1.44
    Fixed a NPE with Alchemy brewing

Version 2.1.43
    Fixed a bug that would result in players being told they they failed to salvage enchantments when in reality they succeeded.

Version 2.1.42
    Fixed McMMOPlayerNotFoundException being thrown instead of null
    (API) UserManager.getPlayer() returns null again (oopsie)
    Added new perk permission node `mcmmo.perks.bypass.salvageenchant` - guarantees full enchantment return for Salvage
    Added alternative permission node `mcmmo.perks.bypass.repairenchant` - guarantees full enchantment return for Repair
    Added new wildcard perk `mcmmo.perks.bypass.*` and `mcmmo.perks.bypass.all` (either of these will grant all new mcmmo.perks.bypass perk permissions)

    NOTE: Sorry about that, when trying to improve Bungee Cord compatibility I made a big oopsie!
    NOTE: Repair's new perk permission works in the exact same way as mcmmo.bypass.arcanebypass, bypass perk permissions will all eventually be moved to `mcmmo.perks.bypass`
    NOTE: Expect perk permissions to all be moved to `mcmmo.perks.X` in the near future

Version 2.1.41
    Fixed NullPointerException errors when trying to grab PlayerProfiles for players who have not loaded
    Added new locale string Profile.PendingLoad
    Added new locale string Commands.Database.CooldownMS
    Fixed a display error preventing the remaining time on /mcrank from being shown if it was on cooldown

Version 2.1.40
    (API) mcMMO will now return null in all cases for UserManager.getPlayerProfile() if they have not been loaded yet
    (API) Roll stores exploit data in AcrobaticsManager now
    Added new locale string "Profile.Loading.FailureNotice"
    Added new locale string "Profile.Loading.FailurePlayer"
    mcMMO no longer gives up forever if a player profile fails to load and the player is still online
    mcMMO will attempt to save a profile up to 10 times now, previously it would only try one time.
    Fixed an ArrayIndexOutOfBounds error with Party Chat
    Player data for mcMMO is now loaded 3 seconds after a player connects in order to give any ongoing save tasks from other servers a small grace period to finish. This will mostly be useful to Bungee servers.

NOTES: I received reports from some users saying that saving and loading was failing could fail and not recover, I have implemented some fail safes to greatly reduce the the odds of that happening.

Version 2.1.39
    Salvaging an item should now only play the item break sound (was playing the anvil sound simultaneously before)
    Fixed bug where Tall_Grass was not giving full XP
    Added Tall_Seagrass and Seagrass to experience.yml under Herbalism (update your configs)

    NOTE: This is what your herbalism section in experience.yml should look like - https://paste.gg/p/anonymous/d5b03bd56e8442f2836f8a954d2974de
Version 2.1.38
    Roll XP cooldown down from 60 seconds to 10
    Updated pt_BR localization (thanks FabioZumbi12)
    NOTE: The XP Cooldown will be configurable in 2.2 which is nearing the finish line

Version 2.1.37
    Fixed a potential IndexOutOfBoundsException when informing a disconnected player that their Blast Mining was off CD
    Updated hu_HU locale (thanks andris)

Version 2.1.36
    Updated German locale (Thanks OverCrave)
    Fixed a bug preventing Villagers from giving combat XP
    The /mcnotify command will now squelch almost all chat messages or action bar notifications sent to the player from mcMMO
    mcMMO will now remind players on an hourly basis that they are are not receiving notifications from mcMMO if they have run the mcnotify command and toggled squelch mode
    Added a new setting to advanced.yml "Feedback.PlayerTips", when set to true this will allow mcMMO to send periodic helpful messages to players, currently this only affects mcnotify reminders.

Version 2.1.35
    Readded the detonator config option

    NOTE: I decided to make the detonator configurable again because 2.2 is some ways off. Sorry for the inconvenience.
    NOTE: Pickaxes are now usable for blast mining, this is in addition to the detonator that you can specify in the config. This will be more configurable in the upcoming 2.2 update.

Version 2.1.34
    Added Llama to taming XP tables
    Added Parrot to taming XP tables
    Pickaxes are now used to activate Blast Mining instead of Flint
    The detonator for Blast Mining is no longer configurable
    Fixed a bug where Blast Mining did not show cooldown length correctly

    NOTE: You'll have to add these entries in yourself, this is what it should look like: https://paste.gg/p/anonymous/aadbcfde3eb3470fb13caebde4065a03
    Alternatively you can delete the experience config file to generate a new one

Version 2.1.33
    Renamed "Skills.Acrobatics.Prevent_AFK_Leveling" to "ExploitFix.Acrobatics"
    ExploitFix.Acrobatics when set to false allows gaining XP in Acrobatics freely with no anti-grind measures
    NOTE: The anti-grinding/exploit stuff is fully configurable in update 2.2 coming soon, this hotfix is to hold you over until that update comes out.

Version 2.1.32
    Completely removed Fireworks from mcMMO because they lag
    Added 'General.AprilFoolsEvent' setting to config.yml to turn off April Fools
    NOTE: April Fools event has been in mcMMO for a long time, I did not write it so I didn't know it spawned fireworks like crazy.

Version 2.1.31
    Fixed a bug where certain SubSkills did not properly send unlock or rank up notifications
    Fixed a bug where unlock notifications would send simultaneously for a specific skill (still happens if mmoedit changes all skill levels on a player at once)
    Fixed a bug where mmoedit triggered notifications for skills already gained
    Fixed NPE with grabbing offline player skill ranks through certain API methods (thanks Ineusia)
    Updated German language locale (thanks OverCrave)

Version 2.1.30
    Fixed double drops behaving oddly
    Double_Drop config table has been renamed to Bonus_Drops, this is to jankily auto-update everyones config
    DoubleDrop config tables now must contain all things that can possibly be doubled, such as the Ore block, the ore itself, etc.
    Added the following items to the Bonus_Drops tables for Mining: Coal, Diamond, Emerald, Glowstone_Dust, Iron_Ingot, Lapis_Lazuli, Nether_Quartz, Redstone, Cobblestone
    Added the following items to the Bonus_Drops tables for Herbalism: Beetroot, Carrot, Cocoa_Beans, Melon_Slice, Potatoe
    Added the following items to the Bonus_Drops tables for Woodcutting: Birch_Wood, Spruce_Wood, Jungle_Wood, Dark_Oak_Wood, Oak_Wood, Acacia_Wood

    NOTE: You don't need to update your configs for this one unless you had custom entries in the Double_Drop tables, the renaming of the key will auto-insert default values and give everyone correct defaults
    NOTE: I'm gonna have to blame Bukkit on this one, several API methods I used are actually unfinished and kind of janky. So I hacked something together to make them work.

Version 2.1.29
    Fixed a bug where double drops and triple drops were not activating

Version 2.1.28
    Fixed a bug where Archery could not gain XP

Version 2.1.27
    Fixed an exploit that allowed players to duplicate torches, and rails

Version 2.1.26
    Added new scaling damage buffs to all existing Combat Skills
    Added a new subskill named Stab to Swords
    Fixed a bug where Berserk was not adding 50% damage to attacks
    Changed how Iron Arm damage is calculated (Rank 1 now effectively gives twice the damage bonus it used to, higher ranks have more damage)

    NOTE: Combat skills will be completely configurable in the upcoming 2.2 update, be patient <3

    New Permissions
            - mcmmo.ability.unarmed.unarmedlimitbreak
            - mcmmo.ability.axes.axeslimitbreak
            - mcmmo.ability.archery.archerylimitbreak
            - mcmmo.ability.swords.swordslimitbreak
            - mcmmo.ability.swords.stab

    Notes:
    The new Limit Break subskills are intended to make Prot IV players less tanky and for you to feel more powerful for having high skill level.
    Limit Break has 10 ranks, each rank gives 1 extra RAW damage, this is damage before reductions from armor and enchantments. The net result is you deal about 50% more damage with an endgame skill compared to before.
    With these new changes, most skills can 2 shot normal diamond armor, and it takes about 5 hits to kill someone in Prot IV Diamond Armor.
    I'm not sure everyone will like these changes, the net result is players are a lot easier to kill now, whereas before you could take quite a beating before getting killed.
    I collected several sets of data before making these changes, including damage to player with and without prot 4 diamond armor, damage to those players with and without enchanted weapons, damage with and without leveling your skills, and combinations of the previously mentioned things.

Version 2.1.25
    Shake now has an upper limit of damage (10) - Will be configurable in 2.2 which is coming in the near future
    Rank 1 of Catalysis & Concoctions are now available at level 0 by default (update skillranks.yml or delete it to regen a new one)
    NOTE: The change to shake was to make mcMMO more compatible with plugins that spawn entities with large amounts of HP

Version 2.1.24
    Fixed an exploit where you could clone inventories

Version 2.1.23
    Fixed a bug with Double Drops for Mining (Update your configs instructions below)
    Fixed a 7 year old bug where damage in mcMMO from SkillBs was potentially getting reduced by damage reduction TWICE
    Fixed a bug where killing entities with Rupture would not properly credit you as the killer
    Fixed a bug where Serrated Strikes was applying Rupture twice
    Players will now be ejected from Minecarts if they cast their fishing rod (anti-afk)
    Many nerfs to Rupture, its now much more reasonable and not very useful against Protection IV opponents
    Rupture's strength is now related to your equipped Sword
    Rupture will no longer be applied if the target is blocking, this doesn't prevent existing bleed damage from occurring though.
    Wolf's Rupture has strength equivalent to a Stone Sword
    Only Diamond swords will have bonus rupture damage at Rank 4
    Rupture damage is cut in half for weapons below Diamond in quality, if the weapon is wooden, the damage is cut in half again.
    Swords below Diamond quality will have their tick duration drastically reduced
    Rupture damage is reduced by 25% on players if they are wearing Full Armor (can be any type)
    Note: You'll need to add these entries to your config.yml manually, or wait for the upcoming config update where this will be fixed for you automatically.
    NOTE: Here's what your Double_Drop entries in Config.yml for Mining should look like
        https://paste.gg/p/anonymous/dcd06f1215844311b4f2225f200090d1
    IMPORTANT: Version 2.1.22 which came before this had a similar fix for Herbalism, instructions on how to fix your Herbalism Double Drops can be found here
        https://www.spigotmc.org/resources/official-mcmmo.64348/update?update=269868
    NOTE: Due to the nature of these fixes, Fortune enchants now work with Double/Triple drops

Version 2.1.22
    Less aggressive spam click protection on Fishing
    Updated Hungarian file for missing entries related to Fishing messages (credit: andris155)
    Added all missing flowers to Double Drop tables for Herbalism
    Fixed bug where Repair Mastery was calculating player skill level incorrectly when determining bonuses
    Fixed Double Drop entries for all farming crops for Herbalism
    It no longer requires seeds to replant crops if you are harvesting crops with a hoe (will still consume seeds if you aren't)
    NOTE: You'll need to add these entries to your config.yml manually, or wait for the upcoming config update where this will be fixed for you automatically.
    NOTE: Here's what your Double_Drop entries in Config.yml for Herbalism should look like: https://paste.gg/p/anonymous/8d8db4ac69bd495fa48a7f5190484c5e

Version 2.1.21
    Improved anti-farm/anti-grinding mechanics for Rolling
    When you gain XP from Rolling there is a cooldown period (60~ seconds) for gaining XP again
    This XP cooldown period extends if players are taking fall damage within the cooldown period
        NOTE: Roll already has a few built in measures to prevent XP grinding / abuse, those are still the same.
        NOTE: Rolls still happen in the cooldown period, you just won't gain XP.

Version 2.1.20
Added Hungarian localization (Locale code: hu_HU) (thanks andris155)
Players can now fish in the same spot about 3 times before mcMMO will mark the area as being over-fished (over-fishing is to prevent abuse)
Added a toggle to turn off the fishing exploit detection to experience.yml "ExploitFix.Fishing"
    Note: The new config update is coming soon and will use a different setting, putting this out as a band-aid fix for people that don't like the new fishing exploit prevention stuff
Added a message to warn players that their next fishing attempt will result in over-fishing (Locale: Fishing.LowResources)

Version 2.1.19
    Greatly Improved Fishing AFK/Exploit Detection
    Fixed a bug where Fishing AFK detection did not work on a new exploit
    Certain exploits for Fishing now result in players losing small amounts of hunger and durability
    Players who get detected by Fishing's anti-exploit measures will no longer get vanilla rewards from Minecraft
        **Note: Previously if mcMMO detected you abusing Fishing it just switched you over to vanilla Minecraft fishing rewards, this change is to help server admins who don't want players to get any kind of reward from AFK fishing
    Fishing now drops several hints to players if they are triggering the exploit detection
        **Note: Not all types of exploit detection will warn players, this is just to prevent legitimate fishers from being confused by the aggressive exploit detection.
    Added messages to warn players about fishing in the same spot (Locale: Fishing.Scarcity)
    Added messages to warn players who exploit in order to catch fish unusually fast (Locale: Fishing.Scared)
    Added messages to warn players about casting the fishing rod too often (Locale: Fishing.Exhausting)

Version 2.1.18
    You will need to add Kelp to your experience.yml file for this fix to be fully functional
    Breaking Kelp will now properly count its XP
    Added "Kelp" to experience.yml (Kelp is actually made up of two blocks mixed together)
    It is recommended that Kelp and Kelp_Plant have the same XP value in experience.yml
    mcMMO will now calculate XP for plants that are taller than naturally allowed (Cactus above 3 block height, etc)

Version 2.1.17
    Fixed a logic error that resulted in Drowned giving no XP
    Fixed a bug that resulted in mob spawner entities to not be marked for no xp after being transforming into Drowned

Version 2.1.16
    Breaking Kelp should now count the whole plant for XP
    Spawned Mobs that are not supposed to award XP will no longer reward XP once transformed (ie: drowned)

Version 2.1.15
    Fixed a bug where a max rank of Fuel Efficiency would cause its benefits to be lost

Version 2.1.14
    Added a config option to toggle double drops for Silk Touch pickaxes (advanced.yml "Skills.Mining.DoubleDrops.SilkTouch"
    Mycelium removed from Woodcutting XP tables (because its soil!)
    Kelp added to Herbalism XP tables
    mcMMO now flags blocks moved by piston as not natural to prevent automated XP farms
    Fixed a bug where Fuel Efficiency was way too good
    Fixed a display issue with Fisherman's Diet
    Fuel Efficiency now uses the rank system
    Removed Fuel Efficiency config options in advanced.yml
    Added Tropical Fish, Raw Cod, Raw Salmon to the list of foods that benefit from Fisherman's Diet

Version 2.1.13
    Fixed a bug where Archery's Arrow Retrieval was using the wrong permission node

Version 2.1.12
    Salvage config entries are no longer case sensitive
    Fixed a bug where Fishing was not rewarding vanilla XP orbs

Version 2.1.11
    Fixed a bug where Rupture was using the wrong permission node (new permission node: mcmmo.ability.swords.rupture)

Version 2.1.10
    Fishing command did an oopsie
    Endstone now gives the same XP as Stone (update your experience.yml)

Version 2.1.9
    Fixed a bug where grabbing the version of WG would throw classnotdefined errors

Version 2.1.8
    mcMMO now checks for WG 7 before attempting to use the WG API
    Made some optimizations for our WG integration
    Fixed a bug where Bite chance for Master Angler was displaying too many decimal places
    Fixed a bug where Abilities didn't check for permission nodes before activating
    MaxBonusLevel now has specific entries for Standard and Retro in advanced.yml
    MaxBonusLevel for Critical Strikes changed from 75/750 to 100/1000
    MaxBonusLevel of Dodge changed from 80/800 to 100/1000
    MaxBonusLevel of Rupture changed from 20/200 to 100/1000
    MaxBonusLevel of Counter Attack changed from 60/600 to 100/1000

Version 2.1.7
    Fixed an almost 6 year old bug where Salvage materials did not have a defined material count so they defaulted to 2 (which could lead to shovels giving back more diamonds than normal)
    Added spam detection for Unarmed's bonus damage and disarm
    Corrected an error where master angler for retro only required level 150 instead of 500 (update your skillranks.yml)
    Fixed a bug where Players could see hidden party members in the party member listings
    (API) Added addXpFromBlocks to ExperienceAPI to help make adding XP for a player easier
    (API) Added addXpFromBlocksBySkill to ExperienceAPI to help make adding XP for a player easier
    (API) Added addXpFromBlock to ExperienceAPI to help make adding XP for a player easier
    (API) Added addXpFromBlockBySkill to ExperienceAPI to help make adding XP for a player easier

Version 2.1.6
    Fixed a bug where Arcane Salvage could never fail
    Recolored some lines in the locale related to failure from white to red
    Fixed a bug where Salvage was giving back too many resources
    SubSkillFailure renamed to SubSkillFailed in config.yml
    SubSkillFailed now sends copies to chat by default
    SubSkillFailed no longer sends messages to the action bar by default

Version 2.1.5
    mcMMO no longer ignores cancelled events relating to the player left or right clicking

Version 2.1.4
    Fixed a bug where Alchemy didn't gain XP
    Fixed a bug where Archery gained XP from mob spawned entities
    Fixed a display bug with Roll on /acrobatics command
    Fixed a display bug for bite chance on Fishing
    Fixed a display bug for treasure drop chances on Fishing
    Fixed a display bug for Arcane Forging on Repair
    Fixed a display bug for Super Repair on Repair
    Fixed a display bug for Repair Mastery on Repair
    Fixed a display bug for Second Smelt on Smelting
    Repair Mastery now uses a rank system
    Super Repair now uses a rank system
    Changed the stat for bite chance to be more clear that its additive chance
    Fixed Styling for the /salvage command
    Temporarily disabled Flux Mining
    Removed XP from entities that target endermite to prevent easy exploitation (Credits to TheBentoBox for the tip!) [Can be turned off in experience.yml]
    Fixed a bug where static chance skills like Arcane Salvage were using incorrect calculations for success
    Advanced Salvage now uses a rank system
    Arcane Salvage now goes by your rank to determine the maximum amount of materials salvaged and is no longer percentage based
    Fixed a bug where Iron Arm was checking for Iron Grip to be unlocked instead of itself
    (Plugin Compatibility) mcMMO no longer ignores cancelled block place events (this is to prevent XP gains from placed blocks)
    (Plugin Compatibility) mcMMO now ignores cancelled events relating to the player left or right clicking
    (Locale) Changed the string for "Salvage.Ability.Bonus.1" to fit the new material recovery mechanics of Salvage
    (Config) Added a toggle for the new endermite enderman xp farm fix in experience.yml "ExploitFix.EndermanEndermiteFarms"
    (Config) Cleaned up some leftover 'unlocklevel' settings, this stuff is now handled in skillranks.yml
    (Config) Removed Salvage.MaxPercentage
    (Config) Removed Salvage.MaxPercentageChance
    (Config) Added Salvage.ArcaneSalvage.MaxBonusLevel
    (Config) Added Salvage.ArcaneSalvage.MaxChance

Version 2.1.3
    Temporarily removed the unarmed no-item pickup feature until its fixed

Version 2.1.2
    (Compatibility) mcMMO now deals custom damage type for all damage sources to be more compatible with other plugins (such as anti-cheat)
    (Perks) Fixed a bug where the Lucky perk wasn't adding to success
    (Skills) mcMMO will now listen to cancelled events to remove our temporary enchantments from tools
    (Skills) Fixing a bug where Shake didn't calculate success correctly
    (Skills) Fixed a bug where Arcane Forging didn't calculate success and failure correctly
    (Skills) Fixed a bug where Salvage didn't calculate success and failure correctly
    (Skills) Fixed a bug where Flux Mining didn't calculate success correctly
    (Skills) Fixed a bug where Shake didn't calculate correctly
    (Skills) Fixed a bug where Pummel didn't calculate correctly
    (Skills) Tree Feller now works on Mushroom Stems
    (Skills) Fixed a bug where magic chance would show as null
    (Skills) Fixed a bug where Trap percentages were added to Fishing even though they no longer exist
    (Skills) Magic Hunter now uses a rank system
    (Skills) Fixed a bug where Magic Hunter would work without treasure hunter
    (Skills) As long are you are empty handed mcMMO will no longer put items into your hands
    (Skills) Improved the styling on /smelting
    (Skills) Iron Arm Style can now reach a bonus damage of 10 (up from 8)
    (Skills) Iron Arm Style now uses a rank system
    (Skills) Iron Grip now uses a rank system
    (Skills) Disarm now uses a rank system
    (Skills) Arrow Deflect now uses a rank system
    (Skills) Flux Mining is now a passive effect when you mine ore instead of requiring a special pickaxe
    (Skills) Removed the Flux Mining mcMMO Pickaxe Item
    (Style) Locked skills now are styled differently in the skill command display
    (Experience) Phantoms have been added to the default experience.yml with a value of 4.0 (update your config!)
    (Experience) Default XP value for witch set to 0.1 instead of 0.0
    (Experience) Default XP value for ender dragon set to 1.0 instead of 0.0
    (Style) Added @ symbol styling for hover tooltips to the locale
    (Style) Added the skill names in the skill commands display to the locale so it can now be edited and styled
    (Experience) Renamed Grass to Grass_Block in treasures.yml to allow grass to give items again (update your configs manually or delete to regen)
    (Experience) Wood blocks now give XP and are affected by Tree Feller (6 sided bark blocks)
    (API) Moved XPGainReason from skills to experience package
    (API) Added XpGainSource for tracking sources of XP
    (API) You can now specify XpGainSource when adding xp to players
    (Config) The Extra Stats option for XP bars now overrides the setting for updating XP bars every time XP is gained
    (Config) Added an option for Party XP gains to not update XP bars
    (Config) Added an option for Passive XP gains to not update XP bars (smelting/brewing)
    (Config) Added warnings if mcMMO finds a MaxBonusLevel of 0 for any skill that incorporates RNG
    (Config) Removed config options for Iron Arm
    (Config) Removed the options related to the Flux Mining Item
    (Config) Second Smelt has a max activation chance of 50% instead of 100% (you can update your configs or gen new ones to get this change)

Version 2.1.1
    = Fixed an issue where excavation wasn't using the correct permission node
    = Added protection against AFK fishing
    = Acrobatics now uses much better anti-exploit detection

Version 2.1.0
 + mcMMO now features XP bars! Configurable in experience.yml
 + Locale files now support & codes for colors and formatting!
 + Prevented exploits involving blocks made from entities (snowmen, etc..)
 + Added JSON integration to all Skill Commands
 + Added config setting to enable or disable old mcMMO skill scaling (General.RetroMode) this is on by default for existing installs
 + You can now disable specific skills in coreskills.yml without the need for permissions
 + Added links to mcMMO related websites to various commands
 + Certain elements of mcMMO's UI have been restyled
 + Added the tagline "Overhaul Era" to various locations until 3.0.0 comes out
 + You can now disable mcMMO completely for specific worlds via world_blacklist.txt in /plugins/mcMMO/
 + (WorldGuard) mcMMO now supports worldguard, you can use the flags "mcmmo" and "mcmmo-xp" on regions (they default to on unless otherwise specified)
 ! (Scoreboards) Scoreboards are now disabled by default, I don't like them. You can turn them back on in config.yml
 + (Sounds) Rolling now plays a sound (Graceful Roll has a different sound :) )
 + (Sounds) Activating Super abilities plays a sound (other plays can hear this)
 + (Sounds) Skill Unlock Notifications have sounds
 + (Sounds) Readying a tool for a super ability now plays a sound
 + (Sounds) Bleed DOT now plays a sound
 + (Experience) mcMMO now notifies you when you progress in a skill!
 + (Experience) Coral (blocks) now give Mining XP
 + (Experience) Coral (plants) now give Herbalism XP
 + (Experience) Blue Ice now gives Mining XP
 + (Experience) Dolphins now give combat XP
 + (Experience) Drowned mobs now count towards combat XP
 + (Experience) You can now set guaranteed minimum values for XP gained if diminishing returns are enabled, this value defaults to 5% (experience.yml)
 + (Events) Starting an XP event will now use the title API (toggle this in advanced.yml)
 + (Sound) Volume and Pitch of sounds can now be configured in the new sounds.yml file
 + (MySQL) Added support for SSL for MySQL/MariaDB (On by default)
 ! (Skills) Taming's Gore now uses Rupture Rank 1 for its DoT calculations
 ! (Skills) Sword's Bleed has been renamed to Rupture
 ! (Skills) Sword's Rupture no longer has an internal hard coded limit
 ! (Skills) Sword's Serrated Strikes now uses your Rupture rank to determine the damage/ticks for its bleed effect.
 ! (Skills) Sword's Rupture now ticks four times as fast
 ! (Skills) Sword's Rupture now refreshes bleed duration instead of adding duration when applying bleed to the same target
 ! (Skills) Sword's Rupture will now deal lethal damage
 = (Skills) Fixed a bug where Rupture would apply an incorrect amount of bleed ticks
 ! (Skills) Sword's Rupture now reaches its max proc chance at level 20 (200 in Retro)
 ! (Skills) Sword's Rupture now has a max chance to proc of 33% instead of 70%
 ! (Skills) Sword's Rupture now deals 50% more damage at above Rank 3 and can last much longer! The base damage for Bleed has been increased as well (update your advanced.yml admins)
 ! (Skills) Sword's Rupture no longer triggers invincibility frames when damaging your opponent
 = (Skills) Furnaces now give XP to the last person to modify their inventory instead of the first person to open them
 + (Skills) Ability Lengths now have a default skill cap at which they stop increasing in length, configurable in advanced.yml (endurance perks extend this limit)
 + (Skills) Added a new subskill to some skills 'Understanding The Art' this adds nothing new, but tracks benefits that increase together that seemed unrelated, which was previously a bit obfuscated.
 + (Skills) Tool alerts now are sent to the Action Bar
 + (Skills) Super Ability activation alerts are now sent to the Action Bar
 + (Skills) Certain Skill messages are now sent to the Action Bar
 + (Skills) Added some missing information to skill stats
 + (Config) Skill Rank requirements are now defined in skillranks.yml you cannot add or remove ranks from this file
 + (Config) Added option to use SSL for MySQL in config.yml
 + (Config) Added option to disable the new URL links to config.yml
 + (Config) New config file added coreskills.yml
 + (Config) Added rank settings for the new Woodcutting skill
 + (Config) Added configurable parameters for the new Tree Feller
 + (Config) Added retro toggle for Tree Feller
 + (Config) Added toggle to disable all scoreboards
 + (Chat) Added ability for admins to spy on party chat (off unless toggled on)
 + (Commands) Added new info command /mmoinfo or /mcinfo
 + (Commands) Added toggle command /mcchatspy
 + (API) Added many missing SubSkills to SubSkillType class
 + (Permissions) Added permission node mcmmo.commands.mcchatspy & mcmmo.commands.mcchatspy.others
 + (Permissions) Added permission nodes for Harvest Lumber, Splinter, Nature's Bounty, and Bark Surgeon
 + (Permissions) Added mcmmo.commands.mmoinfo for the new mmoinfo/mcinfo command
 ! (Permissions) Call of the wild now uses mcmmo.ability.taming.callofthewild instead of mcmmo.ability.taming.callofthewild.all
 + (Locale) Added locale strings for new Woodcutting abilities
 + (Locale) Added locale strings for mcchatspy command
 + (Locale) Added locale strings for JSON integration
 + (Locale) Added locale strings for Taming's Pummel SubSkill
 + (Locale) Added locale strings for Unarmed's Block Cracker SubSkill
 - (Locale) Removed localizations with the following codes for being almost empty: id, HR_hr, et_EE, lv, lt, no, pl_PL, pt_PT, tr_TR
 - (Config) Removed SkillShot's IncreaseLevel & IncreasePercentage (replaced by RankDamageMultiplier)
 - (Config) Removed AxeMastery's MaxBonus & MaxBonusLevel (replaced by RankDamageMultiplier)
 = (Events) Fixed bug where XP rate could be a negative number
 = (Experience) Fixed a bug where you could set a players levels into the negative and bad things would happen
 = (Plugin Compatibility) mcMMO now fires new custom events relating to changes it makes to player scoreboards, plugin authors can listen to these events to improve compatibility
 = (Items) Chimaera Wing now tracks cooldowns between sessions for players (no more disconnect abuse)
 = (Skills) Added missing mushroom blocks to experience.yml defaults
 = (Skills) Tridents will no longer be considered unarmed
 = (MySQL) You can now inspect offline players
 = (MySQL) When converting from MySQL to flatfile mcMMO will now properly include all users in the conversion process
 = (Commands) '/mcMMO help' no longer displays the other/special commands category to players lacking permissions
 + (Party) Parties can now have size limits (configurable in config.yml), party size is unlimited by default
 + (Party) You can now turn on Friendly Fire for parties in config.yml
 + (Debug Stick) The Debug stick can now tell you about properties of a block related to Excavation
 ! (Deaths) Fixed the bug where mob names would be replaced by hearts
 ! (Experience) The XP values of fish are now based on their rarity and have been drastically changed
 ! (Experience) Skills now start at level 1 (configurable in advanced.yml)
 ! (Item) Improved some of the messages sent to the player regarding the Chimaera Wing
 ! (Party) Party member list will only include members of the party that you can see (aren't vanished)
 ! (Skills) Excavation Treasure Hunter is renamed to Archaeology
 ! (Skills) Swords no longer require blocking with a shield to trigger counter attacks
 ! (Skills) Stripping wood and right clicking on stripped wood will no longer ready your Axe
 ! (Skills) Some skill level rank requirements have changed
 ! (Skills) Green Thumb now uses a rank system
 ! (Skills) Farmer's Diet & Fisherman's Diet now use a rank system
 ! (Skills) Fixed an edge case bug where Blast Mining wouldn't inform the player that it was on cooldown
 ! (Skills) mcMMO skills will now be on a scale from 1-100 instead of 0-1000 (for existing mcMMO installs this is opt-in and off by default)
 ! (Skills) Skill Super Powers now use a rank system, almost all of them unlocking first at level 10
 ! (Skills) Acrobatics' Roll exploit detection was tweaked to still allow for Roll to trigger even if it rewards no XP
 ! (Skills) Acrobatics' Roll & Gracefull Roll are now considered the same skill (both mechanics are still there)
 ! (Skills) Woodcutting's Double Drop subskill is now named Harvest Lumber
 ! (Skills) Archery's Skill Shot now uses a rank system
 ! (Skills) Swords' Bleed now uses a rank system
 ! (Skills) Swords' Counter Attack now uses a rank system
 ! (Skills) Axe's Axe Mastery now uses a rank system
 ! (Skills) Axe's Impact now uses a rank system
 ! (Skills) Herbalism's Farmer's Diet now uses a rank system
 ! (Skills) Herbalism's Green Thumb now uses a rank system
 ! (Skills) Shake now uses a rank system
 ! (Skills) Flux Mining now uses a rank system
 ! (Skills) Removed traps from fishing
 ! (Skills) Dodge now uses a rank system
 ! (Skills) Arrow Retrieval now uses a rank system
 ! (Skills) Axes' Critical Strikes now uses a rank system
 ! (Skills) Axes' Greater Impact now uses a rank system
 ! (Skills) Taming's Beast Lore now uses a rank system
 ! (Skills) Taming's Gore now uses a rank system
 ! (Skills) Taming's Call of the Wild now uses a rank system
 ! (Skills) Taming's Pummel now uses a rank system
 ! (Kraken) Removed everything involving the kraken
 = (Skills) Shake now sends custom damage types for better nocheat compat
 ! (Config) Unarmed.IronArm in advanced.yml is now Unarmed.IronArmStyle
 ! (Config) Unarmed.Deflect in advanced.yml is now Unarmed.ArrowDeflect
 ! (Config) Swords.Counter in advanced.yml is now Swords.CounterAttack
 ! (Config) Archery.Retrieve in advanced.yml is now Archery.ArrowRetrieval
 ! (Config) Axes.CriticalHit in advanced.yml is now Axes.CriticalStrikes
 ! (Config) Archery's Skill Shot now uses RankDamageMultiplier for its damage bonus calculations
 ! (Config) Axe's Axe mastery now uses RankDamageMultiplier for its damage bonus calculations
 ! (Permissions) Replaced the old Double Drop permission node for woodcutting with a new Harvest Lumber permission node
 ! (Permissions) Fast Food Service permission node renamed to mcmmo.ability.taming.fastfoodservice
 ! (Permissions) Counter Attack permission node renamed to mcmmo.ability.swords.counterattack
 ! (Permissions) Arrow Deflect permission node renamed to mcmmo.ability.unarmed.arrowdeflect
 ! (Permissions) Iron Arm Style permission node renamed to mcmmo.ability.unarmed.ironarmstyle
 ! (Permissions) Remove all mob health bar permissions, this is no longer a per-player setting.
 ! (Commands) Removed the mobhealthbar command, this is no longer a per-player setting.
 ! (Locale) The descriptions of a few skills have changed
 ! (Locale) Removed redundant information from some skill names and descriptions en_US (other locales will need to be updated)
 ! (Locale) SubSkill locale keys are now located at {ParentSkill}.SubSkill.SubSkillName
 ! (Locale) Super Abilities no longer have (ABILITY) in their Skill.Effect strings
 ! (API) mcMMO is now built against Spigot-API instead of Bukkit
 ! (API) Moved a lot of methods from SkillCommand to SkillUtils
 ! (API) SkillType is now PrimarySkillType
 ! (API) SecondarySkill is now SubSkillType
 ! (API) AbilityType is now SuperAbilityType
 ! (API) SecondaryAbilityEvent is now SubSkillEvent
 ! (API) SubSkillType has had many helpful methods added to it
 ! (API) GREEN_THUMB_PLANT & GREEN_THUMB_BLOCK are replaced by GREEN_THUMB
 ! (Code) Refactored some unreadable code relating to SecondaryAbilityType activation in SkillUtils

Version 2.0.0
 = Fixed an interaction between Tree Feller and Stripped Wood
 ! Fireworks no longer fire by default for ability activation/deactivation
 ! Website has been changed and the MOTD string relating to it reflects this
 ! Discord link added to mcMMO command
 ! Updated misc strings relating to mcMMO


Version 1.5.05-SNAPSHOT

Version 1.5.04
 + Added option to config.yml to control mcMMO generated sound volume
 + Added option to config.yml to truncate existing player skill levels that exceed the skill level cap
 + Falling blocks persist mcMMO natural data
 = Woodcutting double drops correctly identify acacia and dark oak logs
 = Skill Reset command now correctly identifies arguments
 = Hylian Treasure config options are now actually used
 = Child skills now use parent skills configured skill caps properly
 = Auto Update config now properly works
 ! Item dropped from blocks now drop from the center
 ! Potions Config updated for 1.9
 ! Flux mining now simulates a block break event for other plugins to act upon
 ! Zombie Pigmen spawned from nether portals are now considered spawner mobs
 ! Flux Pickaxe lore now appends to existing lore as opposed to replacing it
 ! Party chat no longer displays colors when logged in server console
 - Treefeller no longer lowers exp for big trees
 - No longer supports 1.8 :(
 - Removed plugin metrics

Version 1.5.03
 = Fixed bug where absorption hearts could be attacked by allied players
 = Fixed bug where new forms of stone would drop the wrong type when mined with Silk Touch
 = Fixed bug where blocks would not get tracked correctly when using sticky pistons and slime blocks in certain situations
 = Fixed bug where config value for Daze damage was ignored
 = Fixed UUID updater to not lose data on errors
 = Fixed bug where uuid update could result in large amounts of user data being deleted
 = Fixed bug where custom potions were missed in potion stage calculation
 = Fixed piston dupe bugs permanently
 = Fixed bug involving user name changes
 = Fixed old user purge to properly calculate months
 = Fixed bug where Repair would incorrectly check items
 = Fixed bug where apostrophes in locale files would not read correctly
 = Fixed bug where treasure data was limited to 255 instead of Short.MAX_VALUE
 ! Moved more user loading calculations to async loading thread to reduce lag on login

Version 1.5.02
 + Added option to config.yml for Chimaera Wings to stop using bed spawn points
 + Added option to config.yml to let non-tools in hand count as unarmed
 + Added option to experience.yml to control XP gained by killing bred animals
 + Added support for 1.8 mobs and features
 = Fixed bug where no Mining XP was granted when Flux Mining was successful
 = Fixed bug with UUID conversions in Flatfile
 = Fixed a couple Dupe bugs that were introduced recently
 = Fixed bug where MobHealthbarTypes were not saved between server restarts
 ! Changed Flux Mining mechanics. In order to use the ability, you need to infuse a pickaxe with furnace powers first.
 ! Scoreboard tips are only shown a couple of times to the player, instead of once per login session
 ! Changed Archery distance multiplier to be configurable
 ! Archery distance XP bonus cannot exceed indefinitely anymore

Version 1.5.01
 + Added new child skill; Salvage
 + Added UUID support!
 + Added SQL connection pooling and async loading!
 + Added the long awaited Diminished Returns feature
 + Added new feature to Herbalism. Instantly-regrown crops are protected from being broken for 1 second
 + Added option to config.yml to show the /mcstats scoreboard automatically after logging in
 + Added option to config.yml for Alchemy. Skills.Alchemy.Prevent_Hopper_Transfer_Bottles
 + Added option to config.yml for Scoreboards, display "Ability" instead of ability names on the scoreboards
 + Added options to experience.yml for Dirt and Sand variations
 + Added support for `MATERIAL|data` format in treasures.yml
 + Added API to experience events to get XP gain reason
 + Added API to check if an entity is bleeding
 + Added API to ExperienceAPI to get the amount of XP needed for a level
 + Added API class SkillAPI used to get a list of valid skill names
 + Added API events for hardcore features, McMMOPlayerPreDeathPenaltyEvent, McMMOPlayerStatLossEvent and McMMOPlayerVampirismEvent
 + Added API to ExperienceAPI to specify if XP can be shared
 + Added options to tools.yml and armor.yml config files to set a pretty repair material name
 + Added full support for repairables in tools.yml and armor.yml config files
 + Added magical mod config file import command, for Cauldron 1.7+. Check wiki for usage
 + Added particle effects and sounds to "Call of the Wild" (Taming)
 + Added summon length to "Call of the Wild". Summons will now commit suicide after their lifespan expires
 + Added feature which makes tamed wolves attack a target shot by the owner
 = Fixed bug where pistons would mess with the block tracking
 = Fixed bug where the Updater was running on the main thread.
 = Fixed bug when players would use /ptp without being in a party
 = Fixed bug where player didn't have a mmoPlayer object in AsyncPlayerChatEvent
 = Fixed bug where dodge would check the wrong player skill level
 = Fixed bug which causes /party teleport to stop working
 = Fixed bug where SaveTimerTask would produce an IndexOutOfBoundsException
 = Fixed bug where Alchemy would not fire BrewEvents
 = Fixed bug with setting custom names and lore in treasures config
 = Fixed bug which would cause a NullPointerException with getFlowerAndGrassXp()
 = Fixed bug which could cause and SQLException regarding the connection property 'maxReconnects'.
 = Fixed bug where falling blocks were incorrectly tracked
 = Fixed bug where items would get deleted when in Berserk with a full inventory
 = Fixed bug where the console would not correctly show party chat colors
 = Fixed bug where party chat was using non thread safe methods
 = Fixed bug where Blast Mining unlock levels could be to high in certain occasions
 = Fixed bug where Blast Minings ability "Demolition Expert" would not work
 = Fixed bug where Repair_Material_Quantity wasn't read in mod config files
 ! Changed SecondaryAbilityEvent to implement Cancellable and it now gets fired for damage related secondary abilities
 ! Changed the way mcMMO handles bonus damage, updated for the new damage event API
 ! Changed player data saving. Save tasks are now asynchronous
 ! Vanished players no longer get hit by AoE effects
 ! Changed Alchemy config option 'Prevent_Hopper_Transfer' renamed to 'Prevent_Hopper_Transfer_Ingredients'
 ! Changed Alchemy XP distribution. XP is granted based on the stage of the potion.
 ! Changed behavior of the Blast Mining ability "Demolition Expert"; now only decreases damage for the ability user
 ! Updated for new getOnlinePlayers() behavior
 ! Updated for new blocks and entities
 ! Changed McMMOPlayerDeathPenaltyEvent to get fired after hardcore penalty calculations, use McMMOPlayerPreDeathPenaltyEvent for old behavior
 ! Moved Refresh_Chunks setting from hidden.yml to config.yml
 - Removed salvage ability from Repair, salvage has it's own (child) skill now

Version 1.5.00
 + Added Podzol & Red Sand to Excavation
 + Added Hardened Clay, Stained Clay, and Packed Ice to Mining blocks
 + Added Acacia and Dark Oak to Woodcutting blocks
 + Added Salmon, Clownfish, and Pufferfish to Fishing XP
 + Added new flowers and grasses to Herbalism XP
 + Added option to config.yml which allows players to always catch fish, even when a treasure is found
 + Added option to config.yml to override vanilla Minecraft treasures
 ! Fishing XP now depends on the type of fish.
 ! Woodcutting XP in experience.yml and Woodcutting double drops in config.yml now use the tree species names. Oak is now Generic, and Spruce is now Redwood.
 ! Red_Rose was replaced by Poppy, and so the key in experience.yml has been updated accordingly.
 - Removed deprecated permission nodes
 - Removed "Treasure found!" message

Version 1.4.08
 + Added a new skill; Alchemy. Special thanks to EasyMFnE for creating this!
 + Added SecondaryAbilityType enum, and new SecondaryAbilityWeightedActivationCheckEvent, fired when a secondary ability checkes its activation chances
 + Added the possibility to gain experience when using Fishing "Shake"
 + Added config options to disable various sound effects
 + Smelting now works with custom ores - add smelting XP value to blocks.yml, or it will default to 1/10th of normal XP.
 + Added automatic cleanup of backups folder.
 + Added bypass permission for finding Fishing traps
 + Added level threshold settings to hardcore modes. When a players skill level is below this threshold, they will not lose any stats
 + Added party alliances, two parties can now team up. Allies share party chat and cannot harm each other.
 + Added new experience bonus perk 'mcmmo.perks.xp.10percentboost.<skillname>' multiplies incoming XP by 1.1
 + Added new experience bonus perk 'mcmmo.perks.xp.customboost.<skillname>' multiplies incoming XP by the boost amount defined in the experience config
 + Added Ender Dragon, Wither, and Witch to combat experience multipliers - they do not give XP by default
 + Added support for multiple mod config files, naming can be done as either armor.<modname>.yml or <modname>.armor.yml
 + Added config options to configure the items used in "Call of the Wild"
 + Added config option to configure the database command cooldown
 = Fixed bug where healthbars wouldn't display if skills were disabled
 = Fixed bug with "Call of the Wild" entities despawning
 = Fixed bug with updating (very) old user data.
 = Fixed bug with checking maximum durability of mod items.
 = Fixed exploit involving Call of The Wild.
 = Fixed bug where LeafBlower permissions were ignored
 = Fixed bug with toggle commands not properly displaying the success message.
 = Fixed IllegalArgumentException caused by an empty Fishing treasure category
 = Fixed bug with Salvage not reading the config value for the anvil material.
 = Fixed exploit where you could receive smelting XP for improper items
 = Fixed bug where the Unbreaking enchantment was ignored when using "Super Breaker" or "Giga Drill Breaker"
 = Fixed bug which prevented players from gaining Acrobatics XP when the setting 'Prevent_XP_After_Teleport' was set to false
 = Fixed bug where cooldown donor perks were reducing more than expected
 = Fixed bug where disabling hardcore mode for specific skills didn't work
 = Fixed bug which caused the backup cleanup to delete old backups while it should have kept those
 = Fixed bug where party chat broke if the display name contained special characters
 = Fixed bug where `/addlevels all` and `/skillreset all` didn't work
 = Fixed bug which made it possible to gain XP by taming the same horse multiple times, if a player "untamed" that horse
 = Fixed bug where some horses summoned with "Call of the Wild" were unable to jump
 = Fixed bug where the /ptp request expiration time was checked wrongly - preventing players from using the command
 = Fixed bug where Hylian Luck was broken
 = Fixed bug where Snow would never drop treasures
 = Fixed issues with commands giving away vanished players.
 = Fixed bug where the Repair lucky perk would increase the Arcane Forging downgrade chance, instead of decreasing it
 ! Changed party system. Parties now have XP and Levels. Party features such as party teleport and party chat have to be unlocked before they can be used by the party members
 ! Changed appearance of party member list. Gold = party leader, White = online, Gray = offline, Italic = not nearby
 ! Updated localization files
 ! Changed the appearance of /mcmmo commands
 ! Changed AxesCritical to CriticalHit in config file
 ! Changed several secondary ability permissions(deprecated versions still exist)
 ! Changed /ptp config setting, Commands.ptp.Confirm_Required is now Commands.ptp.Accept.Required
 ! Changed config validation for UnlockLevels, they can now also be 0
 ! Changed config validation for Rank_Levels, successive Ranks can now be less than or equal to each other
 ! Changed default amount of XP gained from mining Quartz Ore. From 250 to 100 XP.
 ! Changed Acrobatics config setting, Skills.Acrobatics.Prevent_XP_After_Teleport is now Skills.Acrobatics.XP_After_Teleport_Cooldown
 - Removed /stats alias for /mcstats

Version 1.4.07
 + Added XP boost to Acrobatics when wearing Boots of Feather Falling
 + Added SQL Database can now recover from a dropped connection without losing data. (Thanks Riking!)
 + Added more tiers to Fishing, Repair and Smelting!
 + Added Carrot on a Stick and Flint & Steel to repair.vanilla.yml
 + Added horses to the "Shake" ability
 + Added ability to summon horses via "Call of the Wild" using apples
 + Added XP gain to Taming for horses
 + Added new permission nodes to allow more control over Taming and "Call of the Wild"
 + Added new experience.yml config file! Moved all experience related settings from config.yml to experience.yml
 + Added support for EXPONENTIAL formula curves to experience.yml
 + Added new /mcconvert command to convert players levels and experience from one formula curve to another.
 + Added snow to Excavation blocks
 + Added new experience curve option. Cumulative curve, calculates experience needed for next level using power level.
 + Added extra settings to config.yml for "Call of the Wild" (Taming)
 + Added a 5 second cooldown after teleporting before Acrobatics XP can be earned. Plus a config option to disable
 + Added new API methods to ExperienceAPI to get a players rank on the leaderboards
 + Added new McMMOPlayerDeathPenaltyEvent, fired when a player dies and would lose levels
 + Added new McMMOPlayerLevelChangeEvent, fired when a players level changes
 + Added new McMMOPlayerLevelDownEvent, fired when a player loses levels
 + Added ability to give custom names to items in treasures.yml - use the key "Custom_Name" to set, expects a string.
 + Added ability to give lore to items in treasures.yml - use the key "Lore" to set, expects a list of strings.
 + Added Quartz and Name Tags to the default Excavation treasures
 + Added a warning message if the server is running NoCheatPlus without CompatNoCheatPlus
 + Added cooldown to commands with heavy database access to prevent denial of service
 + Added /mcscoreboard keep, to keep the scoreboard up forever
 + Added Rainbow Mode to scoreboards
 + Added new /mccooldowns command to show all ability cooldowns
 + Commands may now both print text and display a scoreboard
 + Killing a custom entity will automatically add it to the custom entity config file with default values.
 = Fixed bug which allowed players to bypass fishing's exploit prevention
 = Fixed bug where FakeEntityDamageByEntityEvent wasn't being fired
 = Fixed bug with "Skull Splitter" not finding the locale string
 = Fixed issue where locale strings could cause the scoreboard header to be longer than 16 characters.
 = Fixed a bug with "Beast Lore" when the entity had no owner but was tamed.
 = Fixed a bug where AbilityDeactivateEvent would throw an error if the player logged out before his ability ran out.
 = Fixed a bug where LevelUpEvent would be called for an offline player.
 = Fixed a bug where teleport location was never reset if warmup was set to 0 for "Chimaera Wing".
 = Fixed a bug where the "Dodge" DamageModifier wasn't being read from advanced.yml
 = Fixed a bug where squid were not awarding XP.
 = Fixed a bug where Combat XP was granted within 5 seconds for respawned players
 = Fixed a bug where wrong feedback messages were being send when using a command on an offline player
 = Fixed a bug where players were able to gain Herbalism XP in mine carts, even though Prevent_AFK_Leveling was enabled
 = Fixed a bug where players would get hit by fireworks if they leveled up while in a boat
 ! Changed Fishing "Treasure Hunter" and "Magic Hunter" drop percentages
 ! Changed format of mod config files. (blocks.yml, tools.yml, armor.yml and entities.yml) **YOU WILL NEED TO UPDATE YOUR FILE TO THE NEW FORMAT**
 ! Changed format of treasures.yml. **YOU WILL NEED TO UPDATE YOUR FILE TO THE NEW FORMAT**
 ! Changed format of repair.vanilla.yml. **YOU WILL NEED TO UPDATE YOUR FILE TO THE NEW FORMAT**
 ! Changed default XP multiplier for repairing shears
 ! Changed "Shake" drops for Witches. They no longer drop water bottles, since they no longer drop them in Vanilla.
 ! Changed fishing exploit prevention, by default it will no longer send global sounds, effects and messages.
 ! Changed Hardcore modes, they will also subtract experience
 ! Changed various values to double in advanced.yml for the sake of consistency.
 ! Nerfed Fishing "Master Angler" (removed skill level based bonus) and also made the modifiers configurable
 ! Nerfed Archery damage to eliminate constant one-hit kills.
 ! Changed the way Repair hands out XP, also added config options to control Repair XP
 ! Changed Swords "Counter Attack" ability from passive to active. Blocking is required to activate.
 ! Hardcore modes can now be toggled for each skill individually
 ! Vampirism can now be enabled without having Skill Death Penalty enabled
 ! Admin and Party chat prefixes are now customizable
 ! Changed the color of party leader names in Party chat
 ! Improved "Tree Feller" algorithm (Thanks Riking!)
 ! Improved AFK Acrobatics prevention mechanism
 ! Improved profile saving
 ! Improved partial name matcher
 ! Improved update checker
 ! Updated localization files
 ! Party item share category states are now saved when the server shuts down.
 ! When using "Super Breaker" or "Giga Driller" abilities extra tool durability is used (again)
 ! Mob healthbars are automatically disabled when the plugin "HealthBar" is found
 ! Massively improved scoreboard handling
 ! Reworked scoreboard configuration (config.yml) - **you will need to update**
 - The /mmoupdate command has been removed. It is replaced by /mcconvert database
 - Removed Abilities.Tools.Durability_Loss_Enabled, set Abilities.Tools.Durability_Loss to 0 to disable instead.
 - Removed Skills.Fishing.Shake_UnlockLevel from advanced.yml, now using Skills.Fishing.Rank_Levels.Rank_1 instead.
 - Removed SpoutPlugin support

Version 1.4.06
 + Added "Ice Fishing" ability to Fishing
 + Added global scoreboards to track skill rankings (display using /mctop)
 + Added per-player scoreboard displays for the /inspect, /mcrank, /mcstats, and /<skillname> commands
 + Added tab-complete support for all commands
 + Added ability to configure drops from Shake in treasures.yml
 + Added "Master Angler" ability to Fishing.
 + Added health display for mobs during combat.
 + Added new API method to McMMOPlayerLevelUpEvent to set levels gained
 + Added new permission node for /ptp; mcmmo.commands.ptp.send (enabled by default)
 + Added configurable cooldown and warmup times when using /ptp
 + Added a new Party item share category "Misc" which contains a list of configurable items. (By default all tools and armor)
 + Added fishing exploit prevention
 + Added permission node to bypass the fishing exploit prevention
 + Added boosts to Fishing chance depending on conditions
 + Added McMMOAbilityActivateEvent and McMMOAbilityDeactivateEvent
 + Added config option to toggle the size of fireworks
 + Added config option to multiply xp gains from mob spawner mobs
 + Added multiplier to Archery XP based on bow force
 + Added information about /party itemshare and /party expshare to the party help page
 + Added option to use scoreboards for power level display instead of Spout.
 + Added permission node to prevent inspecting hidden players
 + Added SQL to Flatfile database conversion
 + Added ability to use custom database managers and convert to/from them
 = Fixed bug which could cause the server to hang for a minute when checking for updates. (Thanks to Riking)
 = Fixed bug where spawned arrows could throw ArrayIndexOutOfBoundsException
 = Fixed bug where custom Spout titles were overwritten by mcMMO.
 = Fixed bug where Nether Quartz wasn't included in Smelting or item sharing
 = Fixed bug where players were able to join the same party multiple times
 = Fixed displaying partial names when trying to use /ptp
 = Fixed wolves from Call of the Wild only having 8 health
 = Fixed bug where /party chat was not working
 = Fixed bug where experience commands were adding levels to all skills when they shouldn't
 = Fixed mcmmo.commands.ptp.send not being set by default
 = Fixed NPE when trying to tab-complete /mctop
 = Fixed Fishing treasures always having the same enchants
 = Fixed Smelting returning ink sacs instead of Lapis when double-dropping
 = Fixed bug where players could remain in party chat after leaving or being kicked from a party.
 = Fixed bug where non-player arrows couldn't be deflected.
 = Fixed experience being applied even when the permission for a skill was denied
 = Fixed possible item duplication bug with infinity bows
 = Fixed bug with removing players from mySQL database
 = Fixed bug with empty metadata lists and Smelting
 = Fixed bug where Blast Mining would drop wrong items
 = Fixed bug with Blast Mining where the Ability refreshed message was being send too early
 = Fixed bug where the chance of a successful Gracefull Roll was twice as high as displayed
 = Fixed bug where lucky perks where not working
 = Fixed bug with Ice Fishing on a single block of ice
 = Fixed bug with Ice Fishing which allowed players to break ice in protected areas
 = Fixed a small bug with mob healthbars and bosses, such as EnderDragons and Withers
 ! Changed Spout notification tiers to be stored in SpoutConfig instead of AdvancedConfig
 ! Changed Berserk to add items to inventory rather than denying pickup
 ! Changed Call of the Wild, newly summoned pet's will have a custom name. (added permission node to disable this)
 ! Changed Chimaera Wing's recipe result to use the ingredient Material
 ! Changed Repair to ask a confirmation of the player when he tries to repair an enchanted item
 ! Players will no longer pickup items to their hotbar while using Unarmed
 ! ExperienceAPI methods will now throw InvalidSkillException if the skill name passed in is invalid.
 ! Changed default value for recently-hurt cooldown between teleports, this is also fully configurable now
 ! Changed the amount of info messages in the console when enabling/disabling, enable Verbose_Logging to enable them again
 ! Items dropped by players are now being tracked and are not being shared with party members
 ! Optimized tracking of tool & ability cooldowns.
 ! Updated the localization files

Version 1.4.05
 + Added option to allow refreshing of chunks after block-breaking abilities. (Disabled by default)
 + Added fireworks effects when a player levels-up, for every 100 levels (configurable)
 = Fixed bug where /addxp was setting instead of adding experience
 = Fixed bug where /addxp was not processessing level-ups for online players
 = Fixed bug which allowed players to share experience with nearby dead players
 = Fixed bug with ChimaeraWings not taking Wings from a players inventory properly
 = Fixed bug which caused a NPE when trying to use /mctop smelting
 = Fixed Berserk misbehaving when /reload was used
 = Fixed parties misbehaving when /reload was used
 = Fixed Berserk getting "stuck" when /mcrefresh was used
 = Fixed ClassCastException with Taming
 = Fixed huge mushroom blocks not being properly tracked
 = Fixed potion buff option not using the appropriate # of ticks
 = Fixed Chimera Wing spamming console if Metrics was disabled
 = Fixed Chimera Wing displaying warmup message if warmup was set to 0
 = Fixed party & admin chat errors when not aysnc
 ! Updated localization files

Version 1.4.04
 + Added functions to ExperienceAPI for use with offline players
 + Added Nether Quartz Ore to Mining
 + Added Dropper, Hopper, and Trapped Chest to blocks that shouldn't activate abilities
 + Added partial name matching
 = Fixed bug where trying to activate a Chimaera Wing would require one item too much
 = Fixed bug where Treefeller would try to cut too many leaves and reach the threshold when it shouldn't
 = Fixed bug where Mining wasn't awarding double drops
 = Fixed bug where Shake wouldn't damage mobs whose max health was less than 4
 = Fixed bug where the API would fail if the name of a player's current party is requested when the player isn't in one (Thanks @dualspiral!)
 = Fixed bug with retrieving a player's party members
 = Fixed bug which caused a NPE when trying to join the party of a non-existing player or when ptp to a non-existing player
 = Fixed bug which causes a NPE when trying to use /mcrefresh from the console
 = Fixed bug where Carrots and Potatoes weren't awarding Herbalism XP.
 = Fixed bug where some herbalism drops weren't properly shared within parties.
 = Fixed bug where players wouldn't be able to pick up items if they logged our while Berserk was still active.
 ! Changed config node name for the skill experience modifiers from "Experience.Formula.Multiplier.[Skill]" to "Experience.Formula.Modifier.[Skill]"
 ! Updated localization files
 ! mcMMO abilities can no longer be activated while in Creative mode
 ! Expanded ChatAPI to allow toggling of chat states for users
 ! Updated to EMetrics 0.0.4-SNAPSHOT
 - Removed deprecated functions from API classes.
 - Removed functions for getting the PlayerProfile - using API classes is preferred, but if not the McMMOPlayer should be used instead
 - Removed Ender Dragon, Wither, and Witch from granting combat experience and related configuration options

Version 1.4.03
 + Added option to advanced.yml to determine the # of enchant levels used when buffing Super Breaker & Giga Drill Breaker
 + Improved stats display for child skills
 + Added cooldown between using Chimaera Wings
 = Fixed bug with '/party chat (on|off)' and '/partychat (on|off)' not working
 = Fixed bug with Repair not decreasing enchanting levels properly
 = Fixed bug with Smelting not properly tracking furnaces
 = Fixed bug with Blast Mining not dropping blocks correctly
 = Fixed bug with custom blocks not working
 = Fixed bug with Blast Mining increasing TNT damage.
 = Fixed bug where Blast Mining was awarding too much XP
 = Fixed bug where triple drops would award twice the amount of experience in Herbalism and Mining
 = Fixed bug where Green Thumb would consume wheat instead of seeds
 = Fixed bug where Green Terra would consume twice the amount of seed when used on crops
 = Fixed bug where experience would be awarded in Herbalism for some player-placed blocks
 = Fixed bug where players were unable to salvage leather armor
 = Fixed bug with repairing using materials with byte metadata
 = Fixed bug where Fishing was becoming less successful at higher levels
 = Fixed bug with using Salvage on stacked items.
 = Fixed bug where the 'mcmmo.commands.ptp.world.all' was registered twice
 = Fixed bug where Beast Lore wouldn't work on friendly pets
 = Fixed bug where Deflect was calculated based on the attacker, not the defender. (We really did this time!)
 = Fixed bug where Treefeller would not deal durability damage when the axe "splinters into dozens of pieces"
 ! Moved the Salvage unlock level from config.yml to advanced.yml
 ! Changed how Chimaera Wings are acquired, you need to craft them now. (By default, use 5 feathers in a shapeless recipe)
 ! Changed how Chimaera Wings teleport players to the spawnpoint, will now check if the location is safe
 - Removed option to disable Salvage via the config file. This should be handled via permissions instead.
 - Removed the option to use Woodcutting without an axe from the config file.

Version 1.4.02
 + Added API to get the skill and power level caps.
 = Fixed bug where Deflect was calculated based on the attacker, not the defender
 = Fixed bug where some skills weren't registering as unlocked until one level later
 = Fixed bug where the PTP cooldown was being read improperly
 = Fixed bug where /ptp <accept|toggle|acceptall> where broken
 = Fixed ClassCastException relating to counter-attack with Swords
 = Fixed issue with some skill activations not activating enough or activating too much

Version 1.4.01
 = Fixed bug where trying to use /mctop or /xplock with the Smelting child skill caused NPEs
 = Fixed bug where /mctop and /mcrank wouldn't show overall power levels for servers using Flatfile
 = Fixed bug where Smelting would throw consistent errors due to offline players
 = Fixed bug where repairing an mcMMO ability-buffed item with mcMMO repair could take the enchant but leave the lore tag
 = Fixed bug where using '/party chat message...' would result in the first word of the message being printed repeatedly
 = Fixed bug where the wrong flag was being set when taking damage
 = Fixed bug where the PTP cooldown was set improperly
 = Fixed bug where ptp permissions weren't being handled properly
 = Fixed bug where Beast Lore wouldn't work
 = Fixed bug where Chimaera Wing would always teleport to spawn, even when the player had a valid bed spawn location
 = Updated locale files

Version 1.4.00
 + Added new Child Skill - Smelting!
 + Added a version check, admins will get notified when a new version is available!
 + Added new cancellable McMMOPlayerDisarmEvent for Citizens compatibility - fires whenever a player is disarmed.
 + Added config options for Hylian Luck skill
 + Added display values to Unarmed command for Iron Grip
 + Added '/party create <name>' command, use this to create a party
 + Added '/party disband' command, kicks out all members and deletes the party
 + Added '/ptp toggle' command, to disable party teleportation.
 + Added '/ptp accept' and '/ptp acceptall' commands
 + Added an automatic party kick when a party member has been offline for 7 days (default)
 + Added a permission to allow friendly fire in parties, both attacker and defender must have it for friendly fire to occur
 + Added timeout on party teleport requests
 + Added XP bonus for Archery based on distance from shooter to target
 + Added ability to config Hylian Luck drops through treasures.yml
 + Added party XP sharing, when more party members are near the share bonus increases.
 + Added vanilla XP boost for Fishing - includes permissions, config options, etc
 + Added particle effect for bleeding
 + Added methods to check if a player is in party or admin chat to the ChatAPI
 + Added /mcpurge functionality for Flatfile users
 + Added basic support for Mo' Creatures (and other entity mods) - specify mob info in entities.yml
 + Added Shears, Buckets, Fishing Rods, Flint & Steel, Carrot Sticks, and Bows to the list of items that can be Salvaged
 + Added the "wait" music disc to the default fishing treasures
 + Added "Chinese (Taiwan)" localization files (zh_TW)
 + Added '/hardcore' and '/vampirism' commands for toggling these modes on or off.
 + Added Block Cracker to Unarmed's Berserk, turn smooth brick into cracked smooth brick
 + Added config option to disable automatic zip backups.
 + Added particle effects for many abilities.
 + Added '/mcnotify' command to toggle ability notifications on/off
 + Added ability for config files to automatically update with new keys, and prune out old ones
 + Added config option to make .new config files instead over writing over old ones when updating
 + Added "Holy Hound" ability to Taming
 + Added "Shroom Thumb" ability to Herbalism
 + Added child.yml config file to choose parents for child skills
 + Added '/party itemshare <NONE | EQUAL | RANDOM>' command to choose party item share mode
 + Added '/party itemshare <loot | mining | herbalism | woodcutting> <true | false>' command to control items that are shared
 + Added itemweights.yml file to determine which items are more valuable for party itemshare
 = Fixed Green Thumb on wheat not working properly at rank 4
 = Fixed Green Thumb and Green Terra consuming twice the amount of seed needed
 = Fixed Green Terra not also checking Green Thumb permissions
 = Fixed bug where splash potions could raise a player's unarmed level
 = Fixed bug where fired arrows could raise skill levels other than Archery
 = Fixed /ptp telporting the target to the player, rather than the other way around.
 = Fixed Impact reducing the durability of non-armor equipped blocks
 = Fixed Impact reducing improperly the durability of armors (as a consequence it is now more effective)
 = Fixed multiple commands not working properly on offline players
 = Fixed /mmoedit not giving feedback when modifying another players stats
 = Fixed the guide usage string showing up every time /skillname was called
 = Fixed Spout not being able to precache our resources properly, and therefore making our XP bars fail
 = Fixed Spout config files loading / generating when they shouldn't have
 = Fixed mod config files loading / generating when they shouldn't have
 = Fixed bug where Green Terra could activate on crops that weren't fully grown.
 = Fixed several typos relating to locale string display
 = Fixed bug where all skill guide headers appeared as "Skillname Guide Guide"
 = Fixed bug where Impact was applied incorrectly due to an inverted method call
 = Fixed bug where Impact improperly determined the defender's armor
 = Fixed a bug which made it impossible to join other players' parties
 = Fixed ArrayIndexOutOfBoundsException resulting from being unranked in a skill when using FlatFile
 = Fixed Woodcutting accidentally using Mining double drop values.
 = Fixed Hylian Luck not removing the block-placed flag from flowers.
 = Fixed Hylian Luck not checking the block-placed flag on flowers.
 = Fixed Leaf Blower not respecting the unlock level set in advanced.yml
 = Fixed abilities activating with the wrong tool in hand
 = Fixed Experience.Gains.Mobspawners.Enabled not being used correctly (the check was inverted)
 = Fixed bug where Iron Grip was using the attacker's skill values rather than the defender's.
 = Fixed a bug where /party kick would trigger the PartyChangeEvent for the wrong player
 = Fixed /party kick not working on offline players
 = Fixed a bug where party join messages weren't displayed
 = Fixed a bug where a new party leader wasn't appointed, after the previous party leader left
 = Fixed a bug where Disarm and Deflect had wrong values
 = Fixed Magic Hunter (Fishing ability) favoring certain enchants
 ! Changed our custom chat events to be async
 ! Changed some config value key names regarding double drops and XP - make sure you copy any custom values to your new config after updating.
 ! Changed Green Terra blocks to be determined via permissions instead of the config file
 ! Config files are now backed up even when running in SQL mode
 ! Changed /p and /a to use /partychat and /adminchat as the default command name. The use of /p, /pc, /a, and /ac is still supported.
 ! We're now using Bukkit sounds instead of Spout sounds.
 ! It is now possible to use a negative number for Max_Level in treasures.yml to not use a maximum level, changed default file accordingly
 ! A Fishing catch will now always contains a fish even if a treasure is found
 ! Changed how Berserk handles not picking up items to avoid listening to PlayerPickupItemEvent
 ! Moved Hylian Luck into a separate listener since it actually cancels the event and shouldn't just be on MONITOR.
 ! Changed how Tree Feller is handled, it should now put less stress on the CPU
 ! Changed Tree Feller to work on huge mushrooms
 ! Changed Fisherman's Diet and Farmer's Diet to use two seperate config values
 ! Major refactoring - please take note, this WILL break any mcMMO-related plugin not properly hooking into the API.
 ! Changed the way party commands work, use /party ? to check how to use the new commands
 ! Changed McMMOChatEvent to contain the plugin that the event originated from.
 ! Changed Excavation to have individual XP values for each block type, rather than a base XP value.
 ! Changed the way party teleportation works. When using /ptp, the target player needs to confirm the teleport before it takes place. (Configurable)
 ! Changed BeastLore: Now also displays offline player names
 ! Changed backup task to include ALL config files
 ! Deprecated most functions in ExperienceAPI, replaced them with identical versions that use a String for the SkillName rather than the SkillType enum values
 ! Changed Super Breaker & Giga Drill Breaker to be an enchantment-based boost, rather than an instabreak. Option exists in hidden.yml to change this to an potion-based buff.
 ! Changed locales to fall back on English when translated strings cannot be found.
 - Removed Party "master/apprentice" system. Replaced with the new party XP share feature.
 - Removed unused "healthbar" files from the resources
 - Removed config options for disabling commands from the config.yml. This should instead be done through permissions.
 - Removed /mcc command. Replaced with /mcmmo [?|help|commands]
 - Removed options to allow Mining & Excavation without a tool due to the changes to their abilities

Version 1.3.14
 + Added new Hylian Luck skill to Herbalism.
 = Fixed a memory leak involving mob tracking
 - Removed extra durability loss from Leaf Blower

Version 1.3.13
 + Added task & command to prune old and powerless users from the SQL database.
 + Added Craftbukkit 1.4.6 / 1.4.7 compatibility
 + Added new /mcrank command for showing a players leader board ranking for all skills in one place
 + Added a configurable durability cap for ArmorImpact to advanced.yml
 + Added the version number to /mcmmo
 + Added bats, giants, witches, withers, and wither skeletons to the mcMMO combat experience list, and makes their experience drops configurable
 + Added the ability to track mobs spawned by mob spawners or the Taming ability when the chunks they are in unload and reload
 + Added wooden button to the list of items that shouldn't trigger abilities
 + Added a new feature to fishing. Players will have +10% chance of finding enchanted items when fishing while it's raining
 + Added displaying bonus perks on skill commands
 + Added config option to disable gaining Acrobatics XP from dodging lightning
 + Added missing skill guides. They're finally here!
 + Added more localization
 + Added a very secret easter egg
 = Fix issue with Sand/Gravel tracking
 = Fix possible NPE when using the PartyAPI to add a player to a party that doesn't exist.
 = Fix mcremove command for mySQL
 = Fix a java.io.FileNotFoundException when using SQL
 = Impact now works with mobs wearing armor
 = Fixed issue with Tree Feller dropping player-placed blocks
 = Fixed issue with missing default cases from several switch/case statements
 = Fixed issue with Mining using actual skill level rather than max skill level
 = Fixed some issues with static access
 = Fixed ItemStack deprecation issues
 = Fixed Async deprecation issues
 = Fixed a bug with MySQL databases (non-alphanumeric characters preventing MySQL access)
 = Fixed a bug where the /skillreset command was broken
 = Fixed a bug where skill commands displaying .x% instead of 0.x%
 = Fixed a bug Unbreaking enchantments being ignored when using Treefelling and when hit by Armor Impact
 = Fixed a bug where only 1 diamond was needed to fully repair a broken item: Repaired the Repair skill!
 = Fixed a bug where a infinite loop of errors caused by mySQL database could cause the server to crash
 = Fixed a bug where PartyChangeEvent was fired even when a player isn't able to change parties
 = Fixed a bug which caused advanced.yml not to work for Swords
 = Fixed a bug which caused advanced.yml not to respect every MaxChance node
 = Fixed a bug where GreenThumb_StageChange wasn't read from advanced.yml
 = Fixed a bug where Repair would remove enchantments but the glow effect remained
 = Fixed a bug where dropped items did not retain custom NBT data
 = Fixed a bug which caused a potentially infinite recursion in a btree structure
 = Fixed a NPE with custom blocks
 = Fixed a bug with Blast Mining never dropping debris blocks
 = Fixed a bug with Blast Mining incorrectly handling reduced TNT damage
 = Fixed a bug with conflicting fishing enchantments
 = Fixed a bug where triple drops wouldn't happen
 = Fixed a bug which caused fishing to ignore max/min levels in treasures.yml
 = Fixed a bug where treefeller affected player-placed blocks
 = Fixed bug where Skull Splitter would be applied twice.
 ! GJ stopped being a lazy slacker and got stuff done
 ! Nossr50 actually committed something
 ! Changed code that uses SpoutPlugin to make it compatible with the latest version
 ! Reimplemented skill level and power level caps.
 ! Moved Arcane Forging and Fishing setting from config.yml to advanced.yml
 ! Overall SQL query improvements
 ! Reduced number of SQL queries for mcTop command from 11 to 1, speeding it up immensely
 ! Changed FFS Leaderboards to hold information in memory rather than doing IO work (optimizations)
 ! Improved chunk conversion (less errors)
 ! Changed Fishing Treasure Hunter, chance has increased and now actually is level dependent
 ! Indexed most used mySQL columns for faster queries
 - Removed dead code relating to null profiles
 - Removed unused imports
 - Removed ChunkletUnloader and dependents, since they are no longer necessary.

Version 1.3.12
 + Added Craftbukkit 1.4.5 compatibility
 + Added the new 1.3.2 items, xp and double drops for Cocoa beans & Emeralds, EnderChest to the list of blocks that shouldn't trigger abilities
 + Added new items from Minecraft 1.4 to Herbalism (potatoes & carrots)
 + Added new configuration file for advanced users.
 + Added new permission nodes to greenthumb for the 1.4 items
 + Added new mobs from Minecraft 1.4 checks for every ability
 + Added new active ability for Repair: Salvage
 + Added options to 'config.yml' configure shake chance
 + Added the option to negate experience earned for Herbalism while in a minecart to prevent afk leveling
 + Added Green thumb now converts cobble walls to mossy cobble walls
 + Added beacons and anvils to list of blocks that don't trigger abilities
 + Added a configuration option to disable experience gains when in a minecraft for Acrobatics and Herbalism, to prevent AFK leveling
 + Added a new passive ability for Fishing, Fishermans diet. Increases hunger restored from fish
 + Added a feature to display all active perks on login
 ! Changed Fishing, Shake drops changed from guaranteed to based upon fishing level and perks
 ! Changed Woodcutting, the amount of experience earned when using Tree Feller on jungle trees has increased
 ! Changed Herbalism double drop rates for melons and netherwart
 ! Changed filesystem usage, it's reduced a lot. Should help reduce lag on larger servers
 ! Changed database connection handling. Support for aggressive connection timeouts, with exponential backoff for multiple failures
 ! Changed Cobblestone walls are now mossy-able with Greenthumb
 ! Changed the skull drop rates of the shake ability to 3%
 = Fixed a NPE when Citizens perform certain tasks
 = Fixed a NPE with Woodcutting, excessive null chunk before earning Woodcutting experience
 = Fixed a NPE related to skill cooldowns
 = Fixed a NPE when a players profile was null
 = Fixed a NPE involving certain explosions
 = Fixed a dupe bug when for players who were using a 'nuker' client
 = Fixed a dupe bug where pistons were used to dupe ores
 = Fixed a dupe bug with Salvage when players were in Creative mode
 = Fixed a bug where the player was displayed an incorrect cooldown time
 = Fixed a bug where players could earn experience when they were dealing 0 damage
 = Fixed a bug where players could get double drops from mossified Cobblestone
 = Fixed a bug where Herablism magically converted potatoes to carrots
 = Fixed a bug where you couldn't modify the stats of offline players
 = Fixed a bug where treefeller didn't work properly on tree's with side-way logs
 = Fixed a bug where the Arcane forging downgrade chance should've been 0, but actually wasn't
 = Fixed a bug where Fishing would sometimes give items with empty enchantments
 = Fixed a bug where the lucky perk for Fishing was actually an unlucky perk
 - Removed nothing

Version 1.3.11
 ! Changed axes to start with 1 durability damage instead of 5, gain 1 durability damage every 50 levels instead of 30, and only have a 25% chance on hit to damage armor (per armor piece)
 + Added compatibility with bow-wielding NPCs from Citizens/NPC mods
 + Added compatibility for pvp-prevention plugins for Serrated Strikes
 = Fixed bug where mcMMO could throw NPE errors if trees cut down were from a custom mod and had an id of 17
 = Fixed dupe bug where mcMMO would ignore other block-protection plugins for various abilities
 = Fixed NPE with hardcore mode's vampirism

Version 1.3.10
 + Added 1.3.1 compatibility
 + Added permission node for Iron Grip ability (mcmmo.ability.unarmed.irongrip)
 + Added ability for custom blocks to drop a range of items.
 + Added Ability API functions
 + Added 50% & 150% XP boost perks
 + Added "lucky" perk for donors
 = Fixed /inspect not working on offline players
 = Fixed custom blocks, tools and armors not loading properly
 = Fixed duplication bug with sticky pistons
 = Fixed "GenericLabel belonging to mcMMO..." message
 = Fixed menu exit button not working
 = Fixed Repair enchant downgrade not working
 = Fixed NPE caused by Spout players after a /reload
 = Fixed ConcurrentModificationException on world unload
 = Fixed players never being removed from memory (memory leak)
 = Fixed admin chat being seen by everyone
 = Fixed issue with UTFDataFormatException occurring on occasion when trying to load Chunklets
 = Fixed ArrayIndexOutOfBounds error caused when trying to use /xplock after logging in but before gaining XP
 = Fixed custom tools not properly respecting the Ability_Enabled flag.
 = Fixed "lower tool" messages still being displayed even when ability messages are disabled.
 = Fixed custom blocks not dropping the proper item with Super Breaker when Silk Touch is used
 = Fixed custom woodcutting blocks throwing errors.
 = Fixed possible ClassCastException from catching something other than a mob when using the Shake Mob skill
 ! Changed the format by which Chunklets are stored to be much smaller, and much faster to load
 ! Optimized how player placed blocks are tracked

Version 1.3.09
 + Added compatibility with AntiCheat (Which I highly recommend to prevent cheating)
 + Added several permission nodes to give individual users special perks (Double/Triple/Quadruple XP)
 + Added reduced cooldown permission nodes as special perks (1/4, 1/3, 1/2 cooldown)
 + Added increased activation time permissions nodes as special perks (+4, +8, and +12 seconds)
 + Added API for plugins to add custom tools directly via Spout - repair / abilities do not work ATM
 + Added offline party members to the list displayed by /party
 + Added possibility to kick offline members from parties
 = Fixed bug that would cause a NPE for players that had no parties
 = Fixed Vampirism not notifying the correct amount of stolen levels
 = Fixed bug with Acrobatics not saving you from deadly falls
 = Fixed /mcremove being applied only after a reload
 = Fixed Archery PVE disablement not working properly
 = Fixed possible NPE when a projectile is shot by a dispenser or doesn't have any shooter
 = Fixed issue with NoCheatPlus and Serrated Strikes / Skull Splitter (fight.noswing)
 = Fixed tiny memory leak concerning Archery
 = Fixed bug where you could receive Archery XP from Potions
 = Fixed bug where Chunklets for the < 64 y coordinates would not be properly loaded
 = Fixed exploit with block duplication via piston pushing
 = Fixed bug with falling sand/gravel not being tracked
 = Fixed bug with Tree Feller not working with custom axes
 = Fixed bug with locale strings when trying to teleport to a non-existent player
 = Fixed bug with Tree Feller changing durability before checking for axe splintering
 = Fixed bug with Repair Mastery permission due to typo
 = Fixed bug with repairing items that use metadata
 = Fixed bug with Chunklets not being reloaded on /reload
 = Fixed possible NPE when falling with no item in hand
 ! API methods can now only be used in a static way
 ! Arrows shot from a bow having the Infinity enchantment can no longer be retrieved
 ! Arrows that aren't shot by an entity are now able to be dodged (currently only from dispensers)
 ! Changed Spout settings to be in their own config file (spout.yml)
 ! Changed file format for parties (parties.yml), previous files are no longer used
 ! Changed mcMMO to inform on corrupt Chunklets and make new ones

Version 1.3.08
 + Added more notifications about Vampirism and Hardcore mode on player death
 + Added information about Hardcore mode when joining a server running Hardcore mode
 + Added new hidden.yml inside the jar for very sensitive config options for advanced users
 + Added option to disable Chunklets for servers which do not have doubledrops and do not care about xp farming
 + Added new "Max_Seconds" setting in config.yml to limit the max time of abilities
 + Added new repair configs to allow customization of the repair skill
 + Added message to inform users about hardcore mode on login
 = Fixed exploit where you could gain tons of Acrobatics XP from spamming Ender Pearls
 = Fixed normal pistons marking a block as user-placed on retract if it wasn't a sticky piston (thanks turt2live!)
 = Fixed handling of the Unbreaking enchantment so that tools are actually damaged as they should now
 = Fixed hurting pet cats with serrated strikes
 ! Changed Hardcore Vampirism to require the victim to have at least half the skill level of the killer in order for vampirism to proc (this is to avoid exploitation)
 ! Changed Hardcore Vampirism to steal a minimum of 1 skill level from a player no matter the percentage
 ! Changed Hardcore & Vampirism to not be executed if percentages were set to zero or below
 ! Changed Vampirism to actually remove stats from the victim
 ! Changed Vampirism to inform the victim of their stat loss
 ! Changed Mining to allow Silk Touch to work again since the dupe exploit has been fixed.
 ! Changed Metrics to also report if the server uses plugin profiling
 - Removed level and item settings from Repair skill in config.yml

Version 1.3.07
 + Added ability to gain XP from custom blocks. Enable custom blocks in the config file, then enter the data in the blocks.yml file.
 + Added ability to gain XP with custom tools. Enable custom tools in the config file, then enter the data in the tools.yml file.
 + Added ability to repair custom tools. Enable custom tools in the config file, then enter the data in the tools.yml file.
 + Added ability to repair custom armor. Enable custom armor in the config file, then enter the data in the armor.yml file.
 + Added functionality which makes a new folder in all world files "mcmmo_data" to store player placed block information in
 + Added new configurable Hardcore mode functionality to mcMMO
 + Added new configurable Vampirism PVP stat leech for Hardcore mode
 + Added new bypass permission node for the negative penalties of Hardcore mode 'mcmmo.bypass.hardcoremode'
 + Added configurable level curve multiplier which allows for tweaking the steepness of the XP needed to level formula
 + Added a permission node for Archery bonus damage
 + Added a permission node for Greater Impact ability
 + Added permission nodes for Treasure & Magic Hunter for Fishing
 + Added a permission node for Farmer's Diet
 + Added config options for enabling/disabling specific double drops
 + Added automatic zip backup of flatfile database & config files
 + Added config options to enable/disable specific skills for PVP & PVE
 = Fixed bug where Tree Feller was looking at the wrong blocks for determining how much to take down.
 = Fixed bug where Green Terra consumed seeds even on Mossy Stone Brick
 = Fixed bug where the client didn't reflect the Stone Brick to Mossy Stone Brick change
 = Fixed bug where an arrow could bounce off entities on daze proc
 = Fixed bug where a player could gain Acrobatics experience while riding a cart
 = Fixed /party not working properly with 2 arguments
 = Fixed /party not showing properly the member list
 = Fixed /ability not checking the right permission
 = Fixed rare NPE on /party command
 = Fixed Arrow Retrieval dropping only one arrow
 = Fixed /p and /a incompatibilities with bChatManager
 = Fixed Iron Grip working reversely
 = Fixed NPE when user clicked the HUD button with Spout
 = Fixed bug where the permission node for Impact didn't work
 = Fixed some bypass nodes defaulting true for Ops
 = Fixed bug with trying to use Chimera Wing while standing on a half-block
 = Fixed duplication bug when a placed block was mined after a server restart
 = Fixed exploit where shooting yourself with an arrow gave Archery XP
 ! Changed the mcMMO motd to link to the new website rather than the wiki
 ! Changed bleeding ticks damage to 1 from 2
 ! Changed Mining to ignore blocks when the pick is enchanted with Silk Touch
 ! Changed Super Breaker to be non-functional when used with a Silk Touch enchanted pick
 ! Changed MySQL to save player information 50ms apart from each other to reduce the load on the MySQL server
 ! Changed the permission node for Blast Mining detonation to mcmmo.ability.blastmining.detonate (was mcmmo.skills.blastmining) for the sake of consistency
 ! Changed skill commands to only display what you have permissions for
 ! Changed mcMMO to use a new storage system for player placed blocks
 - Removed some unused permission nodes
 - Removed a few config options in favor of permissions nodes (Hunger Bonus, Armor/Tool Repair, Instant Wheat Regrowth)
 - Removed level requirement for repairing string tools from the config file

Version 1.3.06
 + Added Iron Golem XP for aggressive golems
 + Added permissions check to skill functions
 + Added API functions for obtaining offline profiles & profiles via player names
 + Added API functions for admin & party chat
 + Added Iron Grip skill to Unarmed which gives players an chance to keep from being disarmed.
 + Added some new languages to the locale files.
 = Fixed Green Thumb consuming 2 seeds instead of 1
 = Fixed exploit where you could teleport to yourself with PTP to prevent things like fall damage
 = Fixed NPE error with Metrics on startup
 = Fixed bug where Herbalism required double drops permission to give XP
 = Fixed bug where {0} would be displayed in front of your power level in mcstats
 = Fixed mmoupdate not being useable from console
 = Fixed bug with repairing wooden tools
 = Fixed bug with Nether Wart not awarding XP
 = Fixed bug with fishing treasures when treasures list is empty
 = Fixed bug with only getting one level when there was enough XP for multiple levels.
 = Fixed bugs with the way /mctop displayed
 = Fixed issues with custom characters & locale files.
 = Fixed double explosion for Blast Mining
 = Fixed Blast Mining not giving triple drops when it should
 ! Changed Bleeding to now stack to a finite number on Monsters and will wear off eventually
 ! Changed how we handled the config file to prevent any bugs when returning values
 ! Changed locale files to use a new naming scheme. This breaks ALL old locale files. If you want to assist with re-translating anything, go to getlocalization.com/mcMMO
 ! Changed /mcremove to check for users in the MySQL DB before sending queries to remove them
 ! Changed how the tree feller threshold worked for the better
 ! Changed /mcremove to no longer kick players when they are removed from database
 ! Changed /mcremove to work on offline users for FlatFile
 ! Changed PlayerProfile constructor to always take a boolean
 ! Changed getPlayerProfile function to work for online & offline users
 ! Changed Archery's Daze to deal 4 DMG on proc (2 Hearts)
 ! Changed /addlevel command to work for offline users
 ! Changed party & admin chat handling to be nicer to developers
 ! Changed /mcrefresh to work from console
 ! Changed /mcrefresh to work for offline players
 ! Changed UpdateXPBar function to hopefully avoid errors
 ! Changed /party to show offline party members
 ! Changed Blast Mining requirements, now asks for the player to be crouching

Version 1.3.05
 + Added Skill Shot to Archery which increases damage dealt by 10% every 50 skill levels (caps at 200%)
 + Added ExperienceAPI and PartyAPI classes for developer use
 + Added ability to cap overall power level
 + Added showing powerlevel below a persons name if you run Spout (optional)
 = Fixed errors when Spout would disable itself after start-up
 = Fixed XP bar not updating when XP was gained
 = Fixed bug with repairing wooden tools
 = Fixed bug where spawned wolves only had 8 health.
 = Fixed bug where rare Treasures from Excavation were dropping too often
 = Fixed bug where Skull Splitter & Serrated Strikes could be used without permissions.
 = Fixed bug where API functions were set to static
 = Fixed bug where mmoedit threw errors when modifying an offline user
 = Fixed dupe exploit with Blast Mining
 ! Changed Tree Feller to account for ability durability loss but not leaves.
 ! Changed bypass node for Arcane Forging to not default to true for OPs
 - Removed Ignition from Archery
 - Removed McMMOPlayerRepairEvent - was basically a duplicate of McMMOPlayerRepairCheck but couldn't be cancelled.

Version 1.3.04
 + Added McMMOPlayerRepairEvent for API usage - fires after completion of a repair.
 + Added McMMOPlayerRepairCheckEvent for API usage - fires before repair process begins, can be cancelled.
 + Added ability to get skill level from McMMOPlayerExperience events
 + Added McMMOPartyTeleportEvent for API usage - fires before a successful teleportation would occur.
 + Added McMMOPartyChangeEvent for API usage - fires whenever a player joins or leaves a party
 = Fixed Shake ability dropping bonemeal instead of ink for squids.
 = Fixed Green Terra & Super Breaker awarding 4x drops at high levels.
 = Fixed summoned ocelots never changing skins.
 = Fixed bug with Disarm not working
 = Fixed some API functions not being visible
 = Fixed bug where /ptp worked on dead party members
 ! Changed MySQL to reload all player information on reconnection
 ! Changed event package structure - be sure to update these if you're using the API in your plugin

Version 1.3.03
 + Added Ocelots to Taming XP tables
 + Added ability to summon Ocelots with Call of the Wild
 + Added offline user functionality to mmoedit
 + Added bookshelves to list of blocks that don't trigger abilities.
 + Added 'mcmmo.repair.arcanebypass' permission node to bypass Arcane Repair and keep your enchantments
 + Added config option to disable Herbalism's instant wheat replanting
 + Added LOTS of new permissions nodes. *CHECK PLUGIN.YML FOR UPDATES*
 + Added Italian locale file - thanks Luxius96!
 + Added ability to inspect Ocelots with Beast Lore
 + Added console functionality to mctop
 = Fixed Green Terra not awarding Triple Drops
 = Fixed ClassCastException from Taming preventDamage checks
 = Fixed issue with Blast Mining not seeing TNT for detonation due to snow
 = Fixed issue with block interaction returning NPEs
 = Fixed issue where every block broken had a mining check applied
 = Fixed issue where every block broken had a herbalism check applied
 = Fixed issue where blocks weren't being removed from the watchlist
 = Fixed exploit where you could use /ptp to teleport to anyone
 = Fixed bug where Green Terra didn't work on Stone Brick
 = Fixed bug where Tree Feller could be used without permissions
 = Fixed exploit where falling sand & gravel weren't tracked
 = Fixed exploit where Acrobatics could be leveled via Dodge on party members.
 = Fixed exploit where you could gain combat XP on animals summoned by Call of the Wild
 ! Changed mcMMO to save profiles only when the profile is about to be discarded rather than on player quit
 ! Changed MySQL to try to reconnect every 60 seconds rather than infinitely which caused server hangs
 ! Changed mcMMO to be better about saving player information on server shutdown
 ! Changed PTP to prevent teleporting if you've been hurt in the last 30 seconds (configurable)
 ! Changed Chimera Wing failure check to use the maxWorldHeight.
 ! Changed inspect failed message to say inspect rather than whois
 ! Changed Call of the Wild to activate on left-click rather than right-click
 ! Changed Blast Mining to track based on Entity ID vs. Location
 ! Changed mmoedit to save a profile when used (this will make mctop update)
 ! Changed a few Runnable tasks to have their own classes
 ! Changed parties so that a player will leave their existing party if they enter a world where they don't have party permissions.
 ! Changed Call of the Wild to summon animals already tamed.
 ! Changed mob spawner tracking to use new Metadata API
 ! Changed block watch list to use new Metadata API
 ! Changed around a few config options, including the ones for mySQL. *YOU NEED TO REDO YOUR CONFIG FILE*
 - Removed 'true/false' debug message from Inspect command

Version 1.3.02
 + Added in game guides for Mining, Excavation, and Acrobatics. Simply type /skillname ? to access them
 ! Changed Tree Feller to hand out 1/4 of normal XP for each JUNGLE LOG block it fells
 ! Changed Tree Feller to only fell trees if you have enough durability
 ! Changed Tree Feller to cause injury if your axe splinters from a failed Tree Feller attempt
 ! Changed invincibility checks in EntityDamage listeners to accommodate for vanilla MC behaviour
 ! Changed Ignition to add fire ticks rather than replacing them.
 ! Changed Axes critical to have a max critical rate of 37.5% down from 75%
 = Fixed bug where Taming defensive checks got called twice
 = Fixed Shake not working correctly
 = Fixed bug with Axes command displaying wrong Greater Impact bonus damage
 = Fixed bug where Impact didn't apply bonus damage
 = Fixed Impact proccing multiple times in a row
 = Fixed bug where PVE skills didn't level

Version 1.3.01
 = Fixed bug where Tree Feller had no cooldown
 = Fixed bug with activating Skull Splitter after using Tree Feller

Version 1.3.00
 + Added ability to customize drops for Excavation skill (treasures.yml)
 + Added ability to customize drops for Fishing skill (treasures.yml)
 + Added messages to nearby players when your abilities wear off
 + Added jungle trees to Woodcutting XP tables
 + Added player notification for when they stop Bleeding
 + Added configuration option to control mcMMO reporting damage events
 + Added hunger regain bonuses to Herbalism skill
 + Added Blast Mining subskills to Mining
 + Added Fast Food Service subskill to Taming
 + Added size limit to Tree Feller in config as Tree Feller Threshold
 + Added /inspect (works on offline players)
 + Added /addlevels commands
 + Added /mcremove command which lets you remove users from MySQL or FlatFile
 + Added config values for XP multipliers for different hostile mobs
 + Added 'mcmmo.commands.inspect' permission node for the new /inspect command
 + Added Impact & Greater Impact subskills to Axes
 + Re-added mcMMO reporting damage events
 = Fixed bug with updating MySQL tables to include fishing on servers using custom table prefixes
 = Fixed bug where Disarm didn't work at all ever
 = Fixed bug where Swords command showed Bleed Length twice instead of Bleed Chance
 = Fixed bug where Tree Feller wasn't checking for Tree Feller permission
 = Fixed bug where Leaf Blower required Tree Feller permissions rather than Woodcutting permissions
 = Fixed Leaf Blower preventing the use of shears to collect leaves
 = Fixed Green Thumb & Green Terra not consuming or requiring seeds to replant Wheat
 = Fixed Super Breaker & Giga Drill Breaker failing to damage tools
 = Fixed Tree Feller not giving proper XP for different kinds of trees
 = Fixed Skill Abilities conflicting with NoCheat
 = Fixed memory leak with mob spawner tracking
 = Fixed /mcability not respecting permissions
 = Prettied up new config files
 = Various skill function optimizations
 ! Changed how mcMMO calculates distance between two points (optimizations)
 ! Changed how mcMMO handles MySQL connections (optimizations)
 ! Changed the description /mcmmo provides to be more up to date and relevant
 ! Changed mcMMO user information to be stored for 2 minutes after log out to reduce lag on rejoins
 ! Changed Food+ to be named Farmer's Diet in Herbalism
 ! Changed default values of Woodcutting XP tables
 ! Changed 'Pine' to be renamed 'Oak' in Woodcutting XP tables
 ! Changed the name of Unarmed Apprentice/Mastery to Iron Arm Style
 ! Changed Axes to gain bonus damage every 50 skill levels
 ! Changed Unarmed to start with a +3 DMG (1 Heart = 2 DMG) bonus from Iron Arm Style to make leveling it more viable
 ! Changed Unarmed to gain bonus damage every 50 skill levels
 ! Changed Unarmed to gain more bonus damage total than before
 ! Changed Unarmed to have a max disarm chance of 33.3% rather than 25%
 ! Changed Tree Feller to take down entire trees
 ! Changed mob spawn tracking to use Unique Entity ID instead of Entity Object
 ! Changed stats command name to mcstats for better plugin compatibility
 ! Changed god mode to turn off if player enters world where he does not have mcgod permission
 ! Changed Taming to also gain XP from animal taming
 ! Changed Swords Bleeding effect to never kill
 ! Changed Bleeding to never go beyond 10 ticks
 ! Changed to use Bukkit's built-in ignoreCancelledEvents system
 ! Changed chat logging for /p & /a
 ! Changed Tree Feller to use per-use ArrayList
 - Removed /mcstats console functionality
 - Removed /whois command (replaced with /inspect which has similar functionality)
 - Removed Master/Apprentice chat notifications to reduce spam
 - Removed MySpawn system (You can still use Chimaera Wings) due to being outdated and unwanted
 - Removed duplicate settings in config.yml
 - Removed unused settings from config.yml (HP Regen)
 - Removed Nether Brick from Mining XP Tables
 - Removed Stone Brick from Mining XP Tables

Version 1.2.12
 - Fixed issue that caused terrible MySQL performance and negative XP on levelup (Issue #134)
 - Fixed addxp command taking xprate and skill modifiers into account
 - Added anonymous usage statistics (you can opt out in plugins/PluginMetrics/config.yml)
 - Modified onEntityDamage priority to have better compatibility with other plugins (Factions, WorldGuard, etc...)
 - Fixed /mcgod & /mmoedit permissions defaulting to true
 - Fixed Fishing not working or handing out XP
 - Fixed error with Skull Splitter / Serrated Strikes that caused server instability and log spam
 - Fixed config.yml not having values for End Stone & other new mining blocks
 - Fixed Green Thumb/Green Terra not correctly planting wheat (Issue #133)

Version 1.2.11
 - Removed legacy Permission & PEX dependency. (PEX still works fine with mcMMO)
 - Made Smooth Brick to Mossy Brick and Dirt to Grass for green thumb configurable (Issue #120)
 - Added MagmaCube to XP tables
 - Made optimizations to Skull Splitter/Serrated Strikes
 - Made it so players take damage if they try to log out with Serrated Strikes stacked onto them (Issue #131)
 - Changed mcMMO to save data periodically to optimize performance with FlatFile & MySQL (Issue #138)
 - Added a configurable save interval for the new save system
 - Fixed a bug with the odds calculations for Serrated Strikes
 - Fixed several commands not working from console (mmoedit, etc..) (Issue #150)
 - Added a success message when executing xprate from console

Version 1.2.10
 - Fixed issue with receiving Woodcutting XP for all blocks broken (Issue #103)
 - Fixed issue with Spout images & sounds not working (Issue #93)
 - Fixed typo with repairing Leather Armor & Bows
 - Fixed issue with Silk Touch & Double/Triple drops not working properly
 - Fixed conflict with NoCheat plugin & Super Breaker/Giga Drill Breaker/Berserk/Leaf Blower (Issue #104)
 - Fixed counter-attacking non-LivingEntity (Issue #100 & Issue #107)
 - Fixed various bugs with Leaf Blower
 - Added Monitor & ignoreCancelledEvents to onBlockPlace
 - Made Anvil ID configurable

Version 1.2.09
 - Fixed issue with Repair Mastery (Issue #47)
 - Made Arcane Forging fully configurable (Pull Request #52)
 - Made Fishing configurable (Pull Request #60)
 - Changed timer to be a bit more efficient (Issue #19)
 - Changed to fire EntityDamageEvents for all damage done by mcMMO
 - New custom event for developers McMMOPlayerLevelUpEvent
 - New custom event for developers McMMOItemSpawnEvent
 - Changed LoadProperties from the old Configuration to FileConfiguration
 - Removed aliasing from config.yml
 - Fixed mining procs from Super Break & Silk Touch
 - Unused smelt property removed
 - Minor optimizations
 - Fix for setting properly block damage values
 - Initial skill level capping added
 - Initial command alias framework added
 - Fixed abilities not handling Unbreaking items
 - Fix for treefeller glitch
 - Super secret anniversary easter egg!

Version 1.2.08
 - Changed Bukkit events to new event system
 - Changed aliasing to send both the mcmmo command and the command used.
 - Changes in combat exp (Pull Request #49)
 - Repair for bows & leather armor (Pull Request #46)
 - Fixed missing images (Pull Request #45)
 - POM Changes for dependencies (Pull Request #36)
 - Fishing & Repair fixes (Pull Request #31)
 - Fixed CraftOfflinePlayer issue (Issue #212) errors for offline wolf owners
 - Pull in commit from @NuclearW for issue from previous commit

Version 1.2.07
Fixed mctop not working at all (whoops!)
Fixed problem with multithreading in mcMMO causing errors
Fixed bug with Repair where it would remove the enchantments if you could not even repair the item
The command mmoupdate now runs in its own thread to ease the burden on the server

Version 1.2.06
German translation has been updated
Fixed fishing not being applied to MySQL DB when converting from Flat File -> MySQL
Fixed mctop not taking Fishing into account some of the time
Fixed bug where Taming would try to grab the name of offline players
Fixed bug where Fishing would try to add an enchantment level not normally possible
Fixed another bug with mmoedit and Fishing
Added option to only allow tools to ready when you are sneaking, this is off by default
Added Brewing Stand & Enchanters table to the list of blocks that won't cause you to ready your tool on right click

Version 1.2.05
Fixed my fix of not being able to place blocks near/on Anvils
Fixed resources in inventory not correctly updating after Repair

Version 1.2.04
Fixed bug where you could not place blocks near/on the Anvil

Version 1.2.03
skills2 and experience2 will be removed from MySQL DB automagically when this version first runs
Fishing is now stored in skills and experience tables on the MySQL DB as it should have been
Fishing will now save properly for MySQL
Fishing will now work properly with mctop for those using MySQL
Fixed problems with mmoedit and fishing

Version 1.2.02
Added measures to prevent easy xp from hacks that cause a ridiculous amount of clicks per second
Fixed bug where Call Of The Wild used only 1 bone to summon
Reduced Endermen XP from 3x to 2x
The number of bonus fish caught from fishing has been reduced
Fishing XP reduced from 1500 to 800
Fishing XP is now configurable in the config file

Version 1.2.01
Added a setting to turn off abilities completely from config
Added a setting to just turn off ability messages from config
Fixed the bug with sword repair
Fixed mcMMO not working properly with Spout
Added Fishing XP icon to Normal/Retro HUDs for Spout
Added icons to Spout notifications for leveling Fishing
Added Fishing Retro XP bar color customization to config file
The number of bones required to use Call of The Wild is now configurable
Reduced the XP animals would give from 1.5x to 1x
Removed current durability value message from Repairing
Fixed bug where Arcane Forging failed to display messages
Fixed bug where Arcane Forging tries to downgrade level 1 enchants
Fixed bug where Arcane Forging always kept enchantments if you had under 100 Repair skill

Version 1.2.00
Added Fishing Skill
Added Call Of The Wild to Taming
Added Arcane Forging to Repair
Added new mobs to XP tables
Added Master/Apprentice system to the Party system
Animals now give xp to combat skills (those poor sheep ;_;)
Removed unnecessary sorcery permissions from plugin.yml

Version 1.1.17
XP gained in combat is now softcapped by the remaining health of the entity you are damaging, preventing many exploits.
Players in Creative mode no longer gain XP
Compiled against latest Spout & CraftBukkit
Added World PVP check to Ignition, should no longer ignore PVP settings
Enemies should no longer grant XP when hit during their death
Fixed an exploit that led to unlimited ability use
Possibly fixed a bug where the same player would be listed multiple times in mctop
Added author and description to plugin.yml

/mmoedit and /addxp are useable from the console now
Swearword's statistics tracking removed (He stopped the service, so its gone now.. On a positive note, I did find out 1000-1500 servers installed mcMMO a day)

Version 1.1.16
Added Melons to Herbalism xp tables
Endermen added to Combat skill xp tables
Silverfish added to Combat skill xp tables
CaveSpider added to Combat skill xp tables

Version 1.1.15
Smooth Brick added to Green Terra
Green thumb can be used to spread moss to Smooth Brick now
Implemented a ghetto fix for the sword durability bug (real fix sometime soon)
Added Spain Spanish localization (es_es)

Version 1.1.14
[1.8] Removed the Archery fire rate limiter as its no longer necesarry due to changes in game mechanics
[1.8] Removed the bonus damage from Archery (I'll rework this skill soon)
[1.8] Removed the food bonuses to healing Herbalism provided due to the change of eating in game mechanics
[1.8] Swords no longer parry, no need to compete with in game mechanics
[1.8] mcMMO no longer has an HP Regen system, no need to compete with in game mechanics
[SPOUT] mcMMO now transfers files between [MC Server] -> [Client] rather than [Webserver] -> [Client]
[SPOUT] Temporarily disabled the PartyHUD due to some performance issues
[SPOUT/CONFIG] mcMMO now allows for disabling of the party HUD with the node Spout.Party.HUD.Enabled
[BUG] Fixed a few problems with readying abilities for Woodcutting/Axes
[MYSQL] Improvements have been made to the performance of MySQL thanks to krinsdeath
[CONFIG] Spout.Party.HP tree removed, replaced with Spout.Party.HUD
[CONFIG] Added an option for Excavation to require use of a shovel, on by default
[COMPATIBILITY] Changed the listener priority for OnEntityDamage from High to Monitor (Should make mcMMO compatible with Worldguards pvp regions among other things)
[COMPATIBILITY] Made party/admin chat modes more compatible with chat plugins (vChat)
[API] Added addXpOverride for modders, this will ignore skill modifiers
[SPOUT] The option to change the weburl of mcMMO Images/Sounds has been removed, if you want to customize mcMMO images/sounds you can open mcMMO.jar and replace them there
[LOCALE] Portuguese Brazil locale added (Code: pt_br)
[MISC] Added some experimental usage tracking, you can opt out of this in /plugins/stats/config.yml (Once its generated, may require 2 restarts)

Version 1.1.13
Pets are removed from party bars

Version 1.1.12
mcMMO now downloads files when you join the server to provide the best experience
mcMMO now uses a brand new Party HUD by Rycochet (from his mmoParty plugin)
Fixed the xpbar and xpicon settings in config to work properly
Fixed infinite HP exploit with Herbalism
Fixed bug where herbalism would heal out of the players normal health range
Fixed bug where entering ':' into your party name caused stat loss among other things
Fixed issue with block break listener priority

Version 1.1.11
mcMMO now properly cancels its Async taks when disabled
Fixed newly generated configs using 2 instead of 1 for skill multipliers

Version 1.1.10
Added default hud setting to config
Fixed bug where newly generated configs used old xp gain numbers

Version 1.1.09
Fixed mcMMO to run fine without Spout :)

Version 1.1.08
Fixed repair being 10x slower to level than normal

Version 1.1.07
Fixed the default HUD being set to RETRO instead of STANDARD

Version 1.1.06
mcMMO menu implemented! Default is 'M', change this in config
Retro HUD implemented!
Retro XP fill color is completely customizable on a per skill basis
New levelup sound thanks to @Rustydaggers !
With the help of Randomage the XP Formulas have been vastly changed for flexibility
Global modifiers and skill modifiers now support decimals
Global formula modifier dropped from config
GigaDrillBreaker/Berserk doesn't drop clay blocks anymore
Fixed bug where Herbalism didn't heal more for bread/stew when right clicking a block
Fixed bug where Wheat did not use the values form the config file
Fixed bug where Archery gave xp for inflicting self injury
Watch added to clay loot tables and maps remove from clay loot tables

Version 1.1.05
Maps dropped from excavation are created correctly, and represent the area they are found in
Fixed an exploit with clay and excavation
Fixed a NPE with locking xp bars
Fixed the !AdeptDiamond! localization error when repairing diamond with a skill below 50

Version 1.1.04
Removed URL settings for XPBAR/XPICON/HPBAR
Added single URL setting for mcMMO
Changed default host from Dropbox to Rycochet's webserver (with apparently unlimited bandwidth!, thanks Rycochet)
Fixed Repair noise not getting played
Fixed a small memory leak with party health bars

Version 1.1.03
Fixed a few images being hard-coded still rather than configurable

Version 1.1.02
Fixed bug where toggle for xpicon didn't work
Fixed bug where Excavation gave gravel drops to grass
Excavation now uses more enums

Version 1.1.01
Fixed toggles for hpbar/xpbar not working

Version 1.1.0
Brand new XP Bars, Health bars, and Skill Icons designed by BrandonXP
Added /xplock <skillname> to lock the xp bar to a skill
Repairing metal now has a sound effect
Shears added to Repair
MySpawn now works correctly when you are in the nether
MySpawn message when you right click a bed is now squelched
Intervals at which players renegerate hp have doubled in length (making it take 100% longer to regenerate than before)
Rewrote many variables stored per player to be integer instead of long, reducing overall memory usage of mcMMO
Rewrote the Timer mcMMO relies on to instead use the BukkitScheduler for performance
Fixed the party member list of /party
Fixed bug where Swords would counter-attack Projectiles
Removed a debug message when repairing diamond armor
Changed chat to use getDisplayName() instead of getName()
Changed chat priority from lowest to highest
Added Clay to excavation
Added new items to Clay's loot tables
Archery now works with the latest CB

Version 1.0.50
New /xprate command for those with mcmmo.admin permissions!
mcMMO now uses Spout instead of BukkitContrib
BukkitContrib support dropped
XP Formula is now 100+(skill level value * skill modifier * global modifier) thanks to suggestion
Fixed bug where /mmoupdate used the old directory instead of the new one to find the flat file
Fixed bug where Unarmed Mastery damage bonus only did as much as Unarmed Apprentice
Fixed bug where Pumpkins did not give out XP
Coordinates removed from /whois as they didn't really fit
/mcgod and /mmoedit now require permissions to be setup in some shape or form to be used
Lapus renamed to Lapis in config

Version 1.0.49
Updated German locale
Fixed bug where using the party system on a MySQL setup caused errors when writing to non-existent files
Fixed bug where using /accept caused a NPE (hopefully)
Fixed a few missing descriptions for commands

Version 1.0.48
Updated French Translation
Updated German Translation
Updated Polish Translation
Placed Coal Ore and Redstone Ore won't give XP anymore
Fixed unusually high memory usage at startup
Added many features to the party system written by NuclearW

Version 1.0.47
Fixed another BukkitContrib error for servers not running BukkitContrib

Version 1.0.46
Fixed bug preventing Excavation from gaining skill

Version 1.0.45
Corrected /stats showing Repair XP as Level for Repair
Corrected /repair showing Repair XP as Level for Repair
Corrected /whois showing Repair XP as Level for Repair

Version 1.0.44
Fixed my 'fix' of BukkitContrib errors with Tree Feller

Version 1.0.43
Stopped things from being auto-smelt'd

Version 1.0.42
Corrected 2 more errors involving not running BukkitContrib

Version 1.0.41
Fixed errors using Tree Feller if your server wasn't running BukkitContrib (sorry!)
Fixed some more leftover stuff involving the new half-finished mining skill
Fixed excavation's Giga Drill Breaker not working on placed blocks

Version 1.0.40
Fixed errors if your server wasn't running BukkitContrib

Version 1.0.39
mcMMO won't auto-download and auto-run BukkitContrib anymore

Version 1.0.38
Commented code for the half-finished Infernal Pick subskill (Whoops)

Version 1.0.37
The donation message in /mcmmo is now toggle-able
The anvil message now only gets shown the first time you place an anvil (after login)
Reworked /mcmmo (an improvement I would say)
Added /mcmmo text to localization file
Archery fire rate now configurable
Berserk mode stops items from being collected
Taming no longer receives xp from wolves being harmed
Fixed bug where /stats required Tree Feller permission to show Woodcutting skill
Fixed bug where players with mcgod could be harmed by AoE
Fixed bug where modifying a skill also modified the xp to the same amount (when it should be zero)

BukkitContrib Stuff
Added a pop-up when placing an Anvil
Added pop-ups on levelup
Added basic sound effects to various abilities (Berserk, Tree Feller, Super Breaker, Leaf Blower, etc...)

Code Stuff
Added checkXp(SkillType, Player) for plugin devs (use this after modifying XP to check for levels)
Added getPlayerProfile() which returns a PlayerProfile object for plugin devs (You can do almost everything with this object)
100% more enums
Changed how checking skill xp worked to be more efficient

Version 1.0.36
mcMMO now properly supports Bukkit/PEX/Permissions for Permissions
Config.yml will no longer generate Performance Debugging nodes
Registered permission nodes to plugin.yml
Some more changes to Permissions code
Fixed bug where Super Breaker activated where it shouldn't
Fixed bug with enabling/disabling mcgod in config.yml
Fixed bug with Excavation not kicking in until 1 level higher

Version 1.0.35
Added a Toggle for Chimaera Wing in config.yml
Added customization of what item is used for Chimaera Wing in config.yml
Fixed bug with randomly receiving Taming XP
mcmmo.users file moved into /plugins/mcMMO/FlatFileStuff/
Leaderboard files now moved into /plugins/mcMMO/FlatFileStuff/Leaderboards
Locale files now have the prefix locale_ instead of messages_
Locale files are now located inside com/gmail/nossr50/locale/ instead of com/gmail/nossr50/
Updated the code that handles permissions (this may mean 3.1.6 will finally play well!)
Some more source code organization
Fixed warnings for compiler
Removed dependencies on CraftBukkit
Registered commands to OnCommand
Removed performance debugging
Removed some useless settings from the config file

Version 1.0.34
Fixed the PVP setting determining whether you would hurt yourself from AoE Abilities
Added Dutch (nl) language support
Super Breaker now gives the correct XP as determined by config.yml
Sand Stone XP is now configurable and no longer shares the 'stone' node
/mining now shows mining values instead of taming values

Version 1.0.33
Fixed the toggle for the Excavation drop 'Cocoa Beans'
Fixed bug where Unarmed users could disarm without being bare handed
Cocoa Beans now have an XP modifier in config.yml
You can now toggle whether Mobspawners will give XP (in config.yml)
MySQL version now makes requests to the MySQL server less frequently (should help performance)
Fixed bug with Skull Splitter hitting the user

Version 1.0.32
Added "General.Performance.Print_Reports" node to config.yml to help identify causes of performance issues
Fixed bug of swords users hurting themselves with serrated strikes

Version 1.0.31
Fixed bug of trying to cast Animals to non-animals

Version 1.0.30
Mobs that spawn from spawners no longer give XP (for reals this time)

Version 1.0.29
Mobs that spawn from spawners no longer give XP (again)
Fixed bug where Serrated Strikes did not Bleed additional targets
Identified and solved a potential memory leak in Bleed Simulation
Renamed the Object Config to Misc and rewrote parts of it
Rewrote Party/Admin/God toggles
Added Polish language support (pl)

Version 1.0.28
Actually fixed /stats showing excavation values for swords
Made some improvements to how Bleed Simulation was handled for different entity types
Obsidian now does normal durability damage during Super Breaker

Version 1.0.27
Fixed /stats showing excavation values for swords
Hopefully fixed a wide range of NPE errors
Updated German (de) localization

Version 1.0.26
Fixed accidentally making power levels go above 9,000

Version 1.0.25
Compatible with the latest CB
Beast Lore now functions correctly
Wolves are no longer invincible to players
Changed the look of Beast Lore
Skill info pages now show your stat in that skill (if you have permission)
/stats and /whois has been alphabetized and divided into three categories (Gathering/Combat/Misc)
Abilities will not trigger on Trap Doors

Version 1.0.24
Now compatible with latest RB (928)
Taming now receives XP from your wolves harming foes
Taming is now easier to level
Green Thumb now drops seeds when harvesting Wheat

Version 1.0.23
Modified Bleed Simulation to fix performance problems
Rewrote MySpawn to be more efficient when calculating time left
Rewrote Skills to be more efficient when calculating time left

Version 1.0.22
Added 'Name' nodes to commands for renaming them

Version 1.0.21
Fixed Skull Splitter length in /axes displaying incorrectly
Fire rate limiter now correctly uses the value in the config file
Stone XP now correctly uses the value in the config file
Cobble -> Mossy now correctly uses the value in the config file
Removed setmyspawn from config file as it serves no purpose
All commands now have an 'Enabled' node in the config file that when set to false disables the command completely
Fixed color scheme inconsistency for Mining in /whois results

Version 1.0.20
Fixed Array Index Out of Bounds error

Version 1.0.19
Removed a failsafe for the Timer that is no longer necessary (should improve performance)
Fixed /myspawn not working by rewriting it :3
Fixed exploit where players could break a freshly placed mushroom for XP
MySQL User Passwords can now be blank (Although you really should have a password...)
Fixed a few NPE errors

Version 1.0.18
Fixed MySQL default TablePrefix
Fixed Wheat not being configurable

Version 1.0.17
Brand new YAML Configuration file
Ability to configure XP for all gathering skills in config file
German Language added to mcMMO
French Language added to mcMMO
MySpawn will no longer heal players
/<skillname> commands now also check for their localized names for displaying help
Added many more Strings to localization files
Added more safeguards to MySpawn for NPE
Fixed bug where Tree Feller Radius depended on WoodCutting XP rather than Skill Level
Fixed bug where Readying a Hoe returned a missing localization string
Added some safeguards into Bleed Simulation to prevent possible memory leaks
Performance improvements to storing/calling Skill/XP Values
Plugged a potential memory leak with PlayerProfiles not being removed correctly
Disabled the mob spawner camping anti-exploit in favor of performance

Version 1.0.16
Fixed bug where localization file failed to load
Changed en_US to lowercase
mcMMO now requires locale files to be in lowercase
Fixed a few strings missing from the localization file

Version 1.0.15
Removed leftover code that spammed SQL errors

Version 1.0.14
Added many missed strings into localization
Finnish Localization updated for the new strings
Green Thumb should respect Block Protection plugins now
Fixed Number Format Exception when loading a PlayerProfile

Version 1.0.13
Fixed bug/NPE where stats would not load and therefore 'reset' for players
Fixed NPE involving /ptp
Added "enableMOTD" setting to properties file

Version 1.0.12
Fixed another NPE error
Non-Gathering skills should correctly gain XP if PVP is set to false now
Localization will now support language codes that do not have two parts like "fi"
Fixed bug where Wiki MOTD message would not be loaded from localization file

Version 1.0.11
Fixed bug where players could not gain experience in several skills
Removed PVP flag from mcmmo.properties as its not needed anymore
Fixed a few NPE errors
Mushroom XP reduced from 25 to 15
Fixed an exploit where players who just logged in could be farmed for experience because they were invulnerable

Version 1.0.10
Added Localization/String Customization
Mushroom XP reduced from 40 to 25
Removed "clears inventory" warning in /mcc for /myspawn since this no longer happens

Version 1.0.09
Fixed the NPE that occurs when players gain experience (Sorry!)
Fixed bug where /myspawn & /clearmyspawn would work if MySpawn was disabled in the properties file
Changed strings containing "MMO" to read "mcMMO"
Removed a lot of unused or unnecessary variables from the PlayerProfiles in mcMMO, this should lower the memory footprint
Added getXpToLevel() for modders

Version 1.0.08
Added removeXP() for modders
Fixed bug where stone swords only repaired by 33% instead of 50%
Fixed bug where stone/wooden hoes wouldn't repair
Big overhaul to how skill values and xp values were handled in the code
Modifying the players skill levels now sets the corresponding skill xp to zero
Using Serrated Strikes/Skull Splitter on mobs should no longer harm nearby players when PVP is disabled
Switching to another weapon after firing your bow should no longer trigger procs for that weapon when the arrow hits
Slimes/Ghasts now give XP for combat skills
Added "EnableHpRegeneration" property setting
Added "EnableMySpawn" property setting

Version 1.0.07
Added more repair customization by solarcloud7
Leaderboards ignore players with the respective stat at 0
Reconnecting to MySQL will reload player data
Fixed a NPE with MySQL's Leaderboards
Removed "Loop iteration" debug message from mcMMO

Version 1.0.06
MySQL will attempt to reconnect if the connection is closed
Breaking the bottom block of Cactus/Reeds will award the correct experience and double drops
Added support for Minecraft Statistics
Fixed NPE with /myspawn command

Version 1.0.05
PVP interactions now check for permissions before handing out any experience
Many skill abilities now check for permissions correctly
All interactions with Taming now check for permissions
mcMMO now checks for its pvp flag being true before handling pvp interactions

Version 1.0.04
Fixed bug where players would be informed incorrectly when their cooldowns refreshed
Fixed exploit where players could reconnect to reset their cooldowns
Added new "cooldowns" table to MySQL
Berserk now breaks through snow
Lightning no longer gives Taming XP
Shortened /mcc to fit the screen

Version 1.0.03
Bleed will no longer trigger on friendly wolves
Axes criticals will no longer trigger on friendly wolves

Version 1.0.02
Fixed bug where the Timer would start before everything else was ready
Fixed bug where mcrefresh also required mcability permission node
Fixed bug where Unarmed was not checking for disarm procs
Green Thumb now checks for herbalism permissions
Added "enableGreenThumbCobbleToMossy" to config file, this also changes Green Terra
AoE abilities now harm wolves

Version 1.0.01
Removed debug message when wolves are struck
Fixed issue with reloading mcMMO when MySQL was enabled
Fixed a NPE with MySpawn
Fixed a NPE with removing users from PlayerProfile
Unarmed no longer starts with a damage bonus
Unarmed apprentice DMG bonus changed from 3 to 2

Version 1.0
Players can now repair Stone/Wood tools
Fixed duping bug with WG/Block Protection Plugins
Added Leaf Blower to WoodCutting
Different Trees give different WoodCutting XP
Water changing Gravel to Clay removed
Code Organized/Optimized further
MySQL Support
Taming Skill
Leaderboards
Players won't hand out XP if they died within the last 5 seconds

Version 0.9.29
Fixes critical bug involving water turning anything into clay

Version 0.9.28
Green thumb can now spread grass to dirt using seeds
Adding XP will check for level ups again
Acrobatics won't hand out XP on death anymore
Acrobatics will check plugins for the event being cancelled before handing out XP

Version 0.9.27
Fixed Herbalism not properly receiving Triple Drops from Green Terra
Fixed Herbalism not handing out any XP outside of Green Terra
Fixed Herbalism asking for seeds on things that did not require it

Version 0.9.26
Fixed Green Terra going off without readiness
Fixed Hoe trying to ready when tilling Grass

Version 0.9.25
Fixed issue with anti-exploits and Herbalism
MySpawn works like a hearthstone now, no inv pentality, 1hr cooldown
Added Green Terra Ability to Herbalism
Added Green Thumb ability to Herbalism
Fixed Repair not working for Iron Tools
Fixed bug where Axes Ability checked for Unarmed Ability Permission
Added Cocoa Beans to Excavation XP/Loot Tables, Found in Grass/Dirt
Using Super Breaker on Obsidian significantly damages it compared to other materials
Added Obsidian to Mining XP Table/Super Breaker
Added Pumpkins/Reeds/Cactus to Herbalism XP Tables/Double Drops
Corrected "mcMMMO" to "mcMMO" in MOTD

Version 0.9.24
PLAYER_BED_ENTER removed due to its unusual issues
Added info about the Wiki to the motd
/mcrefresh will reset if you were recently hurt (Chimaera Wing/HP Regen)
Fixed Armor Repair not adding XP
Boosted Repair XP of Armor to match Tools
Repairing Armor won't trigger Super Repair twice anymore
Setting your MySpawn now just requires right clicking a bed (still requires the setmyspawn permission node)

Version 0.9.23
Players will now announce ability usage within a short distance to nearby players
Chimaera Wing now takes the world into account
Acrobatics won't give XP on death, and will fail if you would've died after the damage reduction
Added yet another check to see if a Player is not in the Users system for NPC mod compatibility


Version 0.9.22
Fixed bug where chimaera wing was unusable after being hurt even after the cooldown

Version 0.9.21
/mcrefresh fixed to work properly with the new ability monitoring system
Ability lengths are now based on your skill level directly rather than a tiered system
Chimaera Wings won't trigger on things they shouldn't (Doors, Chests, ETC)
Chimaera Wings will properly tell you how long you have to wait to use it if you've been recently hurt

Version 0.9.20
Fixed Tree Feller not checking if their cooldown was refreshed and always activating
/stats and /whois will now show the powerlevel based on permissions
Shovels will no longer say you've lowered your axe
/myspawn will no longer say your inventory has been cleared if the server settings disable this feature


Version 0.9.19
Fixed Anti-Exploit XP stuff not working

Version 0.9.18
Added failsafe to prevent abilities from going on forever, abilities will check if they should've expired when being used in case the Timer fails
Archery Spam has been nerf'd, you can only fire once per second now (Toggle-able in config file)
Fixed bug when just having the Admin Chat permission wouldn't allow you to see Admin Chat
Fixed bug where Axes ability could be used without permission
Abilities are monitored with Timestamps rather than a Timer monitored tick rate
When players were last hurt is now monitored with Timestamps rather than a Timer monitored tick rate
Made Anti XP-Exploits more Robust
Repair XP is now based on durability restored
Acrobatics rolling will now reduce damage if you go over the damage threshold
Acrobatics rolling damage threshold lowered to 10 from 20
Added Graceful Roll to Acrobatics, hold Shift when falling to do a Graceful Roll
mcMMO now checks for the blockBreak and EntityDamage events being canceled before proceeding
Dodge notification shortened
Dodge won't negate damage completely anymore
Added 3 more functions for plugin authors to call, getPartyName(Player player), inParty(Player player), and getParties()

Version 0.9.17
Players now set their MySpawn by entering a bed, it requires the setmyspawn permission node
/setmyspawn has been removed
Compatible with CB 670
Fixed errors related to Repair
Abilities will no longer trigger from Bed interactions
/unarmed will now tell the player when they will receive unarmed master (if they have apprentice)

Version 0.9.16
Logs placed by the player won't grant XP/Double Drops anymore
Added more functions plugin authors can call
Acrobatics roll has a damage threshold of 20, going above this means a failed Roll


Version 0.9.15
Acrobatics will now behave properly
AoE Abilities ignore wolves (temp fix)
Added "all" parameter to /mmoedit & /addxp
After giving XP to a player it will now check for level ups in skills

Version 0.9.14
mcMMO checks for abilities being active before sending the fake block break event

Version 0.9.13
Fixed excavation ignoring the xpGainMultiplier
Now compatible with CB 600+
Fixed bug where Dodge acted maxed out no matter your skill level

Version 0.9.12
mcMMO now fakes a block break event for abilities to maximize plugin compatibility
/herbalism will return the correct values now
New /addxp command

Version 0.9.11
PVE Combat Skills experience is now based on damage dealt
The Timer will no longer break from Bleed Simulation
Tree feller no longer "damages" saplings
Bleed+ (Serrated Strikes) lasts 5 ticks down from 12
Bleed/Bleed+ now do 2 damage instead of 1
Power Level is now based on permissions
Counter Attack added to swords
Parry is now based directly on Swords skill level
Parry maximum proc chance raised to 30% from 20%
Serrated Strikes now properly applies Bleed+ to targets
Players who parry can no longer be disarmed
Acrobatics now has a Dodge passive skill reducing damage
Repair skill now effects how much durability is restored
Super repair now doubles the repair amount on proc
Unarmed now starts with a bonus to damage to encourage use
Unarmed now has two steps to damage scaling, Appentice, and Mastery
Unarmed disarm now caps at 25% for 1000 skill
Fixed problem where Archery skill procs would ignore other plugins
Ignition changed to 25% chance
Ignition length will be based on archery skill level
/myspawn now has a warning about the inventory loss penalty in /mcc
mcMMO Timer now runs in 1 second intervals rather than 2

Version 0.9.10
Party invites now show who they are from
Mushrooms added to Dirt/Grass excavation loot tables, drops with 500+ skill
mcMMO configuration files property setting names have been changed for readability
Fixed bug where Gold and Iron wouldn't drop anything during Super Breaker
Added /mcability info to /mcc
Potentially fixed NPE error when checking players for being in same party for PVP XP
Removed sand specific diamond drop from sand excavation loot table, Diamonds can still drop globally for sand
Added a global XP gain multiplier, increase it to increase XP gained
Reduced PVE XP for Unarmed, now identical to Axes/Swords
Changed Chat priority in mcMMO to be higher, this should help plugin conflicts
Mushroom XP raised to 40 from 10
Flower XP raised to 10 from 3

Version 0.9.9
Fixed problem where entities never got removed from the arrow retrieval list of entities

Version 0.9.8
EntityLiving shouldn't be cast to entities that are not an instance of EntityLiving
Added a null check in the timer for players being null before proceeding

Version 0.9.7
Procs/XP Gain will no longer happen when the Entity is immune to damage (Thanks EdwardHand!)
Axes critical damage versus players reduced to 150% damage from 200% damage
Fixed bug where Daze might not proc
Changed archery Daze to follow smooth transition
Added archery Daze chance info to /archery
Cooldown lengths are now customizable, they are in seconds and multiplied by 2 by mcMMO

Version 0.9.6
Timer checks for player being null before adding them to the mcUsers system
Cooldowns will now show how much time is remaining when trying to use their respective abilities
SkullSpliiter will now correctly inform the player when they are too tired to use it
Acrobatics will no longer give XP if the event was cancelled by another plugin
Version 0.9.5
Super Breaker now gives a chance for Triple Drops based on mining skill
Ability durability loss down from 15 to 2
Ability durability loss is now toggle-able
Ability durability loss can be adjusted in the configuration file
Mining Picks are no longer lowered after activating Super Breaker

Version 0.9.4
Flowers won't drop wheat anymore
Signs won't trigger ability readiness anymore
Version 0.9.3
Bug stopping abilities from never wearing of may have been fixed
Changed color of "X Ability has worn off" to RED from GRAY
Super Breaker, Giga Drill Breaker, and Tree Feller now damage the tool significantly during use
Netherrack and Glowstone now give Mining XP
Netherrack and Glowstone are now effected by Super Breaker
Abilities will no longer be readied when you right click signs or beds
Chimaera Wings won't activate on blocks you can interact with and signs
Abilities now adjust their effects depending on tool quality
Superbreaker won't break things that tool couldn't normally break
Giga Drill Breaker will only give triple xp and triple drops for diamond tools, with a reduced effect for lesser tools
Skull Splitter now has a limit of opponents nearby it will strike based on your tool quality
Serrated Strikes now has a limit of opponents nearby it will strike based on your tool quality
Modified /mcmmo description to be a little bit more relevant.

Version 0.9.2
Changed priority of some of the mcMMO listeners
Now when certain abilities are activated it shouldn't say "You lower your x"

Version 0.9.1
Fixed "Unknown console command" errors with CB 556
Added /mcability command to toggle being able to trigger abilities with right click
Added some more nullchecks for people reporting NPE errors
Compatibility with NPC mods improved (Mainly for archery!)
Other plugins can now call inSameParty() from mcMMO to increase compatibility

Version 0.9
--NEW CONTENT--
Woodcutting now has the "Tree Feller" Ability
Unarmed now has the "Berserk" Ability
Swords now has the "Serrated Strikes" Ability
Mining now has the "Super Breaker" Ability
Axes now has the "Skull Splitter" Ability
Excavation now has the "Giga Drill Breaker" Ability
Added /mcrefresh <playername> - tool for refreshing cooldowns
Unarmed now has the "Deflect Arrows" passive skill
Chimaera Wing Item Added

--CHANGES--
HP Regen & Bleed are back
Woodcutting will drop the appropriate log on double drop procs
Herbalism now applies double drops to herbs
/<skillname> now shows much more information to the player regarding their stats
Axes skill Critical Strikes are now based directly on your skill level
Swords skill Bleed chance is now based directly on your skill level
Unarmed disarm chance is now based directly on your skill level
Acrobatics now gives XP when you roll

--BUGFIXES--
Memory Leak Fixed
Axes not doing critical strikes
Gold Armor repair
Capped skills now have the correct proc chance
/mmoedit is no longer case sensitive
More NPE errors fixed
Many bugs I forgot to write down

--PLUGIN COMPATABILITY FIXES--
If combat interactions are cancelled by other plugins mcMMO should ignore the event
If block damage interactions are cancelled by other plugins mcMMO should ignore the event

Version 0.8.22
	Fixed bug where Axes did less damage than normal
	Acrobatic rolls now give XP
	Acrobatics XP increased for non-rolls
Version 0.8.21
	Fixed bug where axe criticals would dupe items
Version 0.8.20
	99.99% sure I fixed anvils that suddenly stop working
Version 0.8.19
	Fixed being able to excavate placed blocks
	Added toggle option to mining requiring a pickaxe
	Added toggle option to woodcutting requiring an axe
	PVP interactions now reward XP based on the damage caused (this is effected by skills)
	PVP XP gain can be disabled in the configuration file
	PVP XP has a modifier, increase the modifier for higher XP rewards from PVP combat
Version 0.8.18
	Fixed sandstone not being watched for exploitation
Version 0.8.17
	mcmmo.users moved to plugins/mcMMO/
	Snowballs and Eggs will no longer trigger Ignition
	Loot tables for excavation adjusted
	Mining benefits now require the player to be holding a mining pick
	Woodcutting benefits now require the player to be holding an axe
Version 0.8.16
	Moved configuration file to /plugins/mcMMO
	Arrows now have a chance to Ignite enemiesw
	Fixed arrows not being retrievable from corpses
	Added info about ignition to /archery
Version 0.8.14
	Mining, Woodcutting, Herbalism, and Acrobatics proc rates now are based on your skill level directly rather than tiers you unlock via skill levels
	Archery's ability to retrieve arrows from corpses now is based on your skill level directly rather than tiers you unlock via skill levels
	Mining, Woodcutting, Herbalism, Archery, and Acrobatics now show their proc % relative to your skill if you type /<skillname>
	You can now adjust what level is required to repair diamond in the configuration file
	Changed mining XP rates to be a tad higher for some things
	You can now get XP from sandstone
	XP rates increased for gathering glowstone with excavation
	XP rates increased a bit for excavation
	Skill info is now a bit more detailed for certain skills
	Added info about arrow retrieval to /archery
Version 0.8.13
	Enemies no longer look like they have frozen when they die
	Item duping fix
Version 0.8.11
	Performance improvements
	Memory leak fixed
	NPE error with MySpawn really fixed
Version 0.8.9
	Fixed NPE for My Spawn
	Fixed NPE for onBlockDamage
	Bleed proc now correctly checks for Swords permissions
Version 0.8.8
	Gold can now be repaired
	Tweaked Mining XP gains
	Reorganized code
	Added /mcgod godmode command
	Fixed the pvp toggle in the settings file
Version 0.8.7
	Removed packet-sending stuff wasn't working anyways
	Fixed another NPE with the TimerTask
	Skills now only show up in /stats if you have permissions for them
Version 0.8.6
	Added a null check in bleed simulation to prevent a NPE
Version 0.8.5
	Players are now added to files when they connect (to fix a NPE)
	onPlayerCommand stuff moved into onPlayerCommandPreprocess
Version 0.8.4
	Fixed another nullpointer error for TimerTask
	Fixed bug making regeneration take twice as long to kick in after combat
Version 0.8.3
	Modified the timer intervals (from 1 second to 2)
	All skills now have an individual modifier (Set by default to 2)
	There is now a global XP modifier (Set by default to 1)
	Herbalism now correctly follows its skill curve
	Unarmed no longer gives experience for harming other players
	Players can no longer exploit mob spawners for experience
Version 0.8.2
	Fixed Concurrent Modification Exception
	Fixed some incorrect skill descriptions
	First tier of HP Regeneration is now available from the start
	Fixed bleed proc rate for very high skill levels
	Changed regeneration permissions to 'mcmmo.regeneration'
Version 0.8
	Archery skill now lets players recover arrows from downed foes
	Health regenerates based on power level
	Added toggle to myspawn clearing player inventory in settings file
	Swords now have a bleed effect
	Rewrote Skill descriptions to be more informative/better
Version 0.7.9
	XP Curve now follows a new formula
	Acrobatics XP gains changed
	Compiled against permissions 2.1
Version 0.7.8
	Massive tweaks to XP gain for Archery, Swords, Axes, Unarmed
Version 0.7.7
	Minor tweak to how players are added to the flat file
	Fixed some nullpointer exceptions when players die
Version 0.7.6
	Fixed being able to repair diamond armor with below 50 skill
	Myspawn now supports multiple worlds, clearing myspawn will set it to the first world created by the server
Version 0.7.5
	Removed random checks for herbalism XP
	Herbalism is now called properly (This should fix gaining no xp or double drops)
Version 0.7.4
	Work around for a bukkit bug that broke my onBlockDamage event
	Added /clearmyspawn
Version 0.7.3
	Fixed to work with build 424 of CB
	Lowered the XP of gold due to it not being that rare anymore
Version 0.7.2
	Fixed security flaw where players could access /mmoedit if the server was not running permissions
	Reduced XP gain of woodcutting a bit
Version 0.7
	Completely rewrote the XP system
	Added an XP skillrate modifier to the settings file

Version 0.6.2
	Axes now do critical strikes against farm animals
	Removed the "Stupidly Long Constructor"
	Now compatible with the latest CB builds
Version 0.6.1
	Customizable command names
	Axes can now be modified with /mmoedit
	Party members are now correctly informed when you leave the party
	Fixed incorrect commands in /mcc
Version 0.5.17

	Changed namespaces to fit bukkits new standard
	Adjusted excavation proc rates
	Modified excavation loot tables
	Added Party Invite System

Version 0.5.16

	Fixed unarmed not checking for permissions when hitting players

Version 0.5.15
	Fixed stone swords not being recognized as swords
	Fixed /a not working if you were an op but did not have permissions

Version 0.5.14
	Added permissions for skills

Version 0.5.13

	Removed skillgain from succesful parries
	Repair now refreshed the inventory

Version 0.5.12

	Fixed being able to hurt party members with the bow and arrow

Version 0.5.11

	Added /mmoedit command
	Fixed bug preventing player versus player damage
	Fixed bug preventing damage from scaling with unarmed & bows
	Fixed disarm proc making the opponent dupe his/her items
	Added mcmmo.tools.mmoedit permission
	Added mcmmo.commands.setmyspawn permission
	Added totalskill to /stats
	Changed the look of /stats

Version 0.5.10

    Fixed trying to set health to an invalid value

Version 0.5.9

    Fixed duping inventories on death

Version 0.5.8

    Fixed bug where players inventories would dupe during combat

Version 0.5.7

    Fixed monsters instant killing players
    Misc fixes
Version 0.5.4

    Changed herbalism skill gain from wheat to be WAAAAY slower

Version 0.5.3

    Players will now correctly drop their inventories when killed by a monster

Version 0.5.2

    Fixed MAJOR bug preventing swords skill from gaining through combat

Version 0.5

    Archery Added
    Swords Added
    Acrobatics Added
    Logging for Party/Admin chat added
    Fixed whois to show correct values for Excavation
    Made death messages much much more specific

Version 0.4.4

    Fixed being able to repair full durability iron tools
    Fixed herbalism benefits not behaving properly
    Fixed removing 1 diamond from every stack of diamond when repairing diamond

Version 0.4.2

    Removed myspawn from the motd

Version 0.4.1

    Fixed /mcc showing incorrect command for herbalism
    Changed unarmed skillrate to be much slower than before
    Modified a few skill descriptions
    Added permission for /whois
    Players can now use admin chat without being op as long as they have the correct permission (requires Permissions)

Version 0.4

    Permissions support
    Removed OPs having different names than normal players
    Removed /setspawn & /spawn
    Slowed down excavation skill rate
    Fixed excavation coal drop being too rare

Version 0.3.4

    Creepers now give double xp for unarmed
    Iron armor can now be repaired!
    Fixed bug stopping items from being repaired

Version 0.3.3

    Yet another herbalism skill gain tweak

Version 0.3.2

    Changed excavation loot tables to be more rewarding
    Changed sand to give normal excavation xp instead of double xp
    Fixed herbalism skill exploit
    Mobs killed with unarmed now drop loot properly
    Unarmed xp rate depends on mob (zombies lowest fyi)
    Huge player crashing bug fix on disarm!

Version 0.3.1

    Fixed excavation not saving properly
    Fixed repair using excavation values

Version 0.3

    Unarmed skill
    Herbalism skill
    Excavation skill
    Many bugfixes (thanks for reporting them!)
    /<skillname> - Detailed information about skills in game

Version 0.2.1

    Misc bugfixes

Version 0.2

    Repair ability added
    Repair skill added
    Iron Armor repair temporarily disabled
    Anvils (Iron Block) added
    /mcmmo & /mcc added
    Misc changes to existing commands
    Misc bug fixes

Version 0.1

    Releasing my awesome plugin

